Structure info
  Path1.s    ; CodeArchiv support up to 3 sub-directories
  Path2.s
  Path3.s
  File.s     ; File name of the codearchive code


; **** must be translated for each of the 3 path parts !!!!
; its maybe to much memory consumption!!!!
; so probably create this instantly like in CArchiv generator...
;   DirGerman.s   ; german description of directory name
;   DirFrench.s   ; french description of directory name
; 
  German.s   ; german description
  English.s  ; english description
  French.s   ; french description
  
  
  New.l      ; marked with 1, when the file appears first time in the list, 0 when it was already available
  Updated.l  ; marked with 1, when the file was updated since first release 

  Forum.s
  ForumType.l      ; 0 = english forum, 1 = german forum, 2 = french forum, 3 = other
  ForumURL.s
  Author.s
  Year.l
  Month.l
  Day.l
  OS.l             ; 0 = no information, 1 = Windows, 2 = Linux, 4 = MacOS, 8 = AmigaOS. All flags could also be used in summary (e.g. 3 means Windows + Linux)
  Demo.l           ; 0 = no information, 1 = Yes, 2 = No, 3 = No (but not sure, because only identifier was a '_(' found
EndStructure

Global Dim filesinfo.info(files)



; Procedure TranslateDir(ID,path$)
;   ResetList(trdirs()) : quit = #false
;   Repeat 
;     dummy = NextElement(trdirs())
;     If dummy > 0
;       b$ = trdirs()\english$
;       If b$ = path$
;         filesinfo(ID)\DirGerman = trdirs()\german$
;         filesinfo(ID)\DirFrench = trdirs()\french$
;       EndIf
;     EndIf
;   Until quit=#true Or dummy=0
; EndProcedure

Procedure.l GetDir(path1$)
  Protected quit, dummy, b$
  ResetList(trdirs()) : quit = #False
  Repeat 
    dummy = NextElement(trdirs())
    If dummy > 0
      b$ = trdirs()\english$
      If b$ = path1$
        quit = #True
      EndIf
    EndIf
  Until quit=#True Or dummy=0
  ProcedureReturn dummy
EndProcedure

Procedure.s GetGermanDir(path1$)
  Protected dummy, b$
  dummy = GetDir(path1$)
  If dummy > 0    ; a german locale string was found
    b$ = trdirs()\german$
  Else
    b$ = ""
  EndIf
  ProcedureReturn b$
EndProcedure

Procedure.s GetFrenchDir(path1$)
  Protected dummy, b$
  dummy = GetDir(path1$)
  If dummy > 0    ; a french locale string was found
    b$ = trdirs()\french$
  Else
    b$ = ""
  EndIf
  ProcedureReturn b$
EndProcedure
    
 
; 
; Procedure.l GetFileName(file$)
;   file$ = ReplaceString(file$,".pb","")
;   ResetList(files()) : quit = #false
;   Repeat 
;     dummy = NextElement(files())
;     If dummy > 0
;       b$ = files()\english$
;       If b$ = file$    ; NOTE !!!  Have changed the check to exact word checking!!!!
; ;      If FindString(file$,b$,0)    ; Note!!!!  Instead of comparing exact file name, here will be checked
;         quit = #true               ;           if the file-name contains the translated name of files.csv
;       EndIf
;     EndIf
;   Until quit=#true Or dummy=0
;   ProcedureReturn dummy
; EndProcedure
; 
; Procedure.s GetGermanFile(file$)
;   dummy = GetFileName(file$)
;   If dummy > 0    ; a german locale string was found
;     b$ = files()\german$
;   Else
;     b$ = ""
;   EndIf
;   ProcedureReturn b$
; EndProcedure
; 
; Procedure.s GetFrenchFile(file$)
;   dummy = GetFileName(file$)
;   If dummy > 0    ; a french locale string was found
;     b$ = files()\french$
;   Else
;     b$ = ""
;   EndIf
;   ProcedureReturn b$
; EndProcedure
; 


For a=1 To files
;  MessageRequester("Debug",files(a))
  
  If ReadFile(0, files(a))
    ;Debug "File " + Str(a) + " opened: " + files(a)

    ;- Check Forum
    filesinfo(a)\Forum = ReadString(0)      ; save full text of the first line
    a$ = LCase(filesinfo(a)\Forum)
    If FindString(a$,"english forum:",0)      ; check for english or german forum, or other sources
      filesinfo(a)\ForumType = 0              ;   english
    ElseIf FindString(a$,"german forum:",0)
      filesinfo(a)\ForumType = 1              ;   german
    ElseIf FindString(a$,"french forum:",0)
      filesinfo(a)\ForumType = 2              ;   french
    ElseIf FindString(a$,"www.purebasic-lounge.de",0)
      filesinfo(a)\ForumType = 4              ;   Purebasic-Lounge
    Else
      filesinfo(a)\ForumType = 3              ;   other
    EndIf
    
    If filesinfo(a)\ForumType = 0 Or filesinfo(a)\ForumType = 1 Or filesinfo(a)\ForumType = 2   ; english or german forum ? => extract the URL
      b = FindString(filesinfo(a)\Forum,"http",0)
      If b     ; real URL like "http:..." found, else the URL stay empty
        filesinfo(a)\ForumURL = Right(filesinfo(a)\Forum, Len(filesinfo(a)\Forum) - b +1 )
      EndIf  
    ElseIf filesinfo(a)\ForumType = 4
      filesinfo(a)\ForumURL = "http://www.purebasic-lounge.de"
    EndIf

    
    ;- Check Author
    a$ = Trim(ReadString(0))      ; save full text on the 'author' line 
    If FindString(LCase(a$),"author:",0)
      a$ = RemoveString(a$, "; Author:",1)
      a$ = RemoveString(a$, ";Author:",1)
      a$ = Trim(a$)
      If a$ > ""
        filesinfo(a)\Author = a$
      EndIf
    EndIf
    
    
    ;- Check Date
    a$ = Trim(ReadString(0))
    If FindString(a$,"Date:",0)
      a$ = Right(a$,Len(a$)-8)
      a$ = ReplaceString(a$," January "  ,"1.",1,1)
      a$ = ReplaceString(a$," February " ,"2.",1,1)
      a$ = ReplaceString(a$," March "    ,"3.",1,1)
      a$ = ReplaceString(a$," April "    ,"4.",1,1)
      a$ = ReplaceString(a$," May "      ,"5.",1,1)
      a$ = ReplaceString(a$," June "     ,"6.",1,1)
      a$ = ReplaceString(a$," July "     ,"7.",1,1)
      a$ = ReplaceString(a$," August "   ,"8.",1,1)
      a$ = ReplaceString(a$," September ","9.",1,1)
      a$ = ReplaceString(a$," October "  ,"10.",1,1)
      a$ = ReplaceString(a$," November " ,"11.",1,1)
      a$ = ReplaceString(a$," December " ,"12.",1,1)
      
      ; cut additional information after 'day.month.year'
      b = FindString(a$," ",0)
      If b > 0     ; space and additional info found, so cut it...
        a$ = Left(a$,b-1)
      EndIf
 
      filesinfo(a)\Day   = Val(StringField(a$,1,"."))
      filesinfo(a)\Month = Val(StringField(a$,2,"."))
      filesinfo(a)\Year  = Val(StringField(a$,3,"."))

      ;  Debug files(a)
      ;  Debug a$+"xxx"
    EndIf


    ;- Check OS
    filesinfo(a)\OS = 0    ; no information until now
    ;If Lines > 3
      a$ = Trim(ReadString(0))
      If FindString(a$,"OS:",0)
        a$ = LCase(Right(a$,Len(a$)-3))
        If FindString(a$,"windows",0)             ;---------------------------------------------------------------
          filesinfo(a)\OS + 1                     ;                      Compatibility table
        EndIf                                    ;              1   2   3   4   5   6   7   8   9   10   11   12   13   14   15
        If FindString(a$,"linux",0)               ; Windows     x       x       x       x       x         x         x         x
          filesinfo(a)\OS + 2                     ; Linux           x   x            x  x            x    x              x    x
        EndIf                                     ; MacOS                   x   x   x   x                     x     x    x    x
        If FindString(a$,"macos",0)               ; AmigaOS                                 x   x    x    x   x     x    x    x
          filesinfo(a)\OS + 4
        EndIf
        If FindString(a$,"amigaos",0)
          filesinfo(a)\OS + 8
        EndIf
        
      EndIf

    ;- Check Demo compatibility
    filesinfo(a)\Demo = 0    ; no information until now
      a$ = Trim(ReadString(0))
      If FindString(a$,"Demo:",0)
        a$ = LCase(Right(a$,Len(a$)-5))
        If FindString(a$,"yes",0)
          filesinfo(a)\Demo = 1
          demofiles + 1
        ElseIf FindString(a$,"no",0)
          filesinfo(a)\Demo = 2
        Else                   ; for a lot of older codes we have automatically added the 'Demo:' tag but with no keyword 'yes/no'
          filesinfo(a)\Demo = 3   ; will lead to "?"
        EndIf
      Else        ; the 'Demo' line was not included in the source
        FileSeek(0, 1)
        While Eof(0) = 0
          a$ = ReadString(0)
          If FindString(a$,"_(",0) Or FindString(a$,"_ (",0)     ; look for '_(' or '_ (' as typical part of an API command
            filesinfo(a)\Demo = 3
            Break
          EndIf
        Wend
      EndIf

    

    ;- Store Path File
    a$ = GetPathPart(files(a))
    a$ = Right(a$, Len(a$) - Dir)
    filesinfo(a)\Path1 = StringField(a$, 1, DS$)    ; DS$ = "\" on Windows, "/" on MacOS
    filesinfo(a)\Path2 = StringField(a$, 2, DS$)
    filesinfo(a)\Path3 = StringField(a$, 3, DS$)
    filesinfo(a)\File = GetFilePart(files(a))


;     ;- Make Translations
; **** make this instantly when displaying the TreeGadget
;      because its only needed when opening a new dir node, not for every file (in same dir)

;     TranslateDir(a,filesinfo(a)\Path1)
;     TranslateDir(a,filesinfo(a)\Path2)
;     TranslateDir(a,filesinfo(a)\Path3)
;     
;     filesinfo(a)\DirGerman 
;     filesinfo(a)\DirFrench 
; 

  
    

;    Debug Line
    CloseFile(0)
  Else

    Debug "Can't read the file:"
    Debug files(a)
    Debug Lines

  EndIf
  
Next


;- Little test

; For a = 1 To 10
;   Debug files(a)
;   Debug filesinfo(a)\Forum
;   Debug filesinfo(a)\ForumType
;   Debug filesinfo(a)\ForumURL
;   Debug filesinfo(a)\Author
;   Debug filesinfo(a)\Path1
;   Debug filesinfo(a)\Path2
;   Debug filesinfo(a)\Path3
;   Debug filesinfo(a)\File
; Next




;- Create Author Listing

Structure authorinfo
  Name.s
  Codes.l
EndStructure
Global NewList author.authorinfo()


Procedure FindAuthor(a$)
  ForEach author()
    If author()\name = a$
      ProcedureReturn #True
    EndIf
  Next
  ProcedureReturn #False  
EndProcedure

Procedure ADD_Element(a$) 
  Protected result
  ;result = find_var(@a$)     ; if result > 0 then the new string to add already exists
  result = FindAuthor(a$)     ; if result > 0 then the new string to add already exists
  
  ; Debug "New: "+a$
  ; If result > 0
  ;  Debug "  "+author()\s
  ; EndIf
  
  If result = 0        ; we add only new items, if the old one doesn't exist already
    AddElement(author()) 
    author()\Name = a$ 
    author()\Codes = 1
  Else                 ; author does already exist, so we only increment his code number
    author()\Codes + 1
  EndIf
EndProcedure 


Procedure.s CutAddAuthorInfo(a$)
  Protected a
  a = FindString(a$,"(",0)
  If a
    a$ = Trim(Left(a$,a-1))
  EndIf
  a = FindString(a$,",",0)
  If a
    a$ = Trim(Left(a$,a-1))
  EndIf
  ProcedureReturn a$
EndProcedure


;Debug "We are checking the author informations now, and built the Top-Authors list..."
For a=1 To files
  a$ = filesinfo(a)\Author
  ;Debug "File number:" + Str(a) + "  - author: " + a$
  If a$ > ""
    ; Here we cut additional infos in brackets or after a comma
    a$ = CutAddAuthorInfo(a$)
    If a$ <> ""    ; we need this check, because there are several sources with no author, but only comments in brackets => author name would be blank
      If LCase(a$) <> "unknown"    ; don't add "Unknown" to the TopAuthors list
        ADD_Element(a$) 
      EndIf
    EndIf
  EndIf
Next  
;Debug "Author informations checked+reworked."
  
; ResetList(author()) 
; While NextElement(author()) 
;   Debug author()\Name
;   Debug author()\Codes
; Wend 
; 

;- TopCoders list
coders = ListSize(author()) - 1     ; Attention !! Decremented by 1, because the last element is empty!
If coders = -1
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    MessageRequester("Error", "General error: We didn't found any code authors, so there was an error with checking the codes! CAV will be closed...", #MB_ICONWARNING)
  CompilerElse
    MessageRequester("Error", "General error: We didn't found any code authors, so there was an error with checking the codes! CAV will be closed...")
  CompilerEndIf
  End
EndIf
Global Dim topcoders.authorinfo(coders)

Procedure SortTopAuthors(n)
  Protected i, j, k, temp, temp$
  For i=0 To n-1
    k=i
    For j=i+1 To n
      If topcoders(j)\Codes < topcoders(k)\Codes : k=j : EndIf
    Next j
    If k>i
      temp = topcoders(i)\Codes                 :  temp$ = topcoders(i)\Name
      topcoders(i)\Codes = topcoders(k)\Codes   :  topcoders(i)\Name = topcoders(k)\Name
      topcoders(k)\Codes = temp                 :  topcoders(k)\Name = temp$
    EndIf
  Next i
EndProcedure

a = 0
ResetList(author())
ForEach author()
  topcoders(a)\Name = author()\Name
  topcoders(a)\Codes = author()\Codes
  a+1
Next

; Sorting algorithm
SortTopAuthors(coders)

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 355
; FirstLine = 332
; Folding = --
; UseMainFile = CodeArchivViewer_Main.pb