; Tool for the CodeArchivViewer to create a Data set
; of the WINAPI functions.
; Taken from the file "APIFunctionListing.txt" in the Compilers directory,
; which must previously be splitted from the other data like function description

; Written and CopyRight 07th November 2004 by Andr Beer

; Update: 05-Nov-2004
;         the "" in the .csv file must be unchanged, they will directly used in code
;         (it doesn't attach another pair of "" anymore)
; Update: 28-Dec-2006
;         updated the source to PB v4 syntax (converter itself and also the output)


Dim WinAPIFunctions.s(10000)

If ReadFile(0, "APIFunctionListing.csv")
  dummy$ = ReadString(0)  ; we start reading at second line... (first one contains only the number of functions)
  count = 0
  Repeat 
    a$ = ReadString(0)
    a$ = StringField(a$,1,";")     ; sometimes there are only one field, sometimes more, we only need the first ;-)
    If Right(a$,1) <> Chr(34)     ; if there is the " missing, will manually add one
      a$ + Chr(34)
    EndIf
    If Left(a$,1) <> Chr(34)
      a$ = Chr(34) + a$ 
    EndIf
    WinAPIFunctions(count) = a$
    count + 1
  Until Eof(0) = #True
  CloseFile(0)
  If CreateFile(0, "CodeArchivViewer_WinAPIFunctions.pb")
    WriteStringN(0, "#NbWinAPIFunctions = "+Str(count-1))
    WriteStringN(0, "Global Dim WinAPIFunctions.s(#NbWinAPIFunctions)")
    WriteStringN(0, "Global Dim APIFunctionsHT.l(255)")
    WriteStringN(0, "")
    WriteStringN(0, "Restore WinAPIFunctions")
    WriteStringN(0, "For k=1 To #NbWinAPIFunctions")
    WriteStringN(0, "  Read WinAPIFunctions.s(k)")
    WriteStringN(0, "Next")
    WriteStringN(0, "")
    WriteStringN(0, "; API function Hash Table")
    WriteStringN(0, "CurrentChar = 0")
    WriteStringN(0, "For k=1 To #NbWinAPIFunctions")
    WriteStringN(0, "  Char = Asc(LCase(WinAPIFunctions(k-1)))")
    WriteStringN(0, "  If Char <> CurrentChar")
    WriteStringN(0, "    APIFunctionsHT(Char) = k")
    WriteStringN(0, "    CurrentChar = Char")
    WriteStringN(0, "  EndIf")
    WriteStringN(0, "Next")
    WriteStringN(0, "")
    WriteStringN(0, "DataSection")
    WriteStringN(0, "  ;- Keywords - WinAPI Functions")
    WriteStringN(0, "  WinAPIFunctions:")
    For a=0 To count-1
      ;WriteStringN("    Data$ "+Chr(34)+PBFunctions(a)+Chr(34))      ; original version of 10-07-2004
      WriteStringN(0, "    Data$ "+WinAPIFunctions(a))    
    Next  
    WriteStringN(0, "EndDataSection")
    CloseFile(0)
  EndIf
EndIf

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 55
; FirstLine = 9
; Folding = -
; EnableXP