; Tool for the CodeArchivViewer to create a Data set
; of the PureBasic constants (PB_xxx).
; Taken from the file "PureBasic.pb" in the CVS/Residents directory,
; which must previously be alphabetically sorted via Works-Database etc.

; Written and CopyRight 07th November 2004 by Andr Beer
; Updated on 29-Dec-2006 for PB v4 syntax (converter itself and also the output)

NewList PBConstants.s()
If ReadFile(0, "PureBasic-Constants.csv")
  Repeat 
    a$ = RemoveString(ReadString(0),Chr(34))
    If Left(a$,4) = "#PB_"        ; select the "PB_xxxx" only constants
      a$ = StringField(a$,1," ")    ; we only need the constant name
      If Right(a$,1) = "="
        a$ = Left(a$,Len(a$)-1)
      EndIf
      AddElement(PBConstants())
      PBConstants() = a$
    EndIf
  Until Eof(0) = #True
  CloseFile(0)
  count = CountList(PBConstants())
  If CreateFile(0, "CodeArchivViewer_PBConstants.pb")
    WriteStringN(0, "#NbPBConstants = "+Str(count))
    WriteStringN(0, "Global Dim PBConstants.s(#NbPBConstants)")
    WriteStringN(0, "")
    WriteStringN(0, "Restore PBConstants")
    WriteStringN(0, "For k=1 To #NbPBConstants")
    WriteStringN(0, "  Read PBConstants.s(k)")
    WriteStringN(0, "Next")
    WriteStringN(0, "")
    WriteStringN(0, "DataSection")
    WriteStringN(0, "  ;- Keywords - PB Constants")
    WriteStringN(0, "  PBConstants:")
    ForEach PBConstants()
      WriteStringN(0, "    Data$ "+Chr(34)+PBConstants()+Chr(34))    
    Next  
    WriteStringN(0, "EndDataSection")
    CloseFile(0)
  EndIf
EndIf

; IDE Options = PureBasic v4.02 (Windows - x86)
; CursorPosition = 20
; Folding = -