
; 
; GetDescription:
;       ResetList(trfiles()) : quit = #false
;       Repeat 
;         dummy = NextElement(trfiles())
;         If dummy > 0
;           d$ = trfiles()\english$
;           If d$ = c$    ; compare actual source name with english file name stored in the files.csv file
;                         ; NOTE !!!  It uses exact word checking!!!! => Else it would be:   If FindString(c$,d$,0) 
;             quit = #true
;           EndIf
;         EndIf
;       Until quit=#true Or dummy=0
;       If dummy > 0
;         If Lang = 1          ; actually german is set as locale language
;           b$ = trfiles()\german$
; ;         ElseIf Lang = 2      ; actually french is set as locale language      ; FRENCH ISN'T ACTUALLY IMPLEMENTED IN CODEARCHIVE!!
; ;           b$ = trfiles()\french$
;         EndIf
;       EndIf
; Return
; 
; 


Procedure.s GetDescription(c$)
  ; Get the sourcecode filename translation from english original filename
  ; currently only for german available
  ResetList(trfiles()) : quit = #False
  Repeat 
    dummy = NextElement(trfiles())
    If dummy > 0
      d$ = trfiles()\english$
      If d$ = c$    ; compare actual source name with english file name stored in the files.csv file
                    ; NOTE !!!  It uses exact word checking!!!! => Else it would be:   If FindString(c$,d$,0) 
        quit = #True
      EndIf
    EndIf
  Until quit=#True Or dummy=0
  If dummy > 0
    If Lang = 1          ; actually german is set as locale language
      b$ = trfiles()\german$
;         ElseIf Lang = 2      ; actually french is set as locale language      ; FRENCH ISN'T ACTUALLY IMPLEMENTED IN CODEARCHIVE!!
;           b$ = trfiles()\french$
    EndIf
  EndIf
  ProcedureReturn b$
EndProcedure 



;- Fill TreeGadget
Procedure FillTree()
  ; There is already the FileTree existing, so we do an update here:
  If GetGadgetItemText(#FileTree, 0, 0) <> ""      ; IsGadget(#FileTree) don't work because gadget was already created in Open_MainWindow() procedure
    update = #True    
    actualitem = GetGadgetState(#FileTree)
    ClearGadgetItems(#FileTree)
    ClearList(check2())
  Else
    update = #False
  EndIf
  
;  Debug "A new call to fill TreeGadget"
  
  
  For a = 1 To files
    ; here we do now the optional check, if only demo-compatible codes should be shown...
    If prefs(36) = 1 And filesinfo(a)\Demo <> 1
      Continue    ; jump to next file without including it in the tree...
    EndIf
  
  
    b$=""
    ; paths = 0    ; save actual path deep   (0 = in ground path, 1 = first (main) directory, 2 = ..., 3 = ...)
    lastpath1$ = path1$
    lastpath2$ = path2$
    lastpath3$ = path3$
    
    path1$ = filesinfo(a)\Path1
    path2$ = filesinfo(a)\Path2
    path3$ = filesinfo(a)\Path3

    ; Debug "File: " + Str(a) + " - " + path1$ + " / " + path2$ +  "/ " + path3$

; dummy$= filesinfo(a)\path1+"\"+filesinfo(a)\path2+"\"+filesinfo(a)\path3+"\"+filesinfo(a)\file
; If dummy$ = "\\\"
;   Debug "Error"
; EndIf
; 

    
    ; check here, if the old path was different
    If lastpath3$ <> "" And path3$ <> lastpath3$
      paths - 1      ;here was formerlly used CloseTreeGadgetNode(#FileTree)
    EndIf
    If lastpath2$ <> "" And path2$ <> lastpath2$
      paths - 1      ;here was formerlly used CloseTreeGadgetNode(#FileTree)
    EndIf
    If lastpath1$ <> "" And path1$ <> lastpath1$
      paths - 1      ;here was formerlly used CloseTreeGadgetNode(#FileTree)
    EndIf
    
    file$  = filesinfo(a)\File

    If (path1$ <> lastpath1$) And path1$<>""   ; a new firstpath begins...
      paths = 0
      a$ = path1$
      If prefs(3) = 1       ; showing translation enabled ?
        If Lang=1 : b$=GetGermanDir(path1$) : EndIf
        If Lang=2 : b$=GetFrenchDir(path1$) : EndIf
        If b$ > "" : a$ + "  (" + b$ + ")" : EndIf
      EndIf
      AddGadgetItem(#FileTree, -1, a$, 0, paths)
      AddElement(check2()) : check2() = -1    ; add informations for the TreeGadget, to get later right clicked item
      ;OpenTreeGadgetNode(#FileTree)
      lastpath1$ = path1$
    EndIf
    If (path2$ <> lastpath2$) And path2$<>""   ; a new secondpath begins...
      paths = 1
      a$ = path2$
      If prefs(3) = 1       ; showing translation enabled ?
        If Lang=1 : b$=GetGermanDir(path2$) : EndIf
        If Lang=2 : b$=GetFrenchDir(path2$) : EndIf
        If b$ > "" : a$ + " (" + b$ + ")" : EndIf
      EndIf
      AddGadgetItem(#FileTree, -1, a$, 0, paths)
      AddElement(check2()) : check2() = -1    ; add informations for the TreeGadget, to get later right clicked item
      ;OpenTreeGadgetNode(#FileTree)
      lastpath2$ = path2$
    EndIf
    If (path3$ <> lastpath3$) And path3$<>""
      paths = 2
      a$ = path3$
      If prefs(3) = 1       ; showing translation enabled ?
        If Lang=1 : b$=GetGermanDir(path3$) : EndIf
        If Lang=2 : b$=GetFrenchDir(path3$) : EndIf
        If b$ > "" : a$ + " (" + b$ + ")" : EndIf
      EndIf
      AddGadgetItem(#FileTree, -1, a$, 0, paths)
      AddElement(check2()) : check2() = -1    ; add informations for the TreeGadget, to get later right clicked item
      ;OpenTreeGadgetNode(#FileTree)
      lastpath3$ = path3$
    EndIf

       
;       ; Check for file name translations....
;       If #FileTranslation = 1
;         If Language=0 : b$=GetGermanFile(file$) : EndIf
;         If Language=100 : b$=GetFrenchFile(file$) : EndIf
;       EndIf
;         
;       file$=a$+"<a href="+x+path$+file$+x+">"+file$+"</a>"
;       If codes(a)\newdate = 1       ; file was ADDED after last release
;         file$ + "<img src="+x+"xGfx/new.gif"+x+" border=0>"
;       ElseIf codes(a)\newdate = 2   ; file was UPDATED after last release
;         file$ + " <img src="+x+"xGfx/upd.gif"+x+" border=0>"
;       EndIf
; 
;       ; If there is any file name translation, add it after the file link in brackets
;       If #FileTranslation = 1
;         If b$ > ""
;           file$ + tab
;           If #SmallerFont = 1
;             file$ + "<font size=1>"
;           EndIf
;           file$ + " (" + b$ + ")" 
;           If #SmallerFont = 1
;             file$ + "</font>"
;           EndIf
;         EndIf
;       EndIf
      
    If prefs(4) = 1      ; Adding file translation activated ?
      If Lang = 1      ; currently only for german available
        c$ = ReplaceString(File$,".pb","")
        b$ = GetDescription(c$)
        If b$ > ""     ; only if there is a translation available...
          file$ = file$ + "   (" + b$ + ")"
        EndIf
      EndIf
    EndIf
    AddGadgetItem(#FileTree,-1,file$,0,paths+1)
    
    ;Debug file$ + " - " + path1$ + "/" + path2$ + "/" + path3$ + Str(paths+1)
    
    AddElement(check2()) : check2() = a    ; add informations for the TreeGadget, to get later right clicked item
  Next

  ; Set actual item back to last choosen one, when doing an update to the TreeGadget
  If update = #True
    SetGadgetState(#FileTree, actualitem)
  EndIf

  ;Debug CountGadgetItems(#FileTree)
EndProcedure


;- Fonts
;
Global FontID1
CompilerIf  #os = #windows
  FontID1 = LoadFont(1, "Arial", 12, #PB_Font_Bold)
CompilerElse
  FontID1 = LoadFont(1, "Arial", 16, #PB_Font_Bold)
CompilerEndIf
;FontID2 = LoadFont(2, "Arial", 9, #PB_Font_Bold)

; will be used for creating the menu at first time and also for updating the menu when locale language has changed
Procedure CreateMainMenu()
  ;- Menu
;  If IsMenu(0)
;    FreeMenu(0)
;  EndIf
  If CreateMenu(0,WindowID(#MainWindow))
    MenuTitle(Language$(45))      ; Project
      MenuItem(#MainWinExit,Language$(46)+Chr(9)+"Esc")      ; Quit
    MenuTitle(Language$(47))  
      MenuItem(#MainWinOptions,Language$(48)+Chr(9)+Language$(91)+"+O")   ; Options   (STRG + O)
      MenuBar()
      MenuItem(#MainWinDemoCodes,Language$(225)+Chr(9)+Language$(91)+"+D")   ; Only Demo-compatible codes  (STRG + D)
      SetMenuItemState(0,#MainWinDemoCodes,prefs(36))
      MenuBar()
      MenuItem(#MainWinTopAuthors10,Language$(93)+Chr(9)+"F1") ; Top10-Authors (F1)
      MenuItem(#MainWinTopAuthors20,Language$(94)+Chr(9)+"F2") ; Top20-Authors (F2)
      MenuItem(#MainWinTopAuthors50,Language$(95)+Chr(9)+"F3") ; Top50-Authors (F3)
    MenuTitle(Language$(228))  
      MenuItem(#MainWinForumEnglish,Language$(230)+Chr(9)+"F5")  ; English forum (F5)
      MenuItem(#MainWinForumGerman, Language$(231)+Chr(9)+"F6") ; German forum (F6)
      MenuItem(#MainWinForumFrench, Language$(232)+Chr(9)+"F7") ; French forum (F7)
      MenuItem(#MainWinForumLounge, Language$(233)+Chr(9)+"F8") ; PureBasic Lounge (F8)
    MenuTitle("?")
      MenuItem(#MainWinHelp,Language$(49)+Chr(9)+Language$(91)+"+H")      ; Help
      MenuItem(#MainWinAbout,Language$(50)+Chr(9)+Language$(91)+"+I")     ; About    (STRG + I)
      MenuItem(#MainWinMoreInfo,Language$(145)+Chr(9)+Language$(91)+"+M") ; More informations (STRG + M)
  EndIf
EndProcedure


Procedure Open_MainWindow()
  Shared pichnd 
  Protected x, y 

  Flags.l = #PB_Window_SystemMenu|#PB_Window_TitleBar|#PB_Window_Invisible | #PB_Window_MinimizeGadget

  If prefs(0) = 0 
    Flags = Flags | #PB_Window_ScreenCentered    ; if there is no saved main window position, then add "Sceen-Centered"
  EndIf

  CompilerIf #resize = #True
    Flags = Flags | #PB_Window_SizeGadget
  CompilerEndIf
  
  MainWin = OpenWindow(#MainWindow, prefs(1), prefs(2), 760, 620, #wintitle, Flags)
  If MainWin
      ;- Gadgets
      Frame3DGadget(#FrameMain, 10, 50, 740, 543, "", #PB_Frame3D_Single)
      TextGadget(#Title, 10, 8, 740, 20, Language$(0)+" "+#version, #PB_Text_Center)
      SetGadgetFont(#Title, FontID1)
      TextGadget(#Codes, 10, 28, 740, 16, Language$(1)+" "+Str(files)+"  ("+Language$(227)+" "+Str(demofiles)+")", #PB_Text_Center)
      Frame3DGadget(#SearchFrame, 20, 55, 720, 130, Language$(2))
      x = 40 : y = 77
      TextGadget(#SearchSource, x, y, 60, 20, Language$(3), #PB_Text_Right)    : y + 27
      TextGadget(#SearchAuthor, x, y, 60, 20, Language$(4), #PB_Text_Right)    : y + 27
      TextGadget(#SearchDate, x, y, 60, 20, Language$(5), #PB_Text_Right)      : y + 27
      TextGadget(#SearchFull, x, y, 60, 20, Language$(6), #PB_Text_Right)      : y + 27
      x = 140 : y = 75
      ComboBoxGadget(#SearchSourceInput, x, y, 365, 20)       : y + 27 ; , #PB_ComboBox_Editable)  11-Dec-2004: removed the EDITABLE combobox, use fulltext search instead
      StringGadget(#SearchAuthorInput, x, y, 330, 20, "")
      ButtonGadget(#SearchAuthorSelect, x + 335, y, 30, 20, "...")  : y + 27

      ComboBoxGadget(#SearchDateRange, x, y, 90, 20)
      ComboBoxGadget(#SearchDateDay, x + 95, y, 70, 20)
      ComboBoxGadget(#SearchDateMonth, x + 170, y, 110, 20)
      ComboBoxGadget(#SearchDateYear, x + 285, y, 80, 20)   : y + 27

      StringGadget(#SearchFullInput, x, y, 330, 20, "")
      ButtonGadget(#SearchKeywords, x + 335, y, 30, 20, "...")
;      TextGadget(#SearchFull, 30, 145, 120, 20, Language$(6), #PB_Text_Right)
      x = 570 : y = 80
      ButtonGadget(#ResetSearch, x, y, 150, 40, Language$(29))      : y + 50
      ButtonGadget(#StartSearch, x, y, 150, 40, Language$(8))
      
      x = 20 : y + 60
      Frame3DGadget(#FrameResults, x, y, 720, 398, Language$(58))    ; Language$(9))   ;  58 = Contents of the CodeArchive, 9 = Search Results


      ; ------- Icon's for displaying during performing a search ---------
      ProgressBarGadget(#SearchProgressBar, 33, 340, 534, 30, 0, files, #PB_ProgressBar_Smooth)
      TextGadget(#SearchProgressText, 33, 310, 534, 20, Language$(85), #PB_Text_Center)
      HideGadget(#SearchProgressText, 1)
      HideGadget(#SearchProgressBar, 1)
      ; ------------------------------------------------------------------

      ; ------- Icon's for displaying after performing a search ---------
      If prefs(7) = 0      ; no description should be displayed, so we have space to expand 'name' and 'dir' width
        a = 170    ; expanded 'name' size  (1st column)
        b = 170    ; expanded 'dir' size  (2nd column)
      Else 
        a = 130    ; normal 'name' size
        b = 110    ; normal 'dir' size
      EndIf
      
      y + 20     ; Note: this y value is valid for all        
      ListIconGadget(#ResultList, 30, y, 550, 370, Language$(59), a, #PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  ; ListIcon for displaying the search results
        AddGadgetColumn(#ResultList,1,Language$(79),b)                  ; Dir(s)
        column = 2
        If prefs(5) = 1 
          AddGadgetColumn(#ResultList,column,Language$(61),55)                   ; OS
          column + 1
        EndIf
        If prefs(6) = 1 
          AddGadgetColumn(#ResultList,column,Language$(62),45)                   ; Demo
          column + 1
        EndIf
        If prefs(7) = 1 
          AddGadgetColumn(#ResultList,column,Language$(60),250)                  ; Description
        EndIf
      HideGadget(#ResultList,1)
      ; ------------------------------------------------------------------
      
      ; ------- Icon's for displaying the selected example source ---------
      EditorGadget(#EditorSource, 30, y, 550, 370, #PB_Editor_ReadOnly) 
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
        ;SendMessage_(GadgetID(#EditorSource), #EM_SETOPTIONS, #ECOOP_OR, #ECO_READONLY)
        SendMessage_(GadgetID(#EditorSource),#EM_SETBKGNDCOLOR,#Null,prefs(25))   ; set background color of the code viewer
      CompilerElse
        Debug "Main GUI: setting background color in EditorGadget is only available on MS Windows for now..."
      CompilerEndIf
        
      HideGadget(#EditorSource,1)
      ; ------------------------------------------------------------------

      ; ------- Icon for displaying directory structure ---------
      tree = TreeGadget(#FileTree, 30, y, 550, 370, #PB_Tree_AlwaysShowSelection)
      ; ------------------------------------------------------------------

      #left = 590 : #width = 140

      ButtonGadget(#ResultShow,   #left, y+5,     #width, 40, Language$(10))
      ButtonGadget(#ResultForum,  #left, y+55,  #width, 40, Language$(11))
      ButtonGadget(#ResultEditor, #left, y+105, #width, 40, Language$(12))

      ; ------- Icon's for displaying after performing a search **** Part 2 ***** ---------
      ButtonGadget(#ShowFileTree, #left, y + 180, #width, 40, Language$(63),#PB_Button_MultiLine)   ; Show FileTree with complete code archive
      HideGadget(#ShowFileTree,1)
      ; ------------------------------------------------------------------

   
      ButtonGadget(#CloseFileTree, #left, y+180, #width, 40, Language$(78), #PB_Button_MultiLine)    ; Close FileTree, must be hidden when Search-ListIcon is activated
      TextGadget  (#PureAreaText, #left+2, y+263, #width, 17, Language$(89))   ; "Presented by"
      ButtonImageGadget(#PureAreaPic, #left, y+280, #width, 80, cavlogo)   ;UseImage(0))

;       HyperLinkGadget(150,#left,540,#width,15,"Pure-Board.de",RGB(20,20,250),#PB_Text_Center)
;       SetGadgetFont(150,FontID2)
;       HyperLinkGadget(151,#left,555,#width,15,"English",RGB(20,20,250),#PB_Text_Center)
;       SetGadgetFont(151,FontID2)

      ;- Tooltips
      SetMainWinToolTips()

      FillTree()
      
      
      ;- RESIZE of selected gadgets in main window  (using PUREResize userlib by gnozal)
      CompilerIf #resize = #True
        PureRESIZE_SetWindowMinimumSize(#MainWindow, 700, 615)
        ; activate resizing of the three main gadgets (treegadget, listicon, editor)
        PureRESIZE_SetGadgetResize(#FileTree, #True, #True, #True, #True)      
        PureRESIZE_SetGadgetResize(#ResultList, #True, #True, #True, #True)
        PureRESIZE_SetGadgetResize(#EditorSource, #True, #True, #True, #True)

        PureRESIZE_SetGadgetResize(#FrameMain, #True, #True, #True, #True)
        PureRESIZE_SetGadgetResize(#Title, #True, #False, #True, #False)   ; textgadget with title
        PureRESIZE_SetGadgetResize(#Codes, #True, #False, #True, #False)   ; textgadget with number of codes

        PureRESIZE_SetGadgetResize(#SearchFrame, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchSource, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#SearchAuthor, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#SearchDate, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#SearchFull, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#SearchSourceInput, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchAuthorInput, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchAuthorSelect, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#SearchDateRange, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchDateDay, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchDateMonth, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchDateYear, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchFullInput, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchKeywords, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#ResetSearch, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#StartSearch, #False, #False, #False, #False)

        PureRESIZE_SetGadgetResize(#FrameResults, #True, #True, #True, #True)

        PureRESIZE_SetGadgetResize(#SearchProgressBar, #True, #False, #True, #False)
        PureRESIZE_SetGadgetResize(#SearchProgressText, #True, #False, #True, #False)

        PureRESIZE_SetGadgetResize(#ResultShow, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#ResultForum, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#ResultEditor, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#ShowFileTree, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#CloseFileTree, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#PureAreaText, #False, #False, #False, #False)
        PureRESIZE_SetGadgetResize(#PureAreaPic, #False, #False, #False, #False)

      CompilerEndIf


    CreateMainMenu()
        
    ;- Keyboard-Shortcuts
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Escape,#MainWinExit)
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_O,#MainWinOptions) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_D,#MainWinDemoCodes)
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F1,#MainWinTopAuthors10) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F2,#MainWinTopAuthors20) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F3,#MainWinTopAuthors50) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F5,#MainWinForumEnglish) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F6,#MainWinForumGerman) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F7,#MainWinForumFrench) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_F8,#MainWinForumLounge) 
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_H,#MainWinHelp)
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_I,#MainWinAbout)
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_M,#MainWinMoreInfo)
    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Return,#Return)      ; Return-Handler for several StringGadgets

    AddKeyboardShortcut(#MainWindow,#PB_Shortcut_Control|#PB_Shortcut_Shift|#PB_Shortcut_C,#MainWinStartCodeTester)

;    InitAnimate(480,400,100,50,WindowID()) 
; InitAnimate(10,10,300,100,WindowID()) 


  EndIf
EndProcedure


Procedure FileTreeCollapseAll() 
;   CompilerIf #PB_Compiler_OS = #PB_OS_Windows
;     hwndTV.l = GadgetID(#FileTree)  
;     hRoot.l = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_ROOT, 0)  
;     hItem.l = hRoot  
;     Repeat 
;       SendMessage_(hwndTV, #TVM_EXPAND, #TVE_COLLAPSE, hItem) 
;       hItem = SendMessage_(hwndTV, #TVM_GETNEXTITEM, #TVGN_NEXTVISIBLE , hItem)  
;     Until hItem = #Null  
;     SendMessage_(hwndTV, #TVM_ENSUREVISIBLE, 0, hRoot) 
;   CompilerElse
;    Debug "FileTreeCollapseAll() procedure:"
;    Debug "... is only available on MS Windows for now..."
    Items = CountGadgetItems(#FileTree)
    For a = 0 To Items
      SetGadgetItemState(#FileTree, a, #PB_Tree_Collapsed)
    Next
;  CompilerEndIf
EndProcedure 


Procedure FillComboBoxes()
  ; ComboBox - Source of code examples
  AddGadgetItem(#SearchSourceInput,-1,Language$(13))   ; all
  AddGadgetItem(#SearchSourceInput,-1,Language$(14))   ; english forum
  AddGadgetItem(#SearchSourceInput,-1,Language$(15))   ; german forum
  AddGadgetItem(#SearchSourceInput,-1,Language$(119))  ; french forum
  AddGadgetItem(#SearchSourceInput,-1,"PureBasic-Lounge.de")
  AddGadgetItem(#SearchSourceInput,-1,Language$(16)) 
;  AddGadgetItem(#SearchSourceInput,-1,"")   ; blank field for later (possible) input

  ; ComboBox - Select date range
  AddGadgetItem(#SearchDateRange,-1,Language$(215))      ; Exactly ... codes must match selected date
  AddGadgetItem(#SearchDateRange,-1,Language$(216))      ; Before .... codes must be older than selected date
  AddGadgetItem(#SearchDateRange,-1,Language$(217))      ; After ..... codes must be newer than selected date
  ; ComboBox - Search for day
  AddGadgetItem(#SearchDateDay,-1,Language$(13))   ; all
  For a=1 To 31
    AddGadgetItem(#SearchDateDay,-1,Str(a)) 
  Next
  ; ComboBox - Search for month
  AddGadgetItem(#SearchDateMonth,-1,Language$(13))   ; all
  For a=1 To 12
    AddGadgetItem(#SearchDateMonth,-1,Language$(16+a)) 
  Next
  ; ComboBox - Search for month
  AddGadgetItem(#SearchDateYear,-1,Language$(13))   ; all
  
  ; Get current year from systemdate
  b = Year(Date()) + 1                ; we build a range from 2000 till current_year + 1 
  If b < 2005 : b = 2005 : EndIf     ; this is more for security if the systemtime/date is wrong (broken battery etc.)
  For a=2000 To b
    AddGadgetItem(#SearchDateYear,-1,Str(a)) 
  Next
  
EndProcedure


Procedure SetComboBoxStatus()
  SetGadgetState(#SearchSourceInput,0)
  SetGadgetState(#SearchDateDay,0)
  SetGadgetState(#SearchDateMonth,0)
  SetGadgetState(#SearchDateYear,0)
  SetGadgetState(#SearchDateRange,0)
EndProcedure



;- Authors-Window
Procedure OpenAuthors()
  ; Opens a new window for choosing authors
  ; nearby the mouse cursor
  If OpenWindow(#AuthorWin,0,0,190,104,"",#PB_Window_BorderLess|#PB_Window_Invisible,WindowID(#MainWindow))
      x = 8 : y = 28 : w = 174
      Frame3DGadget (#AuthorWinFrame, 3,3,184,98,Language$(43))                        ; Title: Choose author to search:
      TextGadget    (#AuthorWinText, x,y,w,20,Language$(44),#PB_Text_Center) : y + 16   ; Authors
      ComboBoxGadget(#AuthorWinCombo,x,y,w,400)                              : y + 26
        ResetList(author()) 
        While NextElement(author()) 
          AddGadgetItem(#AuthorWinCombo,-1,author()\Name) 
        Wend 
      ButtonGadget  (#AuthorWinQuit,  x,y,w,24,Language$(34))              ; Cancel  (after choosing a keyword the window will be automatically closed)
      
    AddKeyboardShortcut(#AuthorWin,#PB_Shortcut_Escape,#AuthorWinExit)
    AddKeyboardShortcut(#AuthorWin,#PB_Shortcut_Return,#AuthorWinChoose)
  EndIf
EndProcedure

Procedure ShowAuthors()
  SetGadgetState(#AuthorWinCombo,-1)
  ;UseWindow(#AuthorWin)
  ResizeWindow(#AuthorWin, DesktopMouseX(), DesktopMouseY(), #PB_Ignore, #PB_Ignore)
  HideWindow(#AuthorWin, 0)
  StickyWindow(#AuthorWin, 1)
  DisableWindow(#MainWindow, 1)
  authorwin_shown = #True
EndProcedure

Procedure HideAuthors()
  DisableWindow(#MainWindow, 0)
  HideWindow(#AuthorWin, 1)
  authorwin_shown = #False
  SetActiveGadget(#SearchAuthorInput)      ;16th-May-2005: set the focus to the calling buttongadget
EndProcedure


;- Keywords-Window
Procedure OpenKeywords()
  ; Opens a new window for choosing keywords: PB functions, PB keywords, ASM keywords
  ; nearby the mouse cursor
  If OpenWindow(#KeyWin,0,0,190,277,"",#PB_Window_BorderLess|#PB_Window_Invisible,WindowID(#MainWindow))
      x = 8 : y = 28 : w = 174
      Frame3DGadget (#KeyWinFrame, 3,3,184,271,Language$(30))                            ; Title: Choose keyword to search:
      TextGadget    (#KeyWinText1, x,y,w,15,Language$(31),#PB_Text_Center) : y + 16   ; PB keywords
      ComboBoxGadget(#KeyWinCombo1,x,y,w,400)                              : y + 26
        For a = 1 To #NbBasicKeywords
          AddGadgetItem(#KeyWinCombo1,-1,BasicKeywordsReal(a))
        Next
        
      TextGadget    (#KeyWinText2, x,y,w,20,Language$(32),#PB_Text_Center) : y + 16   ; PB commands
      ComboBoxGadget(#KeyWinCombo2,x,y,w,400)                              : y + 26
        For a = 1 To #NbPBFunctions 
          AddGadgetItem(#KeyWinCombo2,-1,PBFunctions(a))
        Next
        
      TextGadget    (#KeyWinText3, x,y,w,20,Language$(33),#PB_Text_Center) : y + 16   ; ASM keywords
      ComboBoxGadget(#KeyWinCombo3,x,y,w,400)                              : y + 26
        For a = 1 To NbASMKeywords
          AddGadgetItem(#KeyWinCombo3,-1,ASMKeywords(a))
        Next

      TextGadget    (#KeyWinText4, x,y,w,20,Language$(120),#PB_Text_Center) : y + 16   ; PB constants
      ComboBoxGadget(#KeyWinCombo4,x,y,w,400)                               : y + 26
        For a = 1 To #NbPBConstants
          AddGadgetItem(#KeyWinCombo4,-1,PBConstants(a))
        Next

      TextGadget    (#KeyWinText5, x,y,w,20,Language$(118),#PB_Text_Center) : y + 16   ; WinAPI functions
      ComboBoxGadget(#KeyWinCombo5,x,y,w,400)                               : y + 34
        For a = 1 To #NbWinAPIFunctions
          AddGadgetItem(#KeyWinCombo5,-1,WinAPIFunctions(a))
        Next
        
      ; ButtonGadget  (#KeyWinChoose,x,y,w/2-5,24,Language$(34))                         ; Choose (the selected keywords and put them into the search input)
      ButtonGadget  (#KeyWinQuit,  x,y,w,24,Language$(34))                     ; Cancel  (after choosing a keyword the window will be automatically closed)
      
    AddKeyboardShortcut(#KeyWin,#PB_Shortcut_Escape,#KeyWinExit)
    AddKeyboardShortcut(#KeyWin,#PB_Shortcut_Return,#KeyWinChoose)
  EndIf
EndProcedure

Procedure ShowKeywords()
  SetGadgetState(#KeyWinCombo1,-1)
  SetGadgetState(#KeyWinCombo2,-1)
  SetGadgetState(#KeyWinCombo3,-1)
  SetGadgetState(#KeyWinCombo4,-1)
  SetGadgetState(#KeyWinCombo5,-1)
  ;UseWindow(#KeyWin)
  ResizeWindow(#KeyWin,DesktopMouseX(),DesktopMouseY(),#PB_Ignore,#PB_Ignore)
  HideWindow(#KeyWin, 0)
  StickyWindow(#KeyWin, 1)
  DisableWindow(#MainWindow, 1)
  keywin_shown = #True
EndProcedure

Procedure HideKeywords()
  DisableWindow(#MainWindow, 0)
  HideWindow(#KeyWin, 1)
  keywin_shown = #False
  SetActiveGadget(#SearchFullInput)
EndProcedure


Procedure RefreshGadget(gad)
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    While WindowEvent() : Wend
     hWnd = GadgetID(gad) 
     InvalidateRect_(hWnd,0,1) 
     UpdateWindow_(hWnd)
  CompilerElse
    Debug "RefreshGadget() procedure:"
    Debug "... is only needed / supported on MS Windows for now!"
  CompilerEndIf
  SetActiveGadget(gad)
EndProcedure

Procedure RefreshWindow(win)
  While WindowEvent() : Wend
;   hWnd = WindowID(gad) 
;   InvalidateRect_(hWnd,0,1) 
;   UpdateWindow_(hWnd)
  SetActiveGadget(win)
EndProcedure


;- TopAuthors-Window
Procedure OpenTopAuthors()
  If OpenWindow(#TopAuthorsWin,0,0,320,212,Language$(title),#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_Invisible)
      x = 10 : y = 10 : w = 303
      ListIconGadget(#TopAuthorList,x,y,w,165,Language$(96),50,#PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  ; Place
        AddGadgetColumn(#TopAuthorList,1,Language$(97),170)                  ; Author
        AddGadgetColumn(#TopAuthorList,2,Language$(98),60)                   ; Codes (number of codes included)
      y + 173
      ButtonGadget  (#TopAuthorChoose,  x,y,w,24,Language$(99))              ; Cancel  (after choosing a keyword the window will be automatically closed)
    AddKeyboardShortcut(#TopAuthorsWin,#PB_Shortcut_Escape,#TopAuthorsExit)
    AddKeyboardShortcut(#TopAuthorsWin,#PB_Shortcut_Return,#TopAuthorsReturn)
  EndIf
EndProcedure

Procedure ShowTopAuthors(title,authors)
  ; title = Locale string for Language$(xx), 94 = Top10, 95=Top20, 96=Top50
  ; authors = number of authors to display: Top10, Top20 or Top50
  no = ListSize(author()) - 1      ; last element is empty (= -1) 
  If no < authors : authors = no : EndIf     ; be sure the list is at least as long, how many authors are available
  
  If authors < 10        ; we want to display at least 10 authors
    MessageRequester("Error","List is too short!",0)
  Else
    a = 1
    SetWindowTitle(#TopAuthorsWin,Language$(title))
    ClearGadgetItems(#TopAuthorList)
    For i=no To no-authors+1 Step -1      ; the top coders are placed at the end of the array, so we must use it in reverse order
      a$ = RSet(Str(a),2)+"." + Chr(10) + topcoders(i)\Name + Chr(10) + RSet(Str(topcoders(i)\Codes),3)
      AddGadgetItem(#TopAuthorList,-1,a$)
      a + 1
    Next
    HideWindow(#TopAuthorsWin,0)
    SetGadgetItemState(#TopAuthorList,0,#PB_ListIcon_Selected)           ; mark 1st author entry
    SetActiveGadget(#TopAuthorList)
;    MessageRequester(Language$(51),a$,#MB_ICONINFORMATION)
  EndIf
EndProcedure


Procedure CallForumLink(forum)
  If forum = #MainWinForumEnglish
    link$ = prefs$(5)
  ElseIf forum = #MainWinForumGerman
    link$ = prefs$(6)
  ElseIf forum = #MainWinForumFrench
    link$ = prefs$(7)
  ElseIf forum = #MainWinForumLounge
    link$ = prefs$(8)
  EndIf  
  RunProgram(link$)
EndProcedure



; *********************** Procedures for the main loop ******************************
Procedure.l GetCode()
  ; Function: detect the choosen item in #filetree or #resultlist and get the 
  ;           related array index number from the stored check() or check2() list.
  ; Will be called directly in the main loop by several 'action' buttons, like 
  ; 'Call Forum Thread', 'Show Source', etc.
  
  Shared ResultMode
  a = -1    ; if final result 'a' is also -1, then wasn't activated a source item !!!!

  If ResultMode = 1                  ; TreeGadget displayed
    c = GetGadgetState(#FileTree)
  Else                               ; ListIcon with found search items displayed
    c = GetGadgetState(#ResultList)
  EndIf

  If c > -1
    If ResultMode = 1    ; clicked item on #FileTree
      ResetList(check2())
      For b=0 To c
        NextElement(check2())
      Next
      a = check2()    ; if a = -1 then was clicked on a folder => don't do any actions
    Else                 ; clicked item on #ResultList (search function)
      ; OLD search function without LVSORT support (all items must stay in their direction)
      ; ResetList(check())
;       For b=0 To c
;         NextElement(check())
;       Next
;       a = check()

      a$ = GetGadgetText(#ResultList)
      ResetList(check3())
      Repeat
        NextElement(check3())
      Until check3()\File = a$
      a = check3()\FileID

    EndIf
  EndIf
  ProcedureReturn a
EndProcedure
; ************************************************************************************


Procedure.l CheckEditor(editor$)
  If MFileExists(editor$) = #False
    a$ = Language$(186)  +Chr(10)     ; couldn't found the editor under following path:
    a$ + editor$ +Chr(10)+Chr(10)     ; path of PB compiler
    a$ + Language$(187)               ; The path is set in the options
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      MessageRequester(Language$(74),a$,#MB_ICONWARNING)
    CompilerElse
      MessageRequester(Language$(74),a$)
    CompilerEndIf
    ProcedureReturn #False
  Else
    ProcedureReturn #True
  EndIf
EndProcedure


Procedure CallEditor(a$)
  ; a$ = (relative) path+filename
  
  ; because of some errors, when trying to load source files with relative path into the editor, we get the full path
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    b$=Space(512) 
    GetFullPathName_(a$,Len(b$),@b$,@c$)     ; c$ = dummy string for filepart
    a$ = PeekS(@b$) 
  CompilerElse
    Debug "CallEditor() procedure:"
    Debug "GetFullPathName() is only supported on MS Windows for now!"
  CompilerEndIf
  If prefs(17) = 1  ; use original editor
    b$ = prefs$(1)
  Else              ; use alternate editor
    b$ = prefs$(4)
  EndIf
  If CheckEditor(b$) = #True
    RunProgram(b$,#DQUOTE$+a$+#DQUOTE$,GetPathPart(b$))    ; Editor path / SourceFile / WorkingDir
  EndIf
EndProcedure


;- SystrayIcon
Procedure CAV2Tray()
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    AddSysTrayIcon (0, WindowID(#MainWindow), cavicon) 
    HideWindow(#MainWindow, 1) 
    SysTrayIconToolTip (0,Language$(210))       ; Double click for activating C.A.V.
  CompilerElse
    Debug "CAV2Tray() procedure:"
    Debug "Systray isn't supported/available on MacOS!"
  CompilerEndIf
EndProcedure


Procedure Tray2CAV()
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    RemoveSysTrayIcon(0) 
    HideWindow(#MainWindow, 0) 
    ;UseWindow(#MainWindow)
    SetForegroundWindow_(WindowID(#MainWindow))  
    ; ActivateWindow() don't show the window in the foreground
  CompilerElse
    Debug "CAV2Tray() procedure:"
    Debug "Systray isn't supported/available on MacOS!"
  CompilerEndIf
EndProcedure
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 254
; FirstLine = 241
; Folding = ----
; UseMainFile = CodeArchivViewer_Main.pb