; Taken from original PB Editor code
; File: Syntax Highlighting.pb
; Version: v3.91 - 4th July 2004

#NbASMKeywords = 232
#NbBasicKeywords = 72     ; taken from editor source: common.pb !!

Dim BasicKeywords.s(#NbBasicKeywords)
Dim BasicKeywordsHT.l(255)
Dim ASMKeywords.s(#NbASMKeywords)
Dim ASMKeywordsHT.l(255)


; OLD SIMPLE CODE without using hash table!!!
; Restore BasicKeywords
; For k=1 To #NbBasicKeywords
;   Read BasicKeywords(k)
;   Read dummy$
; Next

CurrentChar = 0
Restore BasicKeywords
For k=1 To #NbBasicKeywords
  Read BasicKeywords(k)
  Read dummy$
    
  Char = Asc(LCase(BasicKeywords(k)))
;  Debug char
  If Char <> CurrentChar
    BasicKeywordsHT(Char) = k
    CurrentChar = Char
  EndIf
Next


CurrentChar = 0
Restore ASMKeywords
For k=1 To #NbASMKeywords
  Read ASMKeywords(k)
  
  Char = Asc(LCase(ASMKeywords(k)))
  If Char <> CurrentChar
    ASMKeywordsHT(Char) = k
    CurrentChar = Char
  EndIf
Next
  


; Now we read the original PB functions


DataSection

  ;- Keywords - BASIC
  BasicKeywords:
    Data$ "And", "and"

    Data$ "Break", "break"

    Data$ "CallDebugger"     , "calldebugger"
    Data$ "Case"             , "case"
    Data$ "CompilerCase"     , "compilercase"
    Data$ "CompilerDefault"  , "compilerdefault"
    Data$ "CompilerElse"     , "compilerelse"
    Data$ "CompilerEndIf"    , "compilerendif"
    Data$ "CompilerEndSelect", "compilerendselect"
    Data$ "CompilerIf"       , "compilerif"
    Data$ "CompilerSelect"   , "compilerselect"
    Data$ "Continue"         , "continue"

    Data$ "Data"           , "data"
    Data$ "DataSection"    , "datasection"
    Data$ "Debug"          , "debug"
    Data$ "DebugLevel"     , "debuglevel"
    Data$ "Declare"        , "declare"
    Data$ "DeclareCDLL"    , "declarecdll"
    Data$ "DeclareDLL"     , "declaredll"
    Data$ "Default"        , "default"
    Data$ "DefType"        , "deftype"
    Data$ "Dim"            , "dim"
    Data$ "DisableDebugger", "disabledebugger"

    Data$ "Else"              , "else"
    Data$ "ElseIf"            , "elseif"
    Data$ "EnableDebugger"    , "enabledebugger"
    Data$ "End"               , "end"
    Data$ "EndDataSection"    , "enddatasection"
    Data$ "EndEnumeration"    , "endenumeration"
    Data$ "EndIf"             , "endif"
    Data$ "EndInterface"      , "endinterface"
    Data$ "EndProcedure"      , "endprocedure"
    Data$ "EndSelect"         , "endselect"
    Data$ "EndStructure"      , "endstructure"
    Data$ "EndStructureUnion" , "endstructureunion"
    Data$ "Enumeration"       , "enumeration"
    Data$ "Extends"           , "extends"

    Data$ "FakeReturn"   , "fakereturn"
    Data$ "For"          , "for"
    Data$ "ForEach"      , "foreach"
    Data$ "ForEver"      , "forever"

    Data$ "Global", "global"
    Data$ "Gosub" , "gosub"
    Data$ "Goto"  , "goto"

    Data$ "If"            , "if"
    Data$ "IncludeBinary" , "includebinary"
    Data$ "IncludeFile"   , "includefile"
    Data$ "IncludePath"   , "includepath"
    Data$ "Interface"     , "interface"


    Data$ "NewList", "newlist"
    Data$ "Next", "next"

    Data$ "Or", "or"

    Data$ "Procedure"      , "procedure"
    Data$ "ProcedureCDLL"  , "procedurecdll"
    Data$ "ProcedureDLL"   , "proceduredll"
    Data$ "ProcedureReturn", "procedurereturn"
    Data$ "Protected"      , "protected"

    Data$ "Read", "read"
    Data$ "Repeat", "repeat"
    Data$ "Restore", "restore"
    Data$ "Return", "return"

    Data$ "Select", "select"
    Data$ "Shared", "shared"
    Data$ "Static", "static"
    Data$ "Step", "step"
    Data$ "Structure", "structure"
    Data$ "StructureUnion", "structureunion"
    
    Data$ "To", "to"

    Data$ "Until", "until"

    Data$ "Wend" , "wend"
    Data$ "While", "while"

    Data$ "XIncludeFile" , "xincludefile"

  ;- Keywords - ASM
  ASMKeywords:
    Data$ "AAA"
    Data$ "AAD"
    Data$ "AAM"
    Data$ "AAS"
    Data$ "ADC"
    Data$ "ADD"
    Data$ "AND"
    Data$ "ARPL"
    
    Data$ "BOUND"
    Data$ "BSF"
    Data$ "BSR"
    Data$ "BSWAP"
    Data$ "BT"
    Data$ "BTC"
    Data$ "BTR"
    Data$ "BTS"
    
    Data$ "CALL"
    Data$ "CBW"
    Data$ "CDQ"
    Data$ "CLC"
    Data$ "CLD"
    Data$ "CLI"
    Data$ "CLTS"
    Data$ "CMC"
    Data$ "CMP"
    Data$ "CMPS"
    Data$ "CMPXCHG"
    Data$ "CWD"
    Data$ "CWDE"
    
    Data$ "DAA"
    Data$ "DAS"
    Data$ "DB"
    Data$ "DD"
    Data$ "DEC"
    Data$ "DIV"
    Data$ "DW"
    
    Data$ "ENTER"
    Data$ "ESC"
    
    Data$ "F2XM1"
    Data$ "FABS"
    Data$ "FADD"
    Data$ "FCHS"
    Data$ "FCLEX"
    Data$ "FCOM"
    Data$ "FDIV"
    Data$ "FDIVR"
    Data$ "FFREE"
    Data$ "FINCSTP"
    Data$ "FINIT"
    Data$ "FLD"
    Data$ "FLD1"
    Data$ "FLDCW"
    Data$ "FMUL"
    Data$ "FNOP"
    Data$ "FPATAN"
    Data$ "FPREM"
    Data$ "FRNDINT"
    Data$ "FSAVE"
    Data$ "FSCALE"
    Data$ "FSETPM"
    Data$ "FSIN"
    Data$ "FSQRT"
    Data$ "FST"
    Data$ "FSTENV"
    Data$ "FSTSW"
    Data$ "FSUB"
    Data$ "FSUBR"
    Data$ "FTST"
    Data$ "FUCOM"
    Data$ "FWAIT"
    Data$ "FXAM"
    Data$ "FXCH"
    Data$ "FXTRACT"
    Data$ "FYL2X"
    Data$ "FYL2XP1"
    
    Data$ "HLT"
    
    Data$ "IDIV"
    Data$ "IMUL"
    Data$ "IN"
    Data$ "INC"
    Data$ "INS"
    Data$ "INT"
    Data$ "INTO"
    Data$ "INVLPG"
    Data$ "IRET"
    Data$ "IRETD"
    
    Data$ "JA"
    Data$ "JAE"
    Data$ "JB"
    Data$ "JBE"
    Data$ "JC"
    Data$ "JCXZ"
    Data$ "JE"
    Data$ "JECXZ"
    Data$ "JG"
    Data$ "JGE"
    Data$ "JL"
    Data$ "JLE"
    Data$ "JMP"
    Data$ "JNA"
    Data$ "JNAE"
    Data$ "JNB"
    Data$ "JNBE"
    Data$ "JNC"
    Data$ "JNE"
    Data$ "JNG"
    Data$ "JNGE"
    Data$ "JNL"
    Data$ "JNLE"
    Data$ "JNO"
    Data$ "JNP"
    Data$ "JNS"
    Data$ "JNZ"
    Data$ "JO"
    Data$ "JP"
    Data$ "JPE"
    Data$ "JPO"
    Data$ "JS"
    Data$ "JZ"
    
    Data$ "LAHF"
    Data$ "LAR"
    Data$ "LDS"
    Data$ "LEA"
    Data$ "LEAVE"
    Data$ "LES"
    Data$ "LFS"
    Data$ "LGDT"
    Data$ "LGS"
    Data$ "LIDT"
    Data$ "LLDT"
    Data$ "LMSW"
    Data$ "LOCK"
    Data$ "LODS"
    Data$ "LODSB"
    Data$ "LODSW"
    Data$ "LODSD"
    Data$ "LOOP"
    Data$ "LOOPE"
    Data$ "LOOPNE"
    Data$ "LOOPNZ"
    Data$ "LOOPZ"
    Data$ "LSL"
    Data$ "LSS"
    Data$ "LTR"
    
    Data$ "MOV"
    Data$ "MOVS"
    Data$ "MOVSX"
    Data$ "MOVZX"
    Data$ "MUL"
    
    Data$ "NEG"
    Data$ "NOP"
    Data$ "NOT"
    
    Data$ "OR"
    Data$ "OUT"
    Data$ "OUTS"
    
    Data$ "POP"
    Data$ "POPA"
    Data$ "POPAD"
    Data$ "POPF"
    Data$ "POPFD"
    Data$ "PUSH"
    Data$ "PUSHA"
    Data$ "PUSHAD"
    Data$ "PUSHF"
    Data$ "PUSHFD"
    
    Data$ "RCL"
    Data$ "RCR"
    Data$ "REP"
    Data$ "REPE"
    Data$ "REPNE"
    Data$ "REPNZ"
    Data$ "REPZ"
    Data$ "RET"
    Data$ "RETF"
    Data$ "ROL"
    Data$ "ROR"
    
    Data$ "SAHF"
    Data$ "SAL"
    Data$ "SAR"
    Data$ "SBB"
    Data$ "SCAS"
    Data$ "SETAE"
    Data$ "SETB"
    Data$ "SETBE"
    Data$ "SETC"
    Data$ "SETE"
    Data$ "SETG"
    Data$ "SETGE"
    Data$ "SETL"
    Data$ "SETLE"
    Data$ "SETNA"
    Data$ "SETNAE"
    Data$ "SETNB"
    Data$ "SETNC"
    Data$ "SETNE"
    Data$ "SETNG"
    Data$ "SETNGE"
    Data$ "SETNL"
    Data$ "SETNLE"
    Data$ "SETNO"
    Data$ "SETNP"
    Data$ "SETNS"
    Data$ "SETNZ"
    Data$ "SETO"
    Data$ "SETP"
    Data$ "SETPE"
    Data$ "SETPO"
    Data$ "SETS"
    Data$ "SETZ"
    Data$ "SGDT"
    Data$ "SHL"
    Data$ "SHLD"
    Data$ "SHR"
    Data$ "SHRD"
    Data$ "SIDT"
    Data$ "SLDT"
    Data$ "SMSW"
    Data$ "STC"
    Data$ "STD"
    Data$ "STI"
    Data$ "STOS"
    Data$ "STR"
    Data$ "SUB"
    
    Data$ "TEST"
    
    Data$ "VERR"
    Data$ "VERW"
    
    Data$ "WAIT"
    Data$ "WBINVD"
    
    Data$ "XCHG"
    Data$ "XLAT"
    Data$ "XLATB"
    Data$ "XOR"
    
EndDataSection
; ExecutableFormat=Windows
; CursorPosition=47
; FirstLine=1
; EOF