; C.A.V. - PureBasic CodeArchiv Viewer
; ************************************
; Written & Copyright July 2004 - September 2009 by Andr Beer
; Version: 1.2 beta

; History:
;   June 2004: started first version, just a bit try & error ;-)
;   10th July 2004: added syntax higlighting data for search function
;   17th August: continued with adding more source from the CodeArchiv generator
;   18th-20th August: done a lot more work: TreeGadget, all preferences stuff, first search routines
;   10th Sep 2004: solved the "bug" that the search-function has 0 results every second time!!! :-)
;                  ClearList() instead of calling "NewList check.l()" every time must be done...
;   15th Oct 2004: after slightly modifications the last weeks (no time, sadly :-(
;                  today was added the first code for getting the clicked items in #FileTree or #ResultList
;                  (be aware of the now set ResultMode variable!)
;                  added keyboard shortcuts for all #MainWin menuitems
;   16th Oct 2004: EditorGadget added    --> set cursor pos to 1,1 must be done!!!!!
;   17th Oct 2004: finished the integration of the EditorGadget, added FrameTitle with name,path,description
;                  fixed the TreeGadget refresh bug!!! :-)
;   30th Oct 2004: added loading/checking for 'OS' and 'Demo' flags in sourcecodes + display in ListIcon after search
;   31st Oct 2004: additional infos after author name (in brackets of after comma) cutted, so the author list is shorter now
;                  added Top10, Top20, Top50 author lists with direct link to search function
;   01st Nov 2004  fixed several smaller handling + refreshing bugs, added display of search-results number, started full-text search
;   03rd Nov 2004  completed fulltext string parser ala Google.de, support phrases ("..."), AND (+), NOT (-) and normal OR modus
;   04th Nov 2004  included the CAV Logo in the main window. But this caused a crashed at program start (loading routines),
;                  so I switched the ProgressBar "Load in progress...." from ProgressBarEx userlib to included PB commands
;                  Finally finished the search function :-)
;                  Added more translations (Locale-strings) for About window and error messages in search routine
;   05th Nov 2004  Done the english localization strings, 
;                  included a small search routine for '_(' in code which indicate a probably sign for an API command sign
;   06th Nov 2004  Added Return handler for all gadgets in main window (only the editable combobox of SourceForum doesn't work)
;                  Added checks for valid date entries in the search terms
;   07th Nov 2004  Added WinAPI functions in the keyword selection for full-text search, all the more than 7000 natively in PB 
;                  supported WinAPI functions!!!
;                  Added PB constants in the keyword selection window
;                  Added support for french forum in the search function (source field)
;   28th Nov 2004  Added "Show sourcecode in editor"
;   10th Dec 2004  Added the CavLogo image to the "load in progress" window,
;                  added support for change locale language during runtime
;   11th Dec 2004  Completed all prefs stuff, including auto-saving of all preferences at program-end if set in preferences
;                  to be done: last choosen mode: treeview or listicon or editor
;   18th Dec 2004  Finished the localization with adding a lot more GadgetToolTipps
;   01st Jan 2005  Added a requester at program end: asks, if the (changed) prefs should be saved to disk
;                  Added the 'More informations' window
;   02nd Jan 2005  Fixed the bug, the sourcecodes do not always open in the PB by editor by changing the relative paths 
;                  to full paths using GetFullPathName_()
;                  Changed the Prefs-Window structure by including a PanelGadget with 3 sections, also
;                  new functions like "Create Desktop / Startmenu shortcuts" added
;   15th Jan 2005  CheckInstance added to avoid several program starts
;   16th Jan 2005  Added prefs and handling settings for using an alternate editor tool like jaPBe
;                  Integrated Tommeh's CodeTester tool for code testing with actual PB compiler
;   02nd Feb 2005  Refreshing problems of TreeGadget and PureArea.net Logo fixed because of new Gadget libs by Fred :-)
;                  Added quotes around the filename at RunProgram in the CallEditor() procedure to avoid problems with
;                  users, which have spaces in their directory names (like "CodeArchiv beta").
;                  Added "PureBasic.exe" to the initial prefs path, if no .prefs file exist at (first) start.
;                  Frame3DGadget in general prefs window changed to normal mode (no #Double) to be more stylish [Fred's wish]  ;-)
;   03rd Feb 2005  Included support for LeftDoubleClick in Tree and ListIcon => shows directly the selected code in CAV window [Rings+David's wish]
;                  With a right-click in EditorGadget (code is shown) we go back to previous mode (tree or listicon)
;   05th Feb 2005  Fixed the bug with highlighting found search items (if the item to colorize is exactly at the end of a line, 
;                  then the next line were will also be colored.) => the trick was to add a space to each line in LoadSource() code.
;                  Fixed the bug in keyword selection with adding a WinCallback(): #AuthorWin and #KeyWin are now fully working
;                  (Selection with leftmouse-click on an item or via return on a choosen item, with Esc the selection can be 
;                   cancelled and also scrollbar now works correctly, means only scrolling, no selection anymore then. Thanks to David!)
;                  Added Return-Handler for all senseful gadget in PrefsWindow
;   25th Feb 2005  Fixed little bug: when saving of preferences at program end was enabled, it always asked before quit (even when disabled)
;   12th Mar 2005  Started work on syntax-highlighting of the code examples in EditorGadget
;   13th Mar 2005  Completed a first simple version of syntax-highlighting, it does highlight PB keywords, PB commands and constants
;   24th Mar 2005  Completed syntax-highlighting, which now support PB keywords + functions, ASM commands, WinAPI functions and contants
;   25th Mar 2005  Added all prefs stuff for setting individual colors for editor/codeviewer background as well for syntax-highlighting,
;                  problem/bug left: syntax-highlighting work only with debugger on !!!!???? holly shit! ;-)
;   27th Mar 2005  Updated all PBFunctions/Constants to PB3.93
;                  Adapted the CodeTester tool to PB3.93 and added some more features
;   28th Mar 2005  Completely changed the syntax-highlighting engine from my self-written to the one of the new PB IDE (thanks to fr34k!)
;                  Added new Gadget-Tooltips as nice bubble-help (code by Sparkie), started to use #OS compiler directives for
;                  later portability.
;   29th Mar 2005  Added ChangeTooltip() (it seems that also normal GadgetTooltip() work for this) and RemoveTooltip() procedures
;                  to the new BubbleHelp
;                  Added the #PB_Compiler_Date output (date/time of compile) to the About-Window
;                  Added MessageRequesters for creating shortcuts on desktop/quicklaunch, showing if the actions were sucussful or not
;   30th Mar 2005  Further improved the CodeTester with more options
;   01st Apr 2005  Changing of german/french dir descriptions in FileTree now also work, if Preferences (language or selection) are changed
;                  Added all other missing localization in Prefs window + Result-list
;   02nd Apr 2005  Added a minimize button in #MainWindow for sending CAV to tray (see procedures CAV2Tray(), Tray2CAV() and code in callback
;                  Added missing translation of source filenames in FileTree (german only, as its the only available translation now)
;                  Added a CheckForSourceKeywords() procedure to exclude this keywords from Search function (else "Windows" would be found in nearly every source)
;   14th May 2005  Fixed the not working systray icon (there was just the same image ID used than for preferences color pics... now its ID=10)
;                  Added ts-soft & team to the about window for their help to update old CodeArchiv for PB3.93 :-)
;   15th May 2005  Updated the CodeTester:
;                    'cont' variable is set back to 0 now, when CodeTester window was closed, so next time the "checking all codes" starts from
;                    first code example or from user-selected one
;                    Added "InlineASM support" when compiling as optional parameter now  (avoid several useless compiler errors, when no InlineASM is used in code)
;                    All settings in the CodeTester window are now stored in the preferences file
;                    Added keyboard support for CodeTester window (with Return you can now choose the buttons)
;                  Added a "date range" selector box, enables you to search for codes with exact matching date and NEW also for older/newer codes than selected
;                  Added a Return handler for EditorGadget - pressing return will bring you back to previous treegadget/listicon
;   16th May 2005  Fixed the BalloonTooltip problems with adding following line to each gadget event:
;                    CompilerIf #os = #windows : ChangeToolTip(TTHandles(16) ,#PureAreaPic, Language$(140)) : CompilerEndIf
;                    It looks more like a workaround now, but it does the trick  ;-)  Better ideas are welcome!
;                  Added returnhandler and doubleclick support to the TopAuthorsWindow
;                  Added OS flags to the "SearchResults" Listicon: W L M A stands for Windows, Linux, MacOS, AmigaOS compatibility (must be written in the source 
;                    with the "OS: xxxx" tag on 4th line
;                  Fixed a little focus problem: after closing the author and keyword selection windows the focus is now set to the corresponding stringgadget
;                  Changed a bit the GUI layout for the new "date range" combobox - its now included in the row of day/month/year, not before the "Date" text anymore
;                  Added OpenHelp() function for opening the CAV.chm help (not context-sensitive for now)
;                  The prefs settings for the ListIcon (search-results) are now included: you can enable/disable the columns OS, Demo and Description
;                    (If 'Description' is disabled, there will be some more space for the columns 'Name' and 'Dir' - they will be resized automatically)
;                  *** The feature list for v1.0 is now 99,9% done and the CAV is ready (?) to release with the coming new CodeArchive, at least I've removed the "beta" ***
;   11th Jun 2005  Fixed a little bug: added a missing "FastCloseTextFile" in the CheckLanguages() procedure
;                  added 'Droopy' as corrector of french locale file
;   12th Jun 2005  Fixed the SetLanguages procedure, also added one more missing FastCloseTextFile() in prefs 
;                  Also done a bit more fixing with the BalloonTooltips, only some small problems remain
;   17th Jul 2005  Added a prefs setting for the search-term color
;                  Added support for sorting the SearchResults ListIcon using the PURE_LVSORT userlib by gnozal, added him to the about window
;                  Added support for loading .chm manuals depending on locale language (uses english.chm as standard)
;                  *** FIRST PUBLIC RELEASE AS PREVIEW VERSION 2.0 ***
;   07th Aug 2005  Added Franky in the credits
;   15th Nov 2005  Added a new prefs setting: use normal tooltips or BubbleHelp tooltips
;                  Added GetToolBarButtonState() / SetToolBarButtonState() as new PB3.94 commands, also updated the WinAPI function listing to latest state
;                  so now supported PB version is 3.94; CAV version 1.0 / November 2005
;   21th Aug 2006  Started converting the CAV source to PB4.00
;   25th Dec 2006  After a longer break, the converting of the code to PB4.00 was finally finished today, but now some 
;                  bugs must be removed (e.g. filling of the TreeGadget is broken with the PB v4 syntax change).
;                  Added credits for converting CodeArchiv to PB v4 (blbltheworm, ....)
;                  Changed TopAuthors list, so that "Unknown" isn't recognized as a real author
;                  Extended the CheckForSourceKeywords() procedure to cut also additional PB4 IDE settings from source
;   28th Dec 2006  Fixed the TreeGadget, updated the include files for PB functions, WinAPI functions and PB constants
;   29th Dec 2006  Updated the PB keywords and ASM keywords to latest v4 status, fixed the broken CheckOS and CheckDemo routines
;   30th Dec 2006  Extended the fulltext-search with searching in the source file names :)
;   01st Jan 2007  Made the filename search optional an included specific prefs checkbox
;                  Added a new optional feature: only demo-compatible codes can be showed in FileTree or search-results
;                  Available number of demo-compatible codes will now be showed in main window and about windows
;   02nd Jan 2007  Added links to the three main PB forums to the mainwindow menu, also adjustable in the prefs
;   05th Jan 2007  Added the PureBasic-Lounge.de to the code "sources" (forums)
;                  Several small bugs solved (e.g. "array out of bounds", when locale file is missing)
;   06th Jan 2007  Fixed a bug in TreeGadget code (some codes were included in sub-nodes, but belong to one level higher)
;   12th Jan 2007  Workaround for the sometimes missing EditorGadget() scrollbars by extending the RefreshGadget() procedure
;   13th Apr 2007  Some improvements as well bug-fixing before the final release ;-)
;                  Adding/removing of OS/Demo/Description fields in the SearchResults listicon works now without problems.
;                  Changing of the language will now also be reflected by the listicon contents with the searchresults
;                  Changed all API GetFocus_() to PB native GetActiveGadget() in the eventhandler routine
;                  Fixed the ESC handling in the CodeTester to break the "Test all codes" routine
;   29th Apr 2007  Some better handling added to the CodeTester, reworked the RunProgram() sections to allow breaking with Esc
;   05th May 2007  Updated french localization (by gnozal) included
;                  Created the v1.1 version for release with the "CodeArchiv v4 Beta"
;   07th May 2007  Fixed a bug in the loading routine for locale files
;
;  ... after longer break:
;   26th Aug 2009  Started adapting the source to PB4.40 and make it work on MacOS :-)
;   31th Aug 2009  Completed MacOS conversion - of course with restricted functions (e.g. no CodeTester available), and there
;                  are errors (IMAs) when executing
;   22th Sep 2009  Stopped the 'EnableExplicit" reworking (currently not all variables must be declared first - just like it 
;                  originally was..." + tried to make the code running on MacOS, for now we get an IMA in the "_CheckFiles.pb"
;                  routines with checking/building the TopAuthors list... committing to SVN now for further checking in Windows.
;   23th Sep 2009  Some small adaptions to PB4.40 beta2 ---> CAV runs fine on Windows XP using PB4.40 :o)
;   27th Sep 2009  Replaced David's find_var() procedure for building the Top-Authors list by a new one, which made the CAV
;                  run on MacOS for the first time!  :o)
;                  Reworked the GUI proportions in MainWin + PrefsWin to have a proper GUI on MacOS too.

; ToDo list:
; **********************************************************************************

; Features to be added / completed:
; ---------------------------------

; - Maybe use PUREResize userlib by gnozal to make the whole GUI auto-resizing with activated #PB_Window_SizeGadget flag

; - additional option to set ListIcon columns to 'Auto-sized' width


; ** Prefs stuff:
;   - last choosen mode: treeview or listicon or editor
;   - save also the user-set columns width in search ListIcon

; - display the search items in the ListIcon in multi-color (two different colors for every 2nd row, use the userlib!!)

; - also search in german (+ other languages, if available) code descriptions, when using the fulltext-search

; - don't highlight the searchterms in the source, if coming from TopXX list or TreeGadget

; - call the forum thread in a separeate window (don't overwrite opened IE explorer windows/websites
;   (example from german forum: http://robsite.de/php/pureboard/viewtopic.php?t=427&highlight= 
;    RunProgram("explorer","http://www.Pure-Board.de","") 
;
; - of course a proper .CHM help file (nothing happens at the moment when choosing the menu item)


; ****************************************************************************
; Known bugs to be resolved:
; ****************************************************************************

; Little (?) bug with the BubbleHelp:
; - After activating a ComboBox or a StringGadget the bubblehelp for these gadgets don't work anymore.
;   Maybe the event detection is affected by my self-written Get/SetFocus_() code !?
;   (see difference between standard PB tooltips and the self-created ones by enabling the #os = #windows
;   *** Addition on 16th May 2005 by Andre: have done a workaround with ChangeToolTip() each time the gadget is called ***


; Scrollbars in EditorGadget are sometimes missing
; - also when sourcecodes are longer than actual display of EditorGadget (#EditorSource) can display,
;   there are often missing the scrollbars => a bug of EditorGadget with ReadOnly flag ?

; PB Bug found [5th Feb 2005]: 
;   Global variables need to be declared before their first use. Else they won't be recognized, at least not inside 
;   procedures. Look at the "Global author_changed.l ... etc." declarations and move them in front of the WinCallback()
;   procedure. You will notice, that values of authorwin_shown and keywin_shown will not reach the callback procedure.

; Which is NO bug, more a feature ;-)    (reported by Team100 per email on 14-Feb-2005)
;   Fulltext-search: searchterm = "chr -chr(13)"
;   In the results there is also "GetFileAttributes.pb" displayed, where Chr(13) is included in sourcecode
;   This is no error, because the first "chr" in searchterm is combined as a OR-search with the other "-chr(13)",
;   this means (as it is normally when combining search terms with OR) the search is true, because of the found "chr"


;EnableExplicit

Define MutexHandle.l

;- Developer flag
#dev = #True ;#true ; set to #False when compiling the final exe !!!

; Development platform to compile CAV for:
#windows = 1 : #linux   = 2

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  #os = #windows    
  ; Set to #linux would deactivate special WinAPI calls, whenever possible - or use other Linux specific code
  ; currently this would be:
  ; - Use of FastFile userlib
  ; - Nice BubbleHelp tooltips on Windows
CompilerElse
  #os = #linux
CompilerEndIf


; Using of the PUREResize userlib by gnozal for some gadget resizing
#resize = #False    ; set to #true will activate the resizing, else use #False


#version = "v1.2 beta"
#pbversion = "v4.40"
#maxfiles = 3000      ; maximum number of supported source files in CodeArchiv
#wintitle = "C.A.V. - CodeArchivViewer "+#version+" - (c) 2004-2009 by Andr Beer / PureBasic-Team"

Procedure.l CheckInstance(MutexName.s)
  ; OnlyOne(MutexName.s) is copied from TS-ShutDown source 
  Protected Result.i
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    Result.i = CreateMutex_(0, 0, MutexName)
    If GetLastError_() = #ERROR_ALREADY_EXISTS
      ReleaseMutex_(Result)
      CloseHandle_(Result)
      ; **** Added by Andre to activate the already excisting C.A.V. window ********
      handle=FindWindow_(0,#wintitle) 
      If IsWindow_(handle)
        SetForegroundWindow_(handle)
      EndIf
      ; ****************************************************************************
      End
    EndIf
  CompilerElse
    Debug "CheckInstance() procedure:"
    Debug "Checking for 'Only one instance started!?' can only be done on MS Windows for now!"
  CompilerEndIf
  ProcedureReturn Result
EndProcedure
MutexHandle.l = CheckInstance("CodeArchivViewer")


;- Declare Variables/lists
Global Lang, path$, prefspath$, localepath$, exepath$, MainWin, tree, prefssaved, localeauthor$
Global files.l, demofiles.l   ; save number of scanned PB files for later usage / demofiles = counter for demo-compatible files
Global DS$   ; DirectorySeparator (Windows = '\', MacOS = '/'

Define a, b, x, WinID, a$, Dir, k
Define Lines, coders, Char, CurrentChar

; These global variables are needed in the WinCallback() procedure later,
; which is handling all events of the selection windows for #AuthorWin and #KeyWin
Global author_changed.l, key_changed.l, authorwin_shown.l, keywin_shown.l 

Define cont = -1    ; initial value for the CodeTester (-1 means all codes must be checked)
Global progID   ; contains the value of the actual program started with the CodeTester, if one is running at the end it must be killed

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  DS$ = "\"  ; DirectorySeparator (Windows = '\', MacOS = '/'
CompilerElse
  DS$ = "/"
CompilerEndIf

  
prefssaved=#False

Global NewList check.l()   ; declaring the linked list for search function here, because later must be used ClearList() 
                     ; => this solved the "bug" that the search function worked every second time. An email to 
                     ;    Fred describing the problem and requesting an compiler warning/error done one 10-Sep-2004
Global NewList check2.l()  ; another list for storing the items (with type path or source) of the #FileTree


;- PURE_LVSORT support
;CompilerIf #PB_Compiler_OS = #PB_OS_Windows
; needed for sorting support in #ResultList listicon
Structure infoshort
  FileID.l   ; ID of the file in the filesinfo() list structure
  File.s     ; FileName of the file in the filesinfo() list
EndStructure
Global NewList check3.infoshort()
;CompilerEndIf


; set structure and LinkedList for parsing search term
Structure searchterm
  term.s             ; search-term to search for
  valid.l            ; 0 = OR, search is true if the searchterm appears   (it was entered a SPACE in front of the term)
                     ; 1 = AND, search is only true, if the searchterm appears beside the other terms  (it was entered a '+' in front)
                     ; 2 = NOT, search is only true, if the searchterm DOESN't appear  (it was entered a '-' in front)
  found.l            ; is a flag which is only needed for several AND searchitems, where all must be true to give a result                   
EndStructure
Global NewList searchterms.searchterm()

Procedure.s ExeFilename()
  ProcedureReturn GetFilePart(ProgramFilename())
EndProcedure

Procedure.s ExePath()
  ProcedureReturn GetPathPart(ProgramFilename())
EndProcedure

exepath$ = ExePath()
Define exename$ = ExeFileName()

                     
CompilerIf #dev
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    path$ = "..\Codes\"     ; relative path during development, in final version this string must be empty!!!!
  CompilerElse
    path$ = "/Users/geoworld/CodeArchiv/Codes/"
  CompilerEndIf
CompilerElse
  path$ = exepath$
CompilerEndIf

prefspath$ = path$+"xCAV"+DS$      ; set the path of the CAV's directory (preferences, program files, localization, ...)
localepath$ = prefspath$+"Languages"+DS$   ; set the path to the language files
Define manualpath$ = prefspath$+"Manuals"+DS$     ; set the path to the manual files


Lang = 1   ; set program language: 0 = english, 1 = german, 2 = french, 3 = .... other  
           ; (setting 0-2 is also valid for the file/dir translations, setting 3 and higher 
           ;  only for localization of the GUI)
Global NewList languages.s()    ; create a linked-list for storing the name of the locale files
                          ; (1st+2nd are included and will be english + german, 3rd and more will be loaded from languages dir)


Global ResultMode = 1    ; main display of CAV: 1 = TreeGadget, 2 = ListIcon with SearchItems, 3 = EditorGadget with Programmcode
Define TopAuthorSearch = #False    ; if set to #True all other search terms will be ignored


;- Declare Procedures  (where its not possible to avoid)
Declare CreateMainMenu()
;Declare RefreshWindow()



;- *INCLUDE-Files
XIncludeFile "CodeArchivViewer_Locale.pb"
XIncludeFile "CodeArchivViewer_Constants.pb"
XIncludeFile "CodeArchivViewer_Prefs.pb"         ; prefs window will be initialized


;- CAV-Logo Include
Global cavlogo.l, cavicon.l
UseJPEGImageDecoder() 
cavlogo = CatchImage(0, ?LogoX)
cavicon = CatchImage(10, ?IconX)
DataSection
  LogoX: IncludeBinary "cav.jpg"
  IconX: IncludeBinary "cav.ico"
EndDataSection


;- Init ProgressBar
#UseProgressExLib = #False     ; HERE we adjust, if the userlib should be used or not (in-built progressbar instead)

#ProgressWin = 4

Enumeration
  #ProgressTitle
  #ProgressBar
  #ProgressText
  #ProgressCAV
  #ProgressLogo
  #ProgressFrame
EndEnumeration

x=163

WinID=OpenWindow(#ProgressWin, 0, 0, 366, 130, "", #PB_Window_BorderLess|#PB_Window_ScreenCentered); Language$(37))  ; #PB_Window_TitleBar
If WinID
  CompilerIf #UseProgressExLib = #True     ; we use the ProgessBarEx userlib, which probably cause a crash with included CAV logo image
    #PB_ProgressBarEx_Flat    =$002
    InitProgressBarEx(WinID)
    ProgressBarEx(#ProgressBar,x,48,180,30,0,100,RGB(255,0,255),RGB(0,255,128),RGB(200,128,200),0,#PB_ProgressBarEx_Flat)
  CompilerElse                             ; we don't use the userlib, the included ProgressBar command instead
    ProgressBarGadget(#ProgressBar, x, 48, 180, 30, 0, 100)
  CompilerEndIf
  Frame3DGadget(#ProgressFrame,  3,  3, 360, 123, "", #PB_Frame3D_Double)
  ImageGadget  (#ProgressLogo , 13, 25, 140, 80, cavlogo)
  TextGadget   (#ProgressTitle,  x, 10, 180, 30, Language$(37), #PB_Text_Center)   ; Title ...
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    SetGadgetFont(#ProgressTitle, LoadFont(1, "Arial", 9, #PB_Font_Bold))      ;   ... will be displayed bold
  CompilerEndIf
  TextGadget   (#ProgressText ,  x, 83, 180, 30, Language$(38), #PB_Text_Center)   ; CodeArchiv will be scanned
EndIf

;Delay(3000)

Procedure SetLoadProgress(x)
  CompilerIf #UseProgressExLib = #True     ; we use the ProgessBarEx userlib, which probably cause a crash with included CAV logo image
    SetProgressBarEx(#ProgressBar,x,Str(x)+"%",RGB(0,0,255))
  CompilerElse                             ; we don't use the userlib, the included ProgressBar command instead
    SetGadgetState(#ProgressBar,x)
  CompilerEndIf
  While WindowEvent() : Wend
  Delay(150)
EndProcedure

x=5
SetGadgetText(#ProgressText,Language$(68))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_Prefs.pb"         ; prefs window will be initialized

x=10
SetGadgetText(#ProgressText,Language$(38))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_LoadTranslations.pb"    ; scan files in the CodeArchiv...

x=20
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_ScanFiles.pb"    ; scan files in the CodeArchiv...

x=30
SetGadgetText(#ProgressText,Language$(39))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_CheckFiles.pb"    ; ... and load forum, author and date informations

x=60
SetGadgetText(#ProgressText,Language$(41))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_PBFunctions.pb"  ; load PB functions

x=70
SetGadgetText(#ProgressText,Language$(121))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_PBConstants.pb"  ; load PB constants

x=75
SetGadgetText(#ProgressText,Language$(117))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_WinAPIFunctions.pb"  ; load WinAPI functions

x=80
SetGadgetText(#ProgressText,Language$(40))    ; <===== maybe change the locale string !!!!! *******
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_LoadSource.pb"
; This is not needed anymore, because PB keywords and ASM keywords are directly included
; in the Highlighting engine:
;XIncludeFile "CodeArchivViewer_Keywords.pb"     ; load PB keywords and ASM keywords


x=90
SetGadgetText(#ProgressText,Language$(42))
SetLoadProgress(x)
XIncludeFile "CodeArchivViewer_Gui.pb"           ; main window will be initialized

x=95
SetLoadProgress(x)
CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  XIncludeFile "CodeArchivViewer_CodeTester.pb"      ; Tommeh's code tester tool integrated in C.A.V.
CompilerElse
  Debug "The CodeTester is only supported on MS Windows, so it will not be included on MacOS!"
CompilerEndIf
; 


;Delay(10000)


;- Open PrefsWindow
OpenPrefsWin()      ; open the hidden preferences window


x=100
SetLoadProgress(x)

CloseWindow(#ProgressWin)



;- Open MainWindow
Open_MainWindow()    ; main window is invisible at the start to have time filling the comboboxes...
FillComboBoxes()
SetComboBoxStatus()

If prefs(8) = #True     ; automatic saving of prefs is enabled
  SetGadgetState(#SearchSourceInput,prefs(10))
  SetGadgetText (#SearchAuthorInput,prefs$(2))
  SetGadgetState(#SearchDateRange,prefs(34))
  SetGadgetState(#SearchDateDay,prefs(11))
  SetGadgetState(#SearchDateMonth,prefs(12))
  SetGadgetState(#SearchDateYear,prefs(13))
  SetGadgetText(#SearchFullInput,prefs$(3))
Else
;  Debug prefs(8)
EndIf



OpenAuthors()       ; load the hidden authors selection window
; UseWindow(#MainWindow)
; ActivateWindow()
OpenKeywords()      ; load the hidden keywords selection window  (take some time, so we do this only one time at start and later show/hide the window)

OpenTopAuthors()    ; open TopXX authors window


;- Callback
; The following callback code is needed to avoid the problems with handling the events
; in the #AuthorWin and #KeyWin windows.
; Thanks to David for his help !!! [5th Feb 2005]

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  Procedure.l WinCallback(hwnd.l, Message.l, wParam.l, lParam.l)
    Define.l   result
    Define.l   control_id
    Define.l   notification
      
    result = #PB_ProcessPureBasicEvents 
  
    ; Handle the events of the PureLVSORT userlib by gnozal too
    ;result = PureLVSORT_CallBack(WindowID, Message, wParam, lParam, result) ; <-------- add this line in your window callback
  
  
    ; Send CAV to the Systray when the minimize button was clicked!  (Added 1st April 2005 by Andre)
    If IsWindow(#MainWindow) And hwnd = WindowID(#MainWindow)
      If Message = #WM_SIZE And wParam = #SIZE_MINIMIZED
        CAV2Tray()
      EndIf
    EndIf
    
    If IsWindow(#CodeTesterWin) And hwnd = WindowID(#CodeTesterWin)
      
    EndIf
  
    If IsWindow(#AuthorWin) And hwnd = WindowID(#AuthorWin) And authorwin_shown = 1
      If Message=#WM_COMMAND
        notification = (wParam >> 16) & $FFFF
        control_id = wParam & $FFFF
  
        If control_id = #AuthorWinCombo
          Select notification
            Case #CBN_CLOSEUP
              state = GetGadgetState(#AuthorWinCombo)
              ;Debug "Callback selected item "+GetGadgetText(#AuthorWinCombo)+" "+Str(state)
              If state>=0
                author_changed = #True
              EndIf
            Case #CBN_SELENDCANCEL
              ;Debug "cancel not"
              cancelled = 1
          EndSelect
        EndIf
      EndIf
  
    ElseIf IsWindow(#KeyWin) And hwnd = WindowID(#KeyWin) And keywin_shown = #True
      If Message=#WM_COMMAND
        notification = (wParam >> 16) & $FFFF
        control_id = wParam & $FFFF
              
        Select control_id 
          Case #KeyWinCombo1      ; PB keyword choosen
            Select notification 
              Case #CBN_CLOSEUP
                state = GetGadgetState(#KeyWinCombo1)
                If state>=0
                  key_changed = #True
                EndIf
              Case #CBN_SELENDCANCEL
                cancelled = 1
            EndSelect
  
          Case #KeyWinCombo2      ; PB function choosen
            Select notification 
              Case #CBN_CLOSEUP
                state = GetGadgetState(#KeyWinCombo2)
                If state>=0
                  key_changed = #True
                EndIf
              Case #CBN_SELENDCANCEL
                cancelled = 1
            EndSelect
  
          Case #KeyWinCombo3      ; ASM keyword choosen
            Select notification 
              Case #CBN_CLOSEUP
                state = GetGadgetState(#KeyWinCombo3)
                If state>=0
                  key_changed = #True
                EndIf
              Case #CBN_SELENDCANCEL
                cancelled = 1
            EndSelect
  
          Case #KeyWinCombo4      ; PB constant choosen
            Select notification 
              Case #CBN_CLOSEUP
                state = GetGadgetState(#KeyWinCombo4)
                If state>=0
                  key_changed = #True
                EndIf
              Case #CBN_SELENDCANCEL
                cancelled = 1
            EndSelect
  
          Case #KeyWinCombo5      ; WinAPI function choosen
            Select notification 
              Case #CBN_CLOSEUP
                state = GetGadgetState(#KeyWinCombo5)
                If state>=0
                  key_changed = #True
                EndIf
              Case #CBN_SELENDCANCEL
                cancelled = 1
            EndSelect
  
  ; This I thought would be a faster way, but didn't work either... :-/
  
  ;         Case #KeyWinCombo4      ; PB constant choosen
  ;           If notification = #CBN_CLOSEUP
  ;             state = GetGadgetState(#KeyWinCombo4)
  ;             If state>=0
  ;               SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo4))
  ;               HideKeywords()
  ;             EndIf
  ;           EndIf
  ;         Case #KeyWinCombo5      ; WinAPI function choosen
  ;           If notification = #CBN_CLOSEUP
  ;             state = GetGadgetState(#KeyWinCombo5)
  ;             If state>=0
  ;               SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo5))
  ;               HideKeywords()
  ;             EndIf
  ;           EndIf
        EndSelect
      EndIf
    EndIf
  
    ProcedureReturn result
  EndProcedure
  
  SetWindowCallback(@WinCallback())
CompilerElse
  Debug "Setting a WindowsCallback is only supported on MS Windows!"
CompilerEndIf


; ListIcon Sort Setup
CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  Debug "PureLVSort UserLib currently not used in CAV!"
;   If PureLVSORT_SelectGadgetToSort(#ResultList, #PureLVSORT_ShowClickedHeader_IconLeft) = #PureLVSORT_Ok
;     PureLVSORT_SetColumnType(#ResultList, 0, #PureLVSORT_String)  ; Code name           ; default, not necessary
;     PureLVSORT_SetColumnType(#ResultList, 1, #PureLVSORT_String)  ; Dir
;     PureLVSORT_SetColumnType(#ResultList, 2, #PureLVSORT_String)  ; OS
;     PureLVSORT_SetColumnType(#ResultList, 3, #PureLVSORT_String)  ; Demo
;     PureLVSORT_SetColumnType(#ResultList, 4, #PureLVSORT_String)  ; Description
;   EndIf
CompilerElse
  Debug "The PureLVSort userlib is only supported on MS Windows!"
CompilerEndIf




HideWindow(#MainWindow,0)



run = #True
Repeat
  author_changed = #False
  key_changed = #False
  
  Event = WaitWindowEvent()

  WindowID = EventWindow()
  GadgetID = EventGadget()
  MenuID   = EventMenu()
  EvTypeID = EventType()

  ;event2.l = EventwParam()            ; this we need for checking keycode + mouseclick (Return=13, LeftMB=1)
  ;event3.l = EventlParam()
  
  ;- Events MainWin
  If WindowID = #MainWindow
    ;- MainWin ExitEvent
    If Event = #PB_Event_CloseWindow
      run = #False
      
    ;- *MainWin GadgetEvents
    ElseIf Event = #PB_Event_Gadget
    
      ;Debug "WindowID: " + Str(EventWindowID())

      If GadgetID = #SearchSourceInput
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(0) ,#SearchSourceInput, Language$(126)) : EndIf : CompilerEndIf
        
      ElseIf GadgetID = #SearchAuthorInput
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(1) ,#SearchAuthorInput, Language$(127)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #SearchAuthorSelect
        Gosub GadSearchAuthorSelect
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(2) ,#SearchAuthorSelect, Language$(128)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #SearchDateRange
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(3) ,#SearchDateRange, Language$(218)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #SearchDateDay
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(4) ,#SearchDateDay, Language$(129)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #SearchDateMonth
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(5) ,#SearchDateMonth, Language$(130)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #SearchDateYear
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(6) ,#SearchDateYear, Language$(131)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #SearchFullInput
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(7) ,#SearchFullInput, Language$(35)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #SearchKeywords
        Gosub GadSearchKeywords
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(8) ,#SearchKeywords, Language$(36)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #ResetSearch
        Gosub GadResetSearch
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(9) ,#ResetSearch, Language$(7)) : EndIf : CompilerEndIf
;         SetComboBoxStatus()
;         SetGadgetText(#SearchAuthorInput,"")
;         SetGadgetText(#SearchFullInput,"")

      ElseIf GadgetID = #StartSearch
        Gosub GadStartSearch
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(10) ,#StartSearch, Language$(125)) : EndIf : CompilerEndIf
;         TopAuthorSearch = #False 
;         Gosub StartSearch
      
      ElseIf GadgetID = #FileTree Or GadgetID = #ResultList
        
        ; here we do the sorting of fileinfo2() array, when user clicked on column
        ;If GadgetID = #ResultList
        ;-*
        ;  Debug PureLVSORT_GetClickedColumn(#ResultList)
        ;  Debug PureLVSORT_GetSortingDirection(#ResultList)
        ;
        ;EndIf
        
        ; after a doubleclick immediately show the code in CAV window, go back with a rightclick
        If EvTypeID = #PB_EventType_LeftDoubleClick  
          Gosub GadResultShow
        EndIf
      
      ElseIf GadgetID = #ResultShow
        Gosub GadResultShow
        ; changing / updating of the Tooltip is done here in the sub-routine, because there are 2 different tooltip-texts
      
      ElseIf GadgetID = #ResultForum
        Gosub GadResultForum
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(12) ,#ResultForum, Language$(136)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #ResultEditor
        Gosub GadResultEditor
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(13) ,#ResultEditor, Language$(137)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #ShowFileTree
        Gosub GadShowFileTree
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(14) ,#ShowFileTree, Language$(138)) : EndIf : CompilerEndIf

      ElseIf GadgetID = #CloseFileTree
        Gosub GadCloseFileTree
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(15) ,#CloseFileTree, Language$(139)) : EndIf : CompilerEndIf
      
      ElseIf GadgetID = #PureAreaPic
        Gosub GadPureAreaPic
        CompilerIf #os = #windows : If prefs(28)=1 : ChangeToolTip(TTHandles(16) ,#PureAreaPic, Language$(140)) : EndIf : CompilerEndIf

     
      EndIf

    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      ElseIf Event = #WM_RBUTTONDOWN    ; this is a workaround, because the EditorGadget give no right-click with EventType() 
        If GadgetID = #EditorSource
          ; when right-clicking in the displayed source we go back to previous selected mode (tree or listicon)
          Gosub GadResultShow
        EndIf
    CompilerElse
      Debug "#WM_RBUTTONDOWN is only supported on MS Windows, so no right-click detection on MacOS!"
    CompilerEndIf


    ;- MainWin MenuEvents
    ElseIf Event = #PB_Event_Menu

      If MenuID = #MainWinExit
        run = #False

      ElseIf MenuID = #MainWinOptions
        ShowPrefs()

      ElseIf MenuID = #MainWinDemoCodes
        If GetMenuItemState(0, #MainWinDemoCodes) = 1  ; option "show only demo-compatible sources" was checked until now
          prefs(36) = 0    ; new status = 0 (= show all codes)
        Else
          prefs(36) = 1
        EndIf
        SetMenuItemState(0, #MainWinDemoCodes, prefs(36))
        If ResultMode = 1 Or (ResultMode = 3 And OldResultMode = 1)  ; FileTree is shown or was shown (currently EditorGadget is active)
          FillTree()
          FileTreeCollapseAll()
        ElseIf ResultMode = 2 ; Or (ResultMode = 3 And OldResultMode = 2)    ; ListIcon with search results is shown / or was shown
          Gosub StartSearch
        EndIf

      ElseIf MenuID = #MainWinTopAuthors10
        ShowTopAuthors(93,10)    ; language string 93, show Top10 authors

      ElseIf MenuID = #MainWinTopAuthors20
        ShowTopAuthors(94,20)    ; language string 94, show Top20 authors

      ElseIf MenuID = #MainWinTopAuthors50
        ShowTopAuthors(95,50)    ; language string 95, show Top50 authors

      ElseIf (MenuID >= #MainWinForumEnglish) And (MenuID <= #MainWinForumLounge) 
        CallForumLink(MenuID)
      
      ElseIf MenuID = #MainWinHelp
        Gosub OpenHelp
      
      ElseIf MenuID = #MainWinAbout
        ;- About Window
        a$ = "*******************  C.A.V. - CodeArchivViewer  *******************" + Chr(10)+Chr(10)
        a$ + Language$(52)+" Andre Beer / PureBasic Team"+ Language$(53)+" (C)opyRight 2004-2009"+Chr(10)+Chr(10)
        a$ + Language$(54)+"   ("+Language$(213)+FormatDate(" %dd-%mm-%yyyy - %hh:%ii:%ss)",#PB_Compiler_Date)+Chr(10)+Chr(10)  ; Version + date/time
        a$ + Language$(55)+Chr(10)                                 ; Presented by ....
        a$ + Language$(56)+": andre@purearea.net"+Chr(10)+Chr(10)  ; Email: .....
        a$ + "Freeware. "+Language$(57)+Chr(10)+Chr(10)            ; Freeware. All rights reserved.
        a$ + Language$(88)+Chr(10)                                 ; Thank you and many greetings to following people...
        a$ + ". David - "+Language$(100)+Chr(10)                     ; David - "my scottish friend & GeoWorld developer"
        a$ + ". Fred - "+Language$(101)+" PureBasic 'Feel The Pure Power!'"+Chr(10)    ; Fred - "For" PureBasic 'Feel The Pure Power!'"
        a$ + ". Benny & Epyx - "+Language$(102)+Chr(10)              ; " ... - for their invaluable help at PureArea.net"
        a$ + ". Tommeh, Lars, ts-soft, Falko, Remi Meier, Arthur, Donald, Franky, Team100 - "+Chr(10)
        a$ + "   " + Language$(113)+Chr(10)                          ; " ... - For his help to create an PB 3.92+ compatible CodeArchiv
        a$ + ". blbltheworm, ste123, Leonhard, Hroudtwolf, Progi1984 - "+Chr(10)
        a$ + "   " + language$(223)+Chr(10)                          ; " ... - For his help converting the CodeArchiv to PB v4
        a$ + ". Berikco, Freak, Rings, Danilo, Paul, gnozal & "+Language$(103)     ; ".... of course all other PB developers"
        
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          MessageRequester(Language$(51),a$,#MB_ICONINFORMATION)
        CompilerElse
          MessageRequester(Language$(51),a$)
        CompilerEndIf  


      ElseIf MenuID = #MainWinMoreInfo
        ;- More Informations About Window
        a$ = Language$(147)+": "+#pbversion+Chr(10)+Chr(10)
        a$ + Language$(1)+" "+Str(files)+Chr(10)                     ; Number of available source files
        a$ + "  " + Language$(226) + " " + Str(demofiles) + Chr(10)  ; Number of demo-compatible files of total number
        a$ + Language$(154)+": "+Str(coders)+Chr(10)+Chr(10)         ; Number of coders
        a$ + Language$(148)+Chr(10)                                  ; Number of included search terms
        a$ + "   "+Language$(149)+": "+Str(#NbBasicKeywords)+Chr(10)      ; PureBasic keywords
        a$ + "   "+Language$(150)+": "+Str(#NbPBFunctions)+Chr(10)        ; PureBasic functions
        a$ + "   "+Language$(151)+": "+Str(NbASMKeywords)+Chr(10)        ; InlineASM keywords
        a$ + "   "+Language$(152)+": "+Str(#NbPBConstants)+Chr(10)        ; PureBasic constants
        a$ + "   "+Language$(153)+": "+Str(#NbWinAPIFunctions)+Chr(10)+Chr(10)   ; WinAPI functions
        a$ + Language$(143)+" '"+prefs$(0)+"'"+Chr(10)   ; locale file 'englisch/german/...' 
        a$ + Language$(144)+": "+localeauthor$           ; created by 'author' name (got it from locale file)
        
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          MessageRequester(Language$(146),a$,#MB_ICONINFORMATION)
        CompilerElse
          MessageRequester(Language$(146),a$)
        CompilerEndIf  

      ElseIf MenuID = #MainWinStartCodeTester
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          OpenCodeTesterWin()
        CompilerElse
          Debug "CodeTester is only supported on MS Windows!"
        CompilerEndIf  

        
        
      ;- Event-Returnhandler *****************************************
      ElseIf MenuID = #Return      ; Return-Handler for all StringGadgets
        focus.l = GetActiveGadget()

        Select focus
          Case #SearchSourceInput
            SetActiveGadget(#SearchAuthorInput)
           
          Case #SearchAuthorInput
            SetActiveGadget(#SearchDateDay)

;           Case GadgetID(#SearchDateRange)
;             SetActiveGadget(#SearchDateDay)
             
          Case #SearchDateDay
            SetActiveGadget(#SearchDateMonth)

          Case #SearchDateMonth
            SetActiveGadget(#SearchDateYear)

          Case #SearchDateYear
            SetActiveGadget(#SearchFullInput)
             
          Case #SearchFullInput
            If prefs(9) = 0     ; all Return key presses will lead to the next gadget in the search item area
              SetActiveGadget(#SearchSourceInput)
            Else                ; Return key presses will only be detect in the fulltext searchbox, will immediately start the search function
              Gosub GadStartSearch
            EndIf

          Case #SearchAuthorSelect
            Gosub GadSearchAuthorSelect

          Case #SearchKeywords
            Gosub GadSearchKeywords


          Case #ResetSearch
            Gosub GadResetSearch
            
          Case #StartSearch
            Gosub GadStartSearch

          Case #EditorSource
            Gosub GadResultShow       ; Return-press directly in the EditorGadget - we use it here to go back to previous TreeGadget/ListIcon

          Case #FileTree
            Gosub GadResultShow       ; Return-press directly in the TreeGadget with codes

          Case #ResultList
            Gosub GadResultShow       ; Return-press directly in the ListIcon with search results
          
          Case #ResultShow
            Gosub GadResultShow

          Case #ResultForum
            Gosub GadResultForum

          Case #ResultEditor
            Gosub GadResultEditor

          Case #ShowFileTree
            Gosub GadShowFileTree

          Case #CloseFileTree
            Gosub GadCloseFileTree
            
          Case #PureAreaPic
            Gosub GadPureAreaPic


;           Case GadgetID(#)
;           Case GadgetID(#)
;           Case GadgetID(#)
; 
          
        EndSelect
      
      EndIf
    
    EndIf


    


  ;- Events Authors
  ElseIf WindowID = #AuthorWin

    If Event = #PB_Event_Gadget
  
      If GadgetID = #AuthorWinQuit
        HideAuthors()
        
      ; ElseIf GadgetID = #AuthorWinCombo      ; Author choosen
      ; ^^^^^^^^^ this is handled in the WinCallback procedure now

      ElseIf GadgetID = #AuthorWinCombo      

        If author_changed = #True And cancelled=0
          SetGadgetText(#SearchAuthorInput,GetGadgetText(#AuthorWinCombo))
          ;Debug "Selected item: " + GetGadgetText(#AuthorWinCombo)+" "+Str(GetGadgetState(#AuthorWinCombo))
          HideAuthors()
        EndIf
        
      EndIf
    
    ElseIf Event = #PB_Event_Menu
      Select MenuID
        Case #AuthorWinExit
          HideAuthors()
      
        Case #AuthorWinChoose
          SetGadgetText(#SearchAuthorInput,GetGadgetText(#AuthorWinCombo))
          HideAuthors()
      EndSelect
    EndIf
    
    
  ;- Events Keywords
  ElseIf WindowID = #KeyWin

    If Event = #PB_Event_Gadget
    
      If GadgetID = #KeyWinQuit
        HideKeywords()
    
      ElseIf GadgetID = #KeyWinCombo1      ; PB keyword choosen
        If key_changed = #True And cancelled = 0
          SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo1))
          HideKeywords()
        EndIf        

      ElseIf GadgetID = #KeyWinCombo2      ; PB keyword choosen
        If key_changed = #True And cancelled = 0
          SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo2))
          HideKeywords()
        EndIf        

      ElseIf GadgetID = #KeyWinCombo3      ; PB keyword choosen
        If key_changed = #True And cancelled = 0
          SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo3))
          HideKeywords()
        EndIf        

      ElseIf GadgetID = #KeyWinCombo4      ; PB keyword choosen
        If key_changed = #True And cancelled = 0
          SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo4))
          HideKeywords()
        EndIf        
    
      ElseIf GadgetID = #KeyWinCombo5      ; PB keyword choosen
        If key_changed = #True And cancelled = 0
          SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo5))
          HideKeywords()
        EndIf        

; An example of how I did it before the callback... 
;     ElseIf GadgetID = #KeyWinCombo2      ; PB function choosen
;       If event2 = 1 Or event2 = 13         ; LeftMouseButton or RETURN pressed 
;         a = GetGadgetState(#KeyWinCombo2)
;         If a > -1    ; -1 because 0 = first element
;           SetGadgetText(#SearchFullInput,PBFunctions(a+1))
;           HideKeywords()
;         EndIf
;       EndIf
; 
    
    EndIf

    ElseIf Event = #PB_Event_Menu
      Select MenuID
        Case #KeyWinExit
          HideKeywords()
      
        Case #KeyWinChoose
          ; The last Focus is needed to detect, in which ComboBox the user pressed Return
          focus.l = GetActiveGadget()
          Select focus
            Case #KeyWinCombo1
              SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo1))
            Case #KeyWinCombo2
              SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo2))
            Case #KeyWinCombo3
              SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo3))
            Case #KeyWinCombo4
              SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo4))
            Case #KeyWinCombo5
              SetGadgetText(#SearchFullInput,GetGadgetText(#KeyWinCombo5))
          EndSelect
          HideKeywords()
      EndSelect
    EndIf

   
    
  ;- Events Preferences
  ElseIf WindowID = #PrefWin

    ;- PrefWin Exit
    If Event = #PB_Event_CloseWindow
      CancelPrefs()
      
    ;- *PrefWin Gadgets
    ElseIf Event = #PB_Event_Gadget
  
      If GadgetID = #PrefSave
        Gosub PrefSave
        
      ElseIf GadgetID = #PrefUse   
        Gosub PrefUse
        
      ElseIf GadgetID = #PrefCancel
        Gosub PrefCancel

      ElseIf GadgetID = #PrefEditOriginal Or GadgetID = #PrefEditAlternate
        SetActiveEditor()        

      ElseIf GadgetID = #PrefEditorSelect
        Gosub PrefEditorSelect1

      ElseIf GadgetID = #PrefEditorSelect2
        Gosub PrefEditorSelect2

      ElseIf GadgetID = #PrefAutoSave
        CheckBoxGadgetState(#PrefAutoSave,#PrefAskSave)

      ElseIf GadgetID = #PrefToolTips
        CheckBoxGadgetState(#PrefToolTips,#PrefToolTipMain)
      
      ElseIf GadgetID = #PrefSyntaxH
        SetSyntaxHighlightingColors()

      ElseIf GadgetID = #PrefDesktop
        Gosub PrefDesktop

      ElseIf GadgetID = #PrefStartmenu
        Gosub PrefStartmenu

      ElseIf GadgetID = #PrefSyntaxH_SetStandard
        SetStandardColors()
        
      ElseIf GadgetID >= #PrefSyntaxH_StandColor And GadgetID <= #PrefEditorSearchColor 
        ; Please note: each 2nd gadget is a buttonimage, the others are textgadgets without events
        Gosub PrefsColorPicker


;       ElseIf GadgetID = #PrefPanel     ; we check the status of the active panel to set the focus on the first gadget....
;         SetFocus_(GadgetID(#PrefPanel))
        
        ; Following code have been disabled because of the user should be able to jump from one panel to another ;-)
        ;         Select GetGadgetState(#PrefPanel)
        ;           Case 0 : SetFocus_(GadgetID(#PrefLangChoose))
        ;           Case 1 : SetFocus_(GadgetID(#PrefDirDesc))
        ;           Case 2 : SetFocus_(GadgetID(#PrefDesktop))
        ;         EndSelect
        
      EndIf

    ;- PrefWin Menu
    ElseIf Event = #PB_Event_Menu

      If MenuID = #PrefWinExit      ; Esc in Preferences window pressed
        CancelPrefs()

      ElseIf MenuID = #PrefReturn   ; Return-Handler for several button gadgets  (Save/Use/Cancel/...)
        focus.l = GetActiveGadget()

        Select focus
          Case #PrefSave
            Gosub PrefSave
           
          Case #PrefUse
            Gosub PrefUse
             
          Case #PrefCancel
            Gosub PrefCancel
          
          ; Deactivated because it doesn't work
          ; Case GadgetID(#PrefReturnHnd1)
          ;   SetFocus_(GadgetID(#PrefReturnHnd2))   ; jump to the other editor selection

          ; Case GadgetID(#PrefReturnHnd2)
          ;   SetFocus_(GadgetID(#PrefReturnHnd1))   ; jump to the other editor selection

          Case #PrefEditorSelect
            Gosub PrefEditorSelect1


          Case #PrefEditorSelect2
            Gosub PrefEditorSelect2

          Case #PrefDesktop
            Gosub PrefDesktop

          Case #PrefStartmenu
            Gosub PrefStartmenu

        EndSelect
      EndIf

      
    EndIf

  ;- Events TopAuthors
  ElseIf WindowID = #TopAuthorsWin
  
    ;- TopAuthors Exit
    If Event = #PB_Event_CloseWindow
      HideWindow(#TopAuthorsWin,1)

    ;- TopAuthors Gadgets
    ElseIf Event = #PB_Event_Gadget

      If GadgetID = #TopAuthorChoose 
        Gosub TopAuthorsSelect
        
      ElseIf GadgetID = #TopAuthorList And EvTypeID = #PB_EventType_LeftDoubleClick  
        ; after a doubleclick immediately start the search for author name and show results in CAV window
        Gosub TopAuthorsSelect

      EndIf
      
    ;- TopAuthors Menu
    ElseIf Event = #PB_Event_Menu

      If MenuID = #TopAuthorsExit
        HideWindow(#TopAuthorsWin,1)

      ElseIf MenuID = #TopAuthorsReturn   ; Return-Handler 
        focus.l = GetActiveGadget()

        If focus = #TopAuthorChoose Or focus = #TopAuthorList
          Gosub TopAuthorsSelect
        EndIf
           
      EndIf
      
    EndIf

  ;- Events CodeTester
  ElseIf WindowID = #CodeTesterWin
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  
      ;- CodeTester Exit
      If Event = #PB_Event_CloseWindow
        CloseCodeTesterWin()
  
      ;- *CodeTester Gadgets
      ElseIf Event = #PB_Event_Gadget
  
        If GadgetID = #CodeTesterOne
          Gosub CodeTesterOne
         
        ElseIf GadgetID = #CodeTesterAll
          Gosub CodeTesterAll
       
        ElseIf GadgetID = #CodeTesterEditor
          Gosub CodeTesterEditor

        ElseIf GadgetID = #CodeTesterCheckCompiRun
          CheckCompileRunOptions()
        EndIf

      ;- CodeTester Menu
      ElseIf Event = #PB_Event_Menu
  
        If MenuID = #CodeTesterExit
          CloseCodeTesterWin()
          cont = -1      ; set the value of "codes to check from" back to -1, so we start next time with first code again
  
        ElseIf MenuID = #CodeTesterReturn   ; Return-Handler for several button gadgets 
          focus.l = GetActiveGadget()
  
          Select focus
            Case #CodeTesterOne
              Gosub CodeTesterOne
             
            Case #CodeTesterAll
              Gosub CodeTesterAll
               
            Case #CodeTesterEditor
              Gosub CodeTesterEditor
  
          EndSelect
        EndIf
      EndIf      
      
    CompilerElse
      Debug "CodeTester is only supported on MS Windows!"
    CompilerEndIf  

  EndIf


  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    If Event = #PB_Event_SysTray  
      If EventType() = #PB_EventType_LeftDoubleClick
        Tray2CAV()
      EndIf 
    EndIf
  CompilerElse
    Debug "Systray isn't supported on MacOS!"
  CompilerEndIf  
      
Until run = #False

If prefs(8) = #True   ; Automatic Saving of prefs is enabled
;  Debug "Automatic saving of prefs enabled!"
  If prefs(14) = #True And prefssaved = #False
    If MessageRequester(Language$(155), Language$(156), #PB_MessageRequester_YesNo) <> 6 : End : EndIf
  EndIf
  SavePrefs()
EndIf


; here we clear actual running programms of the CodeTester
If IsProgram(progID) And ProgramRunning(progID)
  CloseProgram(progID)
  KillProgram(progID)
EndIf 

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  CloseHandle_(MutexHandle)
CompilerElse
  Debug "Checking for running only one instance by using 'Mutex' is only possible on MS Windows for now!"
CompilerEndIf
End



; -------------------------------------------------------------------------------------------------------------
;- *Event-Subroutines
; --------------------------------------------

;- MainWin-Events
GadSearchAuthorSelect:
  ShowAuthors()
  Return


GadSearchKeywords:
  ShowKeywords()
  Return
  

GadResetSearch:
  SetComboBoxStatus()
  SetGadgetText(#SearchAuthorInput,"")
  SetGadgetText(#SearchFullInput,"")
  Return


GadStartSearch:
  TopAuthorSearch = #False 
  Gosub StartSearch
  Return


GadResultShow:
        If ResultMode = 3     ; Editorgadget is shown
          HideGadget(#EditorSource,1)
          SetGadgetText(#ResultShow,Language$(10))        ; set button text to "Show code"
          If prefs(15) = 1 
            If prefs(28) = 1  ; use BubbleHelp
              CompilerIf #os = #windows
                ChangeToolTip(TTHandles(11) ,#ResultShow, Language$(135)) ; there are 2 tooltipps, because the button name changes to 'Back' when EditorGadget is displayed
              CompilerElse
                GadgetToolTip(#ResultShow,Language$(135)) 
              CompilerEndIf
            Else
              GadgetToolTip(#ResultShow,Language$(135)) 
            EndIf
          EndIf
          If OldResultMode = 1
            ; We show the FILETREE again...
            SetGadgetText(#FrameResults,Language$(58))  ; ... set the Frame title back to "Contents of CodeArchive"
            HideGadget(#FileTree,0)
            HideGadget(#CloseFileTree,0)  ; show the buttongadget "Close dir tree" again
            SetActiveGadget(#FileTree)
            ResultMode = 1
            CompilerIf #os = #windows
              If prefs(28) = 1
                If prefs(16) = 0     ; tooltips for tree, list and editor are NOT disabled
                  ChangeToolTip(TTHandles(19) ,#FileTree, Language$(134))
                EndIf
              EndIf
            CompilerEndIf
          Else
            ; We show the RESULTLIST (ListIcon) again...
            SetGadgetText(#FrameResults,Language$(9)+"  ("+Str(a)+"/"+Str(files)+")")  ; ... set the Frame title back to "Search results"            HideGadget(#ResultList,0)
            HideGadget(#ShowFileTree,0)   ; ........ and the button for re-calling the TreeGadget again
            HideGadget(#ResultList,0)
            RefreshGadget(#ResultList)
            ResultMode = 2
            CompilerIf #os = #windows
              If prefs(28) = 1
                If prefs(16) = 0     ; tooltips for tree, list and editor are NOT disabled
                  ChangeToolTip(TTHandles(17) ,#ResultList, Language$(132))
                EndIf
              EndIf
            CompilerEndIf
          EndIf
        Else                  ; TreeGadget or ListIcon is shown
          OldResultMode = ResultMode
          actcode = GetCode()
          If actcode > -1         ; if result = -1, then there wasn't an item or it was a folder (#FileTree)
            ;- Show Source in EditorGadget
            LoadSource(files(actcode))      ; see include file 'CodeArchivViewer_LoadSource.pb'
            If ResultMode = 1
              HideGadget(#FileTree,1)       ; hide the FileTree 
              HideGadget(#CloseFileTree,1)  ; hide the buttongadget "Close dir tree"
            Else
              HideGadget(#ResultList,1)     ; hide the ListIcon with search results 
            EndIf
            b$ = filesinfo(actcode)\Path1
            c$ = filesinfo(actcode)\Path2
            If c$ <> ""
              b$ + "\" + c$
            EndIf
            c$ = filesinfo(actcode)\Path3
            If c$ <> ""
              b$ + "\" + c$
            EndIf
            a$ = filesinfo(actcode)\File + "  (" + b$ + ")"
            If prefs(7) = 1    ; "ShowFileDescription" in search results activated ?
              b$ = ""
              If Lang = 0                ; for english there isn't a translation available, but propably are more extended description in a later version of CodeArchive
                Debug "Not implemented yet."
                ;Debug b$ = filesinfo(actcode)\English
              ElseIf Lang = 1            ; german
                c$ = ReplaceString(filesinfo(actcode)\File,".pb","")
                b$ = GetDescription(c$)
              ElseIf Lang = 2            ; french
                Debug "Not implemented yet."
                ; c$ = ReplaceString(filesinfo(actcode)\File,".pb","")
                ; Gosub GetDescription
              EndIf
              If b$ <> ""
                a$ + "  -  " + b$
              EndIf
            EndIf
            SetGadgetText(#FrameResults,a$)              ; ... and change the Frame title to name of code file
            SetGadgetText(#ResultShow,Language$(92))     ; the "Show code" button is renamed with "Back" (for switching back to Tree or SearchList later
            If prefs(15) = 1 
              If prefs(28) = 1
                CompilerIf #os = #windows
                  ChangeToolTip(TTHandles(11) ,#ResultShow, Language$(141)) ; there are 2 tooltipps, because the button name changes to 'Back' when EditorGadget is displayed
                CompilerElse
                  GadgetToolTip(#ResultShow,Language$(141)) 
                CompilerEndIf
              Else
                GadgetToolTip(#ResultShow,Language$(141)) 
              EndIf
            EndIf
            HideGadget(#EditorSource,0)
            RefreshGadget(#EditorSource)
            ;SetActiveGadget(#EditorSource)    ; included in RefreshGadget() procedure!
            ResultMode = 3
            CompilerIf #os = #windows
              If prefs(28) = 1
                If prefs(16) = 0     ; tooltips for tree, list and editor are NOT disabled
                  ChangeToolTip(TTHandles(18) ,#EditorSource, Language$(133))
                EndIf
              EndIf
            CompilerEndIf
;           Else;             ; nothing valid selecting, but we need to refresh the balloontooltip;             If prefs(15) = 1 
;               CompilerIf #os = #windows
;                 ChangeToolTip(TTHandles(11) ,#ResultShow, Language$(135)) ; there are 2 tooltipps, because the button name changes to 'Back' when EditorGadget is displayed
;               ; CompilerElse
;               ;   GadgetToolTip(#ResultShow,Language$(141)) 
;               CompilerEndIf
;             EndIf
          EndIf
        EndIf
        Return


GadResultForum:
        If ResultMode = 3   ; already EditorGadget is shown
          a = actcode
        Else                ; TreeGadget or ListIcon is shown
          a = GetCode()
        EndIf
        If a > -1         ; if result = -1, then there wasn't an item or it was a folder (#FileTree)
          a$ = filesinfo(a)\ForumURL
          If a$ <> ""
            RunProgram(a$)
          Else
            CompilerIf #PB_Compiler_OS = #PB_OS_Windows
              MessageRequester(Language$(86),Language$(90),#MB_ICONWARNING)
            CompilerElse
              MessageRequester(Language$(86),Language$(90))
            CompilerEndIf
          EndIf
        EndIf
        Return

        
GadResultEditor:
        If ResultMode = 3   ; already EditorGadget is shown
          a = actcode
        Else                ; TreeGadget or ListIcon is shown
          a = GetCode()
        EndIf
        If a > -1         ; if result = -1, then there wasn't an item or it was a folder (#FileTree)
          a$ = files(a)
          If a$ <> ""
            CallEditor(a$)
          Else
           ; MessageRequester(Language$(86),Language$(90),#MB_ICONWARNING)
          EndIf
        EndIf
        Return


GadShowFileTree:
        If ResultMode = 2
          HideGadget(#ResultList,1)     ; hide the ListIcon with search results 
        Else
          HideGadget(#EditorSource,1)     ; hide the editor with source code
        EndIf
        HideGadget(#FileTree,0)       ; ... and show the TreeGadget again 
        HideGadget(#ShowFileTree,1)   ; ........ and hide the button because its not needed with the FileTree displayed
        HideGadget(#CloseFileTree,0)  ; ... and also show the buttongadget "close dir tree" again
        SetGadgetText(#FrameResults,Language$(58))  ; ... and change the Frame title
        SetGadgetText(#ResultShow,Language$(10))        ; set button text to "Show code"
        RefreshGadget(#FileTree)
        ResultMode = 1
        Return


GadCloseFileTree:
  FileTreeCollapseAll()
  RefreshGadget(#FileTree)
  Return
      
GadPureAreaPic:
  RunProgram("http://www.purearea.net")
  Return


;- PrefWin-Events
PrefSave:
  ; save here the settings to an .ini file
  a = UsePrefs()   ; we call first the UsePrefs() procedure, where all values will be stored for current program run and also the prefs window will be closed
  SavePrefs()
  If a = 1 And ResultMode = 2   ; ListIcon is shown and columns have changed, so we must start the search function again for refreshing
    Gosub StartSearch
  EndIf
  Return
  
PrefUse:
  ; use the actual settings until program quits
  a = UsePrefs()
  If a = 1 And ResultMode = 2   ; ListIcon is shown and columns have changed, so we must start the search function again for refreshing
    Gosub StartSearch
  EndIf
  Return
  
PrefCancel:
  ; cancel current settings
  CancelPrefs()
  Return
  
PrefEditorSelect1:
  GetEditorPath(#PrefEditorPath)
  ;         a$ = GetGadgetText(#PrefEditorPath)
  ;         a$ = OpenFileRequester(Language$(72),a$,"Exe (*.exe)|*.exe|Alle Dateien (*.*)|*.*",0)
  ;         If a$ 
  ;           SetGadgetText(#PrefEditorPath,a$)
  ;         EndIf
  Return
  
PrefEditorSelect2:
  GetEditorPath(#PrefEditorPath2)
  Return
  
PrefDesktop:
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    If myCreateShortcut(GetFullPath() + "CAV.exe", myGetSpecialeFolder(#CSIDL_DESKTOP) + "C.A.V.lnk", GetFullPath(), "", GetFullPath() + "CAV.exe", 0)
      MessageRequester(Language$(86),Language$(200))                    ; Desktop shortcut sucessfully created
    Else
      MessageRequester(Language$(112),Language$(201),#MB_ICONWARNING)   ; Error creating desktop shortcut
    EndIf
  CompilerElse
    Debug "PrefDesktop sub-routine: creating a desktop shortcut is only supported on MS Windows!"
  CompilerEndIf
  Return
  
PrefStartmenu:
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    If myCreateShortcut(GetFullPath() + "CAV.exe", myGetSpecialeFolder(#CSIDL_APPDATA) + "Microsoft\Internet Explorer\Quick Launch\C.A.V.lnk", "", "", GetFullPath() + "CAV.exe", 0)
      MessageRequester(Language$(86),Language$(202))                    ; Quicklaunch shortcut sucessfully created
    Else
      MessageRequester(Language$(112),Language$(203),#MB_ICONWARNING)   ; Error creating quicklaunch shortcut
    EndIf
  CompilerElse
    Debug "PrefStartmenu sub-routine: creating a startmenu entry is only supported on MS Windows!"
  CompilerEndIf
  Return

PrefsColorPicker:
  If GadgetID = #PrefSyntaxH_StandColor
    a = #PrefSyntaxH_StandColor     ; save GadgetID
    b = 1                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefSyntaxH_PBKeyColor
    a = #PrefSyntaxH_PBKeyColor     ; save GadgetID
    b = 2                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefSyntaxH_PBComColor
    a = #PrefSyntaxH_PBComColor     ; save GadgetID
    b = 3                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefSyntaxH_PBAsmColor
    a = #PrefSyntaxH_PBAsmColor     ; save GadgetID
    b = 4                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefSyntaxH_PBConColor
    a = #PrefSyntaxH_PBConColor     ; save GadgetID
    b = 5                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefSyntaxH_ComColor
    a = #PrefSyntaxH_ComColor       ; save GadgetID
    b = 6                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefEditorBackColor
    a = #PrefEditorBackColor        ; save GadgetID
    b = 7                           ; save ImageID
    c = GetColor(b)                 ; save color value
  ElseIf GadgetID = #PrefEditorSearchColor
    a = #PrefEditorSearchColor      ; save GadgetID
    b = 8                           ; save ImageID
    c = GetColor(b)                 ; save color value
  EndIf
  
  c = ColorRequester(c)
  If c > -1
    SetColor(a,b,c)   ; update the ButtonImageGadget with new color, parameters are: gadget, image, color
  EndIf  

  Return


CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  CodeTesterOne:
           a$ = GetTestCode()
           If a$ <> ""
             TestOneCode(a$)
           EndIf
           Return
  
  CodeTesterAll:
           If cont = -1     ; no codes tested before...
             If GetGadgetState(#CodeTesterCheckFromHere)    ; user forced the CodeTester to start testing all codes from actual selected one
               a = GetGadgetState(#CodeTesterList)
               If a > -1
                 cont = a+1   ; set 'cont' to actual selected code in listview (+1 because files() array is starting at 1), from here we will start our code-testing
               EndIf
             EndIf
           Else
             cont + 1     ; we continue with next code after last code test
           EndIf
           cont = TestAllCodes(cont)
           Return
           
                    
  CodeTesterEditor:         
           a$ = GetTestCode()
           If a$ <> ""
             CallEditor(a$)
           EndIf
           Return
CompilerElse
  Debug "CodeTester sub-routines not included, because it's only supported on MS Windows!"
CompilerEndIf           
         

TopAuthorsSelect:
        a = GetGadgetState(#TopAuthorList)    
        HideWindow(#TopAuthorsWin,1)
        b = ListSize(author()) - 1 - a
        author$ = LCase(topcoders(b)\Name)
        TopAuthorSearch = #True
        Gosub StartSearch
        Return
  

OpenHelp:
;     If OpenHelp(path$+"CAV.chm", "")     ; instead of the "0" a context-sensitive help should be included later 
;     Else
;       MessageRequester(Language$(178),Language$(219),#MB_ICONWARNING)       ; Error - couldn't open the online-help!
;     EndIf
    If OpenHelp(manualpath$+prefs$(0)+".chm", "")    ; open the manual related to the actual selected language
    ElseIf OpenHelp(manualpath$+"English.chm", "")   ; if this fails use the English.chm manual as standard
    Else
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
        MessageRequester(Language$(178),Language$(219),#MB_ICONWARNING)       ; Error - couldn't open the online-help!
      CompilerElse
        MessageRequester(Language$(178),Language$(219))       ; Error - couldn't open the online-help!
      CompilerEndIf
    EndIf
    Return

  
; ----------------------------------------------------------------------------------------------------------------

; *******************************
;- Search Procedures
; *******************************
Procedure ExtractSearchTerms(text$)
  ; Structure searchterm
  ;   term.s             ; search-term to search for
  ;   valid.l            ; 0 = OR, search is true if the searchterm appears   (it was entered a SPACE in front of the term)
  ;                      ; 1 = AND, search is only true, if the searchterm appears beside the other terms  (it was entered a '+' in front)
  ;                      ; 2 = NOT, search is only true, if the searchterm DOESN't appear  (it was entered a '-' in front)
  ; EndStructure
  x.s=Chr(34)                ; define "
  ClearList(searchterms())
  text$ = Trim(text$)        ; cut possible spaces in front or at the end of the search string
  a = CountString(text$,x)

  ; Search for phrase, enclosed by two ""
  ; -------------------------------------
  If a>0 
    If a & %1    ; if there are any " in the searchstring, there must always be a pair of them, else we show the error message
      ProcedureReturn -1
    Else
      Repeat
        first = FindString(text$,x,0)
        second = FindString(text$,x,first+1)
        If second - first < 2        ; difference between first " and second " must be at least 2, else there isn't any text in between
          ProcedureReturn -2
        EndIf

        phrase$ = Mid(text$,first+1,second-first-1)
        
        ; check, if there are any +/- in the phrase, which is not allowed
        If FindString(phrase$,"+",1)
          ProcedureReturn -3
        ElseIf FindString(phrase$,"-",1)
          ProcedureReturn -3
        EndIf
        
        AddElement(searchterms())
        searchterms()\term = LCase(phrase$)
        
        ; check if there is any +/- in front of the phrase
        a$ = Mid(text$,first-1,1)   ; test the char in front of the cutted phrase (one char before the ")
        If a$ = "-"
          searchterms()\valid = 2      ; NOT
        ElseIf a$ = "+"
          searchterms()\valid = 1      ; AND
        Else
          searchterms()\valid = 0      ; OR
        EndIf

        ; now we cut the already scanned part from the searchterm input
        part1$ = Left(text$,first-1)  
        part2$ = Right(text$,Len(text$)-second)
        text$ = part1$ + part2$       ; remove the phrase including the two ""
        If a$ = "-" Or a$ = "+"                                           ; remove the leading +/- if present
          text$ = Left(text$,first-2) + Right(text$,Len(text$)-first+1)    
        EndIf
        a-2
      Until a=0
    EndIf
  EndIf
    
;  Debug "SearchString='"+text$+"'"

;          Debug "first="+Str(first)
;          Debug "second="+Str(second)
;          Debug "-----------------------"

        
  ; Here we start parsing all search terms OUTSIDE a "" marked phrase  
  ; -----------------------------------------------------------------
  b = CountString(text$," ")
  For a=1 To b+1
    phrase$ = Trim(StringField(text$,a," "))
    valid = 0                     ; set standard 'valid' operator, which will be used if there is no +/-
   
    c = FindString(phrase$,"+",1)
    d = FindString(phrase$,"-",1)

; Debug "phrase='"+phrase$+"'"
; Debug "pos of + :"+Str(c)
; Debug "pos of - :"+Str(d)

    If c > 0 Or d > 0             ; + or - was found in search term
      If c > 1 Or d > 1           ; +/- isn't in front of the term, which isn't allowed
        ProcedureReturn -4
      Else                        ; there is a valid +/- in front, so we cut it from the searchstring and set the 'valid' operator
        If phrase$="+" Or phrase$="-"   ; there was a single +/- with no other searchterm following, not allowed ;-)
          ProcedureReturn -4
        EndIf
        phrase$ = Right(phrase$,Len(phrase$)-1)
        If c=1                    ; + was found => AND
          valid = 1
        ElseIf d=1                ; - was found => NOT
          valid = 2
        Else
          Debug "Missing check, because this shouldn't happen!"
        EndIf
      EndIf
    EndIf

    If FindString(phrase$,"+",1) Or FindString(phrase$,"-",1)     ; here we catch multiple ++++ or ----
      ProcedureReturn -4
    EndIf
    
    ; at this point there isn't any +/- in the string or it was already cutted and the 'valid' operator set
    If phrase$ > ""
      AddElement(searchterms())    
      searchterms()\term = LCase(phrase$)
      searchterms()\valid = valid
    EndIf
  Next
  
;   ResetList(searchterms())
;   While NextElement(searchterms())
;     Debug searchterms()\term 
;     Debug searchterms()\valid
;   Wend
 
EndProcedure
 


; **************************************************************
;- Search Start
; **************************************************************
StartSearch:
  If TopAuthorSearch = #False   ; we only need the search terms from input gadgets, if not coming from the TopXX author list
    text$ = Trim(GetGadgetText(#SearchFullInput))
    If text$ > "" 
      text=#True 
      ; we parse the fulltext input at first to create the search terms...
      a = ExtractSearchTerms(text$) 
      If a < 0                ; if there is a negative return value, then there was an error in the searchterm
        b$ = Chr(34)
        Select a             
          Case -1        ; -1 means that there was an error the search terms
            a$ = Language$(104)+b$+Language$(105)+b$+b$+Language$(106)     ;"Wenn Sie "+b$+" verwenden mchten, dann muss die Phrase jeweils von zwei "+b$+b$+" umschlossen sein."
          Case -2
            a$ = Language$(107)+b$+b$+Language$(108)          ; "Zwischen zwei "+b$+b$+" muss auch eine Phrase eingegeben werden."
          Case -3
            a$ = Language$(109)+b$+b$+Language$(110)          ;"Innerhalb einer von "+b$+b$+" umschlossenen Phrase sind keine + und - erlaubt."
          Case -4
            a$ = Language$(111)                               ;"+/- fr UND- bzw. NICHT-Kennzeichnung eines Suchworts sind nur unmittelbar vor dem Wort erlaubt."
        EndSelect
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          MessageRequester(Language$(112),a$,#MB_ICONWARNING)   ; "Fehler im Volltext-Suchstring"
        CompilerElse
          MessageRequester(Language$(112),a$)   ; "Fehler im Volltext-Suchstring"
        CompilerEndIf
        Return
      Else                    ; all if fine :-)
        ; test output of the found search terms
;         ResetList(searchterms())
;         Debug "*********************************"
;         Debug "Number of searchstrings = "+Str(CountList(searchterms()))
;         While NextElement(searchterms())
;           Debug "'"+searchterms()\term + "' / " + Str(searchterms()\valid)
;         Wend
;         Debug "*********************************"

        ; Here we check if there are AND or NOT search items present,
        ; because if there are any then the full-text search can be shortened
        no=#False : an=#False    ; set NOT and AND to false
        ForEach searchterms()
          If searchterms()\valid = 1 : an=#True : EndIf     ; AND item found
          If searchterms()\valid = 2 : no=#True : EndIf     ; NOT item found
        Next
          
      EndIf
    Else 
      text=#False 
    EndIf
  EndIf

;  Debug "Search started...."
  

  
;   Debug "Source: "+GetGadgetText(#SearchSourceInput)
;   Debug "Author: "+GetGadgetText(#SearchAuthorInput)
;   Debug "Date:   "
;     Debug "  Day:   "+GetGadgetText(#SearchDateDay)
;     Debug "  Month: "+GetGadgetText(#SearchDateMonth)
;     Debug "  Year:  "+GetGadgetText(#SearchDateYear)
;   Debug "Fulltext: "+GetGadgetText(#SearchFullInput)

  If TopAuthorSearch = #False   ; we only need the search terms from input gadgets, if not coming from the TopXX author list
    source$ = GetGadgetText(#SearchSourceInput)
    If source$ = Language$(13)        ; 'all' was choosen
      source = -1
    ElseIf source$ = Language$(14)    ; 'english forum' was choosen
      source = 0
    ElseIf source$ = Language$(15)    ; 'german forum' was choosen
      source = 1
    ElseIf source$ = Language$(119)   ; 'french forum' was choosen
      source = 2
    ElseIf source$ = "PureBasic-Lounge.de"
      source = 4
    ElseIf source$ = Language$(16)    ; 'other' was choosen, so we don't search for anything from english or german forum
      source = 3   
    Else
      If source$ = ""                  ; nothing entered
         source = -2
      Else
         source = -3            ; a freely entered search term was entered, so we must search for exactly comparing entries
       EndIf  
    EndIf

    author$ = LCase(GetGadgetText(#SearchAuthorInput))
    If author$ > "" : author=#True : Else : author=#False : EndIf
  
    range = GetGadgetState(#SearchDateRange)
    day = GetGadgetState(#SearchDateDay)
    month = GetGadgetState(#SearchDateMonth)
    year = Val(GetGadgetText(#SearchDateYear))
    
    If month>0 And year=0      ; a month was choosen, but no year
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
        MessageRequester(Language$(86), Language$(114),#MB_ICONWARNING)  ; Note: please choose a year beside a month
      CompilerElse
        MessageRequester(Language$(86), Language$(114))  ; Note: please choose a year beside a month
      CompilerEndIf
      SetActiveGadget(#SearchDateYear)
      Return
    EndIf
    If day>0 And month=0      ; a day was choosen, but no month
      CompilerIf #PB_Compiler_OS = #PB_OS_Windows
        MessageRequester(Language$(86), Language$(115),#MB_ICONWARNING)  ; Note: please choose a month and year beside day
      CompilerElse
        MessageRequester(Language$(86), Language$(115))  ; Note: please choose a month and year beside day
      CompilerEndIf
      SetActiveGadget(#SearchDateMonth)
      Return
    EndIf
    If (month=2 And day>29) Or ((month=4 Or month=6 Or month=9 Or month=11) And day>30)
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          MessageRequester(Language$(86), Language$(116),#MB_ICONWARNING)   ; Note: the choosen day has an error, please correct it
        CompilerElse
          MessageRequester(Language$(86), Language$(116))   ; Note: the choosen day has an error, please correct it
        CompilerEndIf
      SetActiveGadget(#SearchDateDay)
      Return
    EndIf
  Else      ; we're coming directly from the TopXX authors list
    source = -1      ; all 
    author = #True
    range = -1
    day = 0          ; all
    month = 0        ; all
    year = 0         ; all
    text = #False    ; we don't use fulltext search
  EndIf



  If ResultMode = 1
    HideGadget(#FileTree,1)       ; hide TreeGadget with normal File list
    HideGadget(#CloseFileTree,1)  ; hide the buttongadget "Close dir tree"
  ElseIf ResultMode = 3
    HideGadget(#EditorSource,1)
  EndIf
  
  HideGadget(#ResultList,1)     ; hide also the listicon until search is completed
  HideGadget(#ShowFileTree,1)   ; ........ and the button for re-calling the TreeGadget 
  
  ; Show the progressbar during searching
  HideGadget(#SearchProgressBar,0)
  HideGadget(#SearchProgressText,0)
  

 
;- Show Search Terms
; Debug "Source: "+Str(source)
; Debug "Author: "+Str(author) + " / " + author$
; Debug "Date:   "+Str(day)+"."+Str(month)+"."+Str(year)
; Debug "Text:   "+Str(text)


  ClearList(check.l())   ; here the 'files' array index for found files will be cleared for a new run
  ClearList(check3())    ; added for LVSORT support
  
  For a=1 To files    

;    Debug "Search in: "+files(a)
    
    
   ; Update the Search ProgressBar
    SetGadgetState(#SearchProgressBar,a)
    While WindowEvent() : Wend
    
    check = #True
    
    While check = #True
      ; here we do now the optional check, if only demo-compatible codes should be shown...
      If prefs(36) = 1 And filesinfo(a)\Demo <> 1
        check = #False
        ; Continue    ; jump to next file without including it in the tree...
      EndIf


      ; Search in 'source' field (forum, etc.)
      tempcheck = #False
      If source = filesinfo(a)\ForumType    ; forum 'english, german, other' doesn't compare with sourcefile
          tempcheck = #True
      Else
        If source = -1 Or source = -2       ; 'all' or nothing entered
          tempcheck = #True
        Else                                ; source = -3   (a freely entered search term)
          If FindString(LCase(filesinfo(a)\Forum), LCase(source$), 0)
            tempcheck = #True
          EndIf
        EndIf
      EndIf
      If tempcheck = #False 
        ;Debug "Search in Forum = false: "+files(a)      
        check = #False
      EndIf
      
      ; Search in 'Author' field
      If author = #True     ; anything entered in author field !
        If FindString(LCase(filesinfo(a)\Author), author$, 0) = #False
          check = #False
          ;Debug "Search in Author = false: " + files(a)
          ;Debug filesinfo(a)\Author + " / Searched for: "+author$
        EndIf
      EndIf  

      ; Search in 'Date' fields
      tempcheck = #True
      If year > 0      ; anything other than 'all' was entered in 'year' field
        tempyear = filesinfo(a)\Year 
        If (range = 0 And tempyear <> year) Or (range = 1 And tempyear > year) Or (range = 2 And tempyear < year)
          tempcheck = #False
        Else
          If month > 0      ; anything other than 'all' was entered in 'month' field
            tempmonth = filesinfo(a)\Month 
            If (range = 0 And tempmonth <> month) Or (range = 1 And tempmonth > month) Or (range = 2 And tempmonth < month)
              tempcheck = #False
            Else
              If day > 0      ; anything other than 'all' was entered in 'day' field
                tempday = filesinfo(a)\Day 
                If (range = 0 And tempday <> day) Or (range = 1 And tempday > day) Or (range = 2 And tempday < day)
                  tempcheck = #False
                EndIf
              EndIf
            EndIf
          EndIf
        EndIf
      EndIf
      If tempcheck = #False
        ;Debug "Search in Date: false / "+files(a)    
        check = #False
      EndIf
      
      ; Search fulltext with the search terms from full-text search field here...
      If text = #True
        ;Debug "Fulltext-Search in file: "+files(a)
        
        tempcheck = #False
        ResetList(searchterms())
        ForEach searchterms()
          searchterms()\found = #False    ; is only needed for AND searches, where all must be true
        Next
        
        ; 30-Dec-2006: here we add now also searching in file name of the source
        If prefs(35)   ; as this is optional, we search only in the filenames when the option is set
          file$ = LCase(GetFilePart(files(a)))
          ForEach searchterms()
            c = FindString(file$,searchterms()\term,0)
            Select searchterms()\valid
              Case 0    ; OR
                If c
                  tempcheck = #True
                  If an=#False          ; we could only leave immediately the check, if there are no "AND search terms"
                    Break 2
                  EndIf
                EndIf
              Case 1    ; AND
                If c                    ; the AND combined searchitem wasn't found, but this is a must! so tempcheck is set to false...
                  searchterms()\found = #True
                EndIf
              Case 2    ; NOT
                If c                    ; found a NOT term in the file, so we stop searching in this file immediately
                  check = #False   
                  Break 2
                EndIf
            EndSelect
          Next
        EndIf

        ; here starts searching in the file itself...
        If ReadFile(0,files(a))
          Repeat 
            a$ = ReadString(0)
            If CheckForSourceKeywords(a$) = #False    ; we don't search in the IDE source-keyword lines
              a$ = LCase(a$)
              ForEach searchterms()
                c = FindString(a$,searchterms()\term,0)
                Select searchterms()\valid
                  Case 0    ; OR
                    If c
                      tempcheck = #True
                      If an=#False          ; we could only leave immediately the check, if there are no "AND search terms"
                        Break 2
                      EndIf
                    EndIf
                  Case 1    ; AND
                    If c                    ; the AND combined searchitem wasn't found, but this is a must! so tempcheck is set to false...
                      searchterms()\found = #True
                    EndIf
                  Case 2    ; NOT
                    If c                    ; found a NOT term in the file, so we stop searching in this file immediately
                      check = #False   
                      Break 2
                    EndIf
                EndSelect
              Next
            EndIf
          Until Eof(0) = #True 
          CloseFile(0)

          ; Here some special code for the AND search items
          If an = #True   ; if there any AND search items included in the list....
            tempcheck = #True
            ForEach searchterms()
              If searchterms()\valid = 1 And searchterms()\found = #False   ; there are AND search items, but not set to true (=found)
                tempcheck = #False
              EndIf
            Next
          EndIf

        EndIf
;        Else
;          Debug "Error or empty file!" + files(a)
      EndIf
      
      If tempcheck = #False 
        ;Debug "Search in fulltext = false / "+files(a)    
        check = #False
      EndIf
      

      ; If the search routine is still true after all search terms, then the item was sucessfully found, so we leave the loop
      If check = #True
        Break
      EndIf

    Wend
    ;EndIf
    
    If check=#True       ; all search terms found
      AddElement(check())
      check() = a
      
      ; added 17th July for LVSORT support
      AddElement(check3())
      check3()\FileID = a
      check3()\File   = filesinfo(a)\File
    EndIf
  Next

;Debug CountList(check.l())



ClearGadgetItems(#ResultList)



; ; TEST !!!!!
; Debug CountList(check())
; 

ResetList(check())  
While NextElement(check())
  ; fill first column: Name
  a$ = filesinfo(check())\File

  ; fill second column: Path
  b$ = filesinfo(check())\Path1
  If filesinfo(check())\Path2 <> ""
    b$ + "/" + filesinfo(check())\Path2 
  EndIf
  If filesinfo(check())\Path3 <> ""
    b$ + "/" + filesinfo(check())\Path3
  EndIf
  a$ + Chr(10) + b$ 

  ; fill third column: OS    ; only if set in prefs
  If prefs(5) = 1
    check = filesinfo(check())\OS 
    b$ = ""
    If check = 1 Or check = 3 Or check = 5 Or check = 7 Or check = 9 Or check = 11 Or check = 13 Or check = 15
      b$ + "W "      ; Windows compatible
    EndIf
    If check = 2 Or check = 3 Or check = 6 Or check = 7 Or check = 10 Or check = 11 Or check = 14 Or check = 15
      b$ + "L "      ; Linux compatible
    EndIf
    If (check >= 4 And check <= 7) Or check > 12
      b$ + "M "       ; MacOS compatible
    EndIf
    If check >= 8 
      b$ + "A"        ; AmigaOS compatible
    EndIf
    a$ + Chr(10) + b$ 
  EndIf

  ; fill fourth column: Demo   ; only if set in prefs
  If prefs(6) = 1
    b$ = ""
    If filesinfo(check())\Demo = 1
      b$ = Language$(208)                ; Yes
    ElseIf filesinfo(check())\Demo = 2
      b$ = Language$(209)                ; No
    ElseIf filesinfo(check())\Demo = 3
      b$ = Language$(209)+"?"            ; No?
    EndIf
    a$ + Chr(10) + b$ 
  EndIf

  ; fill fifth column: description field, if set in the prefs and available for the source in setted language
  If prefs(7) = 1     ; show file descriptions is set in preferences
    b$ = ""             ; set empty string for adding when there is no descriptions
    If Lang = 1   ; language = german ?  => when there are more languages available then do the search at first and after that grab the german/.... description
      c$ = ReplaceString(filesinfo(check())\File,".pb","")
      b$ = GetDescription(c$)
    EndIf
    a$ + Chr(10) + b$
  EndIf
  
  
  
  AddGadgetItem(#ResultList,-1,a$)

;  Debug files(check())
;  Debug filesinfo(check())\Forum
;  Debug filesinfo(check())\Author
Wend


  ; Hide the progressbar after searching
  HideGadget(#SearchProgressText, 1)
  HideGadget(#SearchProgressBar, 1)

  ; Show the search results in main area
  HideGadget(#ResultList, 0)     ; .... and show the ListIcon for search results
  HideGadget(#ShowFileTree, 0)   ; ........ and the button for re-calling the TreeGadget again
  SetGadgetText(#ResultShow, Language$(10))        ; set button text to "Show code"
  ResultMode = 2

  a = ListSize(check()) 
  If a = 0
    SetGadgetText(#FrameResults, Language$(9))     ; ... and change the Frame title
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      MessageRequester(Language$(86), Language$(87),#MB_ICONWARNING)
    CompilerElse
      MessageRequester(Language$(86), Language$(87))
    CompilerEndIf
  Else
    SetGadgetText(#FrameResults,Language$(9)+"  ("+Str(a)+"/"+Str(files)+")")  ; ... and change the Frame title
  EndIf
  

  While WindowEvent() : Wend

  SetGadgetItemState(#ResultList,0,#PB_ListIcon_Selected)     ; mark 1st entry
  SetActiveGadget(#ResultList)  
Return


End
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 1279
; FirstLine = 1236
; Folding = --
; EnableXP
; UseIcon = C:\Programming\PureBasic_CDROM\CAV\CAV.ico
; Executable = CAV.exe