Declare FillTree()     ; declaration is needed here, because real procedure is later included (in the CAV_GUI.pb)


;- Init PrefsMemory
Global Dim prefs$(10)   ; store all preferences strings here (including actual program run)
;Dim orgprefs$(10)      ;   here the original loaded pref settings are stored for backup, if the user hit cancel in prefs window
Global Dim prefs(36)    ; store all preferences values here
;Dim tempprefs(15)       ;   currently only used for temporarly saving the settings of the search items when changing program language
;Dim tempcolors(5)       ; save color values for syntax highlighting, the will be stored to prefs() when user select 'Save' or 'Use'

Global Dim TTHandles.l(20)   ; save ToolTip handles (only the WinAPI edition of CAV) here


;- Procedure declarations  (where needed)
Declare SetLanguage()
Declare LoadPrefs()
Declare CheckBoxGadgetState(gadget,relatedgadget)
Declare SetActiveEditor()
Declare SetSyntaxHighlightingColors()

; Here we make the initial settings of the program language
LoadPrefs()
SetLanguage()



; Procedure RestoreTempPrefs()
;   For a=0 To 10
;     tempprefs(a)  = prefs(a)
;     tempprefs$(a) = prefs$(a)
;   Next
; EndProcedure
; 
; Procedure SaveTempPrefs()
;   For a=0 To 10
;     prefs(a)  = tempprefs(a)
;     prefs$(a) = tempprefs$(a)
;   Next
; EndProcedure


Procedure.s GetPBDir()
;   Buffer$=Space(10000):BufferSize=Len(Buffer$)-1
;   If GetVersion_() & $ff0000 ; Windows NT/XP 
;     If RegOpenKeyEx_(#HKEY_CLASSES_ROOT, "Applications\PureBasic.exe\shell\open\command", 0, #KEY_ALL_ACCESS , @Key) = #ERROR_SUCCESS 
;       If RegQueryValueEx_(Key, "", 0, @Type, @Buffer$, @BufferSize) = #ERROR_SUCCESS 
;         OutputDirectory$ = GetPathPart(Mid(Buffer$, 2, Len(Buffer$)-7)) 
;       EndIf 
;     EndIf 
;   Else  ; The same for Win9x 
;     If RegOpenKeyEx_(#HKEY_LOCAL_MACHINE, "Software\Classes\PureBasic.exe\shell\open\command", 0, #KEY_ALL_ACCESS , @Key) = #ERROR_SUCCESS 
;       If RegQueryValueEx_(Key, "", 0, @Type, @Buffer$, @BufferSize) = #ERROR_SUCCESS 
;         OutputDirectory$ = GetPathPart(Mid(Buffer$, 2, Len(Buffer$)-7)) 
;       EndIf 
;     EndIf 
;   EndIf 
;   ProcedureReturn OutputDirectory$
  ProcedureReturn #PB_Compiler_Home
EndProcedure


Procedure CheckLanguages()
  Protected dirid.i, file.s, a$, b$
  ClearList(languages())    ; clear the languages list
  AddElement(languages()) : languages() = "English"   ; add fixed (inbuilt) language
  AddElement(languages()) : languages() = "Deutsch"   ; add fixed (inbuilt) language
  AddElement(languages()) : languages() = "Francais"  ; add fixed (inbuilt) language

  If ExamineDirectory(0,localepath$,"*.catalog")
    dirid=NextDirectoryEntry(0)
    While dirid
      If dirid = 1    ; file detected
        file.s=DirectoryEntryName(0)
        If ReadFile(0,localepath$+file)
          a$ = ReadString(0)
          If Left(a$,18) = "CAV - Catalog File"   ; second check to be sure ;-)
            AddElement(languages())
            b$ = RemoveString(file,".catalog")    ; get filename for adding to language list
            languages() = UCase(Left(b$,1)) + LCase(Right(b$,Len(b$)-1))
          EndIf
          CloseFile(0)
        EndIf
      EndIf
      dirid=NextDirectoryEntry(0)
    Wend
    FinishDirectory(0)
  Else
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      MessageRequester(Language$(73), "Loading of further locale files failed!" + Chr(10) + "LocalePath: " + localepath$, #MB_ICONERROR)
    CompilerElse
      MessageRequester(Language$(73), "Loading of further locale files failed!" + Chr(10) + "LocalePath: " + localepath$)
    CompilerEndIf
  EndIf
EndProcedure


Procedure.l LoadLanguage(LanguageName$)
  Protected file.s, dummy$, a$, a.i
  file.s = localepath$ + LanguageName$ + ".catalog"
  If ReadFile(0, file)
    dummy$ = ReadString(0)
    a$ = ReadString(0)  ; we need the second line
    If Left(a$,7) = "Author:"    ; Author found on 2nd line
      localeauthor$ = Trim(Right(a$,Len(a$)-7))
    Else
      localeauthor$ = "unknown"
    EndIf
    dummy$ = ReadString(0)   ; we don't need the third line
    a = 0
    Repeat  ; we have skipped the first 3 lines of the catalog file, containing only info stuff
      Language$(a) = ReadString(0)
      a + 1
    Until Eof(0) = #True Or a = #locstrings
    CloseFile(0)
    ProcedureReturn 1
  Else
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      MessageRequester(Language$(73),Language$(74)+" "+LanguageName$+Language$(75),#MB_ICONERROR)    ; LanguageFile *name* couldn't be loaded!
    CompilerElse
      MessageRequester(Language$(73),Language$(74)+" "+LanguageName$+Language$(75))    ; LanguageFile *name* couldn't be loaded!
    CompilerEndIf    
    ProcedureReturn 0
  EndIf
EndProcedure


Procedure SetLanguage()
  Protected k.i
  If prefs$(0) = "Deutsch"
    Lang = 1
    localeauthor$ = "Andre Beer"
    Restore BaseLanguage
  ElseIf prefs$(0) = "Francais"
    Lang = 2
    localeauthor$ = "Benjamin Pecek / Droopy / Philippe 'gnozal' Guntz"    
    Restore FrenchLanguage
  ElseIf prefs$(0) = "English"
    Lang = 0
    localeauthor$ = "Andre Beer"
    Restore EnglishLanguage
  Else
    Lang = 3
  EndIf
 
  If Lang > 2    ; no included language is set
    LoadLanguage(prefs$(0))
;     If ReadCatalog(localepath$+prefs$(0)+".catalog") = #False
;       MessageRequester(Language$(73),Language$(7),#MB_ICONERROR)    ; "No valid CAV catalog file, current language will be further used
;     EndIf
  Else
    ; we always load a base language (better, if something fails with the locale files to load)
    For k=0 To #locstrings
      Read.s Language$(k)
    Next
  EndIf
EndProcedure


Procedure InitPrefs()
  ; needed if there isn't any valid CAV.prefs file ...
  prefs(0) = 0
  prefs(1) = 0
  prefs(2) = 0
  prefs(3) = 1
  prefs(4) = 1
  prefs(5) = 1    ; show OS
  prefs(6) = 1    ; show Demo
  prefs(7) = 1    ; show description
  prefs(8) = 0
  prefs(9) = 1
  prefs(10) = 0
  prefs(11) = 0
  prefs(12) = 0
  prefs(13) = 0
  prefs(14) = 1
  prefs(15) = 1
  prefs(16) = 1
  prefs(17) = 1
  prefs(18) = 1
  prefs(19) = 0           ; SyntaxHighlighting colors, here for: Standard Text (and all other items not listed below)
  prefs(20) = 6710784     ; SyntaxHighlighting colors, here for: PB Keywords
  prefs(21) = 6710784     ; SyntaxHighlighting colors, here for: PB Commands/Functions and WinAPI commands
  prefs(22) = 7490450     ; SyntaxHighlighting colors, here for: ASM commands
  prefs(23) = 7490450     ; SyntaxHighlighting colors, here for: Constants
  prefs(24) = 11184640    ; SyntaxHighlighting colors, here for: Comments
  prefs(25) = 14811135    ; Background color for EditorGadget; standard = yellow-white
  prefs(26) = 6605055     ; Background color for found search items
  ; ***
  prefs(28) = 1           ; Prefs/Windows: Use BubbleHelp
  prefs(29) = 0           ; CodeTester: Compile&Run
  prefs(30) = 1           ; CodeTester: WaitForEnd (=1) or Asynchronous (=0)
  prefs(31) = 0           ; CodeTester: EnableDebugger
  prefs(32) = 0           ; CodeTester: EnableInlineASM
  prefs(33) = 0           ; CodeTester: StartFromHere
  prefs(34) = 0           ; MainWin: set SearchDateRange 
  prefs(35) = 1           ; Full-text search: also search in filenames of the codes
  prefs(36) = 0           ; Show only Demo compatible codes  (=1 when set)
   
  prefs$(0) = "English"   ; Current language
  prefs$(1) = ""          ; path of the original PB IDE
  prefs$(2) = ""          ; InputSettings: SearchAuthor
  prefs$(3) = ""          ; InputSettings: SearchFullText
  prefs$(4) = ""          ; path of alternate editor (jaPBe)
  prefs$(5) = "http://forums.purebasic.com/"      ; Link to english forum
  prefs$(6) = "http://www.pure-board.de/"         ; Link to german forum
  prefs$(7) = "http://forums.purebasic.fr/"       ; Link to french forum
  prefs$(8) = "http://www.purebasic-lounge.de/"   ; Link to pb lounge
EndProcedure


Procedure LoadPrefs()
  Lang = 1    ; Locale language is set here: english is used as main language
  If OpenPreferences(prefspath$+"CAV.prefs")
    PreferenceGroup("General")
      prefs(0) = ReadPreferenceLong("SaveWindowPos",0)    ; save main window position isn't enabled as standard
      prefs(1) = ReadPreferenceLong("WindowX"      ,0)
      prefs(2) = ReadPreferenceLong("WindowY"      ,0)
      prefs(8) = ReadPreferenceLong("AutoSavePrefs",0)
      prefs(14)= ReadPreferenceLong("AskSavePrefs", 0)
      prefs(15)= ReadPreferenceLong("ShowToolTipps",1)
      prefs(16)= ReadPreferenceLong("NoMainToolTipps",0)
      prefs(36)= ReadPreferenceLong("OnlyDemoCompatibleCodes",0)

    PreferenceGroup("Language")
      prefs$(0) = ReadPreferenceString("CurrentLanguage"     ,"English")   ; we use english as main language  (english, german and french are in-built)
;      prefs(1)  = ReadPreferenceLong  ("CurrentLanguageState" ,0)   ; **** we probably can't save a fixed value, because users could flexibly add/delete locale files

    PreferenceGroup("CodeViewer")
      prefs(25) = ReadPreferenceLong("EditorBackgroundColor",14811135)
      prefs(26) = ReadPreferenceLong("SearchTermBackgroundColor",6605055)
      prefs(18) = ReadPreferenceLong("UseSyntaxHighlighting"  ,1)
      prefs(19) = ReadPreferenceLong("SyntaxHighlight_Standard"      ,0)
      prefs(20) = ReadPreferenceLong("SyntaxHighlight_PBKeywords"    ,6710784)
      prefs(21) = ReadPreferenceLong("SyntaxHighlight_PBFunctions"   ,6710784)
      prefs(22) = ReadPreferenceLong("SyntaxHighlight_ASMCommands"   ,7490450)
      prefs(23) = ReadPreferenceLong("SyntaxHighlight_Constants"     ,7490450)
      prefs(24) = ReadPreferenceLong("SyntaxHighlight_Comments"      ,11184640)

    PreferenceGroup("Windows")
      prefs(28) = ReadPreferenceLong("UseBubbleHelp", 1)

    PreferenceGroup("External")
      prefs(17) = ReadPreferenceLong("UsePureBasicIDE",1)     ; will use original PB IDE when 1, else the alternate set editor (jaPBe)
      prefs$(1) = ReadPreferenceString("EditorPath"          , "")   ; path of the original PB IDE
      prefs$(4) = ReadPreferenceString("EditorPathAlternate" , "")   ; path of alternate editor (jaPBe)

    PreferenceGroup("FileTreeSettings")
      prefs(3) = ReadPreferenceLong  ("ShowDirDescription"  , 1)   ; showing of directory descriptions in TreeGadget is enabled
      prefs(4) = ReadPreferenceLong  ("ShowFileDescription" , 1)   ;   - " -    file   - " -

    PreferenceGroup("SearchInputSettings")
      prefs(9) = ReadPreferenceLong  ("ReturnHandler", 1)
      prefs(10)= ReadPreferenceLong  ("SearchForum", 0)
      prefs$(2)= ReadPreferenceString("SearchAuthor","")
      prefs(34)= ReadPreferenceLong  ("SeachDateRange",0)
      prefs(11)= ReadPreferenceLong  ("SeachDay", 0)
      prefs(12)= ReadPreferenceLong  ("SeachMonth", 0)
      prefs(13)= ReadPreferenceLong  ("SeachYear", 0)
      prefs$(3)= ReadPreferenceString("SearchFullText","")

    PreferenceGroup("SearchResultSettings")
      prefs(5) = ReadPreferenceLong  ("SearchOS"     , 1)
      prefs(6) = ReadPreferenceLong  ("SearchDemo"   , 1)
      prefs(35)= ReadPreferenceLong  ("SearchFileNames", 1)
      prefs(7) = ReadPreferenceLong  ("ShowDesc"     , 1)

    PreferenceGroup("CodeTesterSettings")
      prefs(29) = ReadPreferenceLong  ("CompileRun"     , 0) 
      prefs(30) = ReadPreferenceLong  ("WaitForEnd"     , 1) 
      prefs(31) = ReadPreferenceLong  ("EnableDebugger" , 0) 
      prefs(32) = ReadPreferenceLong  ("EnableInlineASM", 0) 
      prefs(33) = ReadPreferenceLong  ("StartFromHere"  , 0) 

    PreferenceGroup("ForumLinks")
      prefs$(5) = ReadPreferenceString ("ForumEnglish","http://forums.purebasic.com/")
      prefs$(6) = ReadPreferenceString ("ForumGerman", "http://www.pure-board.de/")
      prefs$(7) = ReadPreferenceString ("ForumFrench", "http://forums.purebasic.fr/")
      prefs$(8) = ReadPreferenceString ("ForumLounge", "http://www.purebasic-lounge.de/")

  Else
    MessageRequester("Error","Can't open preferences file <" + prefspath$+"CAV.prefs"+">, we will use standard settings.",0)
    InitPrefs()     ; use standard values as preferences
  EndIf

;  RestoreTempPrefs()   ; copy the prefs values/strings also to the temp-prefs
  
  
;   Debug "Prefs-Strings"
;   For a=0 To 10
;     Debug prefs$(a)
;   Next
;   Debug "Prefs-Longs"
;   For a=0 To 10
;     Debug prefs(a)
;   Next
EndProcedure



Procedure SetPrefsSettings()
  Protected a.i, b.i, a$
      ; now we find the saved languages and detect the right state (0 = english, 1 = german, 2 = francais, 3,4,5,... = other)
;      If prefs$(0) <> ""     ; only if there is something saved
      ResetList(languages())
      a = -1
      Repeat
        b = NextElement(languages())
        If b : a+1 : EndIf
      Until languages() = prefs$(0) Or b = 0
      SetGadgetState(#PrefLangChoose,a)

      SetGadgetState(#PrefSaveWinPos, prefs(0))
      SetGadgetState(#PrefAutoSave  , prefs(8))
      SetGadgetState(#PrefAskSave   , prefs(14))
      CheckBoxGadgetState(#PrefAutoSave, #PrefAskSave)      ; disable second gadget if needed
      SetGadgetState(#PrefToolTips  , prefs(15))
      SetGadgetState(#PrefToolTipMain,prefs(16))
      CheckBoxGadgetState(#PrefToolTips, #PrefToolTipMain)  ; disable second gadget if needed
    
      ; Set path to original PB editor
      If prefs$(1) <> ""
        a$ = prefs$(1)
        ;      If GetGadgetText(#PrefEditorPath) = ""
      Else
        a$ = GetPBDir() + "PureBasic.exe"    ; if there isn't any (valid) entry in the path field, then set the PB standard path
        prefs$(1) = a$                       ; we set the path to the purebasic IDE to the current prefs settings
      EndIf
      SetGadgetText(#PrefEditorPath,a$)

      ; Set path to alternate editor (jaPBe)
      If prefs$(4) <> ""
        SetGadgetText(#PrefEditorPath2,prefs$(4))
      EndIf
      If prefs(17) = 1
        SetGadgetState(#PrefEditOriginal,1)
      Else
        SetGadgetState(#PrefEditAlternate,1)
      EndIf
      SetActiveEditor()


      SetGadgetState(#PrefDirDesc     , prefs(3))
      SetGadgetState(#PrefFileDesc    , prefs(4))
      
      If prefs(9) = 0
        SetGadgetState(#PrefReturnHnd1,1)
      Else
        SetGadgetState(#PrefReturnHnd2,1)
      EndIf
;      SetGadgetState(#PrefSaveItems   , prefs(10))
      SetGadgetState(#PrefSearchOS    , prefs(5))
      SetGadgetState(#PrefSearchDemo  , prefs(6))
      SetGadgetState(#PrefSearchFileName, prefs(35))
      SetGadgetState(#PrefSearchDesc  , prefs(7))

      ; Syntax highlighting colors settings
      SetGadgetState(#PrefSyntaxH,prefs(18))
      SetSyntaxHighlightingColors()
      
      CompilerIf  #os = #windows
        SetGadgetState(#PrefBubbleHelp,prefs(28))
      CompilerEndIf
            
EndProcedure


Procedure OpenPrefsWin()
  Protected Flags.l, x, y, w, w2, a
;  LoadPrefs()
  Flags.l = #PB_Window_SystemMenu|#PB_Window_TitleBar|#PB_Window_Invisible|#PB_Window_ScreenCentered
  
  If OpenWindow(#PrefWin, 0, 0, 550, 350, "C.A.V. - "+Language$(64), Flags)
      PanelGadget(#PrefPanel, 3, 3, 546, 310)
      ;- Prefs-General
      AddGadgetItem(#PrefPanel, -1, Language$(159))
        x = 17 : y = 20 : w = 500
        ; Frame3DGadget (#PrefFrame1      ,x-9   ,y-10,w+23,148,"",#PB_Frame3D_Double)  changed that for better styling (Fred on 02-Feb-2005)
        Frame3DGadget (#PrefFrame1      ,x-9   ,y-14, w+23 , 152, "")    ; deleted the #PB_Frame3D_Double for better styling (Fred on 02-Feb-2005)
        TextGadget    (#PrefLangText    ,x     ,y+2 , 158  , 20 , Language$(73))
        ComboBoxGadget(#PrefLangChoose  ,x+160 ,y-2 , 190  , 20)           : y + 27
        CheckLanguages()
        ResetList(languages())
        While NextElement(languages())
          AddGadgetItem(#PrefLangChoose, -1, languages())
        Wend
      
        CheckBoxGadget(#PrefSaveWinPos  , x     , y, w, 20, Language$(77))  : y + 20
        CheckBoxGadget(#PrefAutoSave    , x     , y, w, 20, Language$(80))  : y + 20
        CheckBoxGadget(#PrefAskSave     , x+25  , y, w-25, 20, Language$(157)) : y + 25
        CheckBoxGadget(#PrefToolTips    , x     , y, w, 20, Language$(165))  : y + 20
        CheckBoxGadget(#PrefToolTipMain , x+25  , y, w-25, 20, Language$(142)) : y + 48
      
        Frame3DGadget (#PrefFrame2       , x-9   , y-17, w+23, 105, Language$(168))
        OptionGadget  (#PrefEditOriginal , x+2   , y+12, 15  ,  20, "")
        OptionGadget  (#PrefEditAlternate, x+2   , y+56, 15  ,  20, "")
        TextGadget    (#PrefEditorText   , x+25  , y   , w-20,  20, Language$(67)) : y + 17
        StringGadget  (#PrefEditorPath   , x+23  , y   , w-57,  20, "")     ; <= set here the saved path of the PB editor from prefs file
        ButtonGadget  (#PrefEditorSelect , x+w-30, y   , 30  ,  20, "...")       : y + 27
        TextGadget    (#PrefEditorText2  , x+25  , y   , w-20,  20, Language$(169)) : y + 17
        StringGadget  (#PrefEditorPath2  , x+23  , y   , w-57,  20, "")     ; <= set here the saved path of the alternate editor from prefs file
        ButtonGadget  (#PrefEditorSelect2, x+w-30, y   , 30  ,  20, "...")       : y + 50


      ;- Prefs-Functions
      AddGadgetItem(#PrefPanel, -1, Language$(160))
        x = 17 : y = 20 : w = 500
        Frame3DGadget (#PrefFrame3      , x-9 , y-15, w+23,  62, Language$(81))   ; DirTree
        CheckBoxGadget(#PrefDirDesc     , x   , y   , w   ,  20, Language$(65)) : y + 20
        CheckBoxGadget(#PrefFileDesc    , x   , y   , w   ,  20, Language$(66)) : y + 52

        Frame3DGadget (#PrefFrame4      , x-9 , y-17, w+23, 162, Language$(82))    ; Search results
        TextGadget    (#PrefReturnText  , x   , y   , w   ,  20, Language$(158)) : y + 17
        OptionGadget  (#PrefReturnHnd1  , x+20, y   , w-20,  20, Language$(122)) : y + 18
        OptionGadget  (#PrefReturnHnd2  , x+20, y   , w-20,  20, Language$(123)) : y + 25
;   CheckBoxGadget(#PrefSaveItems   ,x     ,y,w,20,Language$(124)) : y + 25
        CheckBoxGadget(#PrefSearchOS    , x   , y   , w   ,  20, Language$(83)) : y + 20
        CheckBoxGadget(#PrefSearchDemo  , x   , y   , w   ,  20, Language$(84)) : y + 20
        CheckBoxGadget(#PrefSearchDesc  , x   , y   , w   ,  20, Language$(66)) : y + 20
        CheckBoxGadget(#PrefSearchFileName, x , y   , w   ,  20, Language$(224)): y + 20

      ;- Prefs-CodeViewer
        ; Here we set different image sizes for each OS:
        CompilerIf #PB_Compiler_OS = #PB_OS_Windows
          x = 20 : y = 20
        CompilerElse
          x = 12 : y = 12
        CompilerEndIf
      For a = 1 To 8
        CreateImage(a, x, y)
        StartDrawing(ImageOutput(a))
          Box(0, 0, x, y, prefs(18+a))
        StopDrawing()
      Next
      
      AddGadgetItem(#PrefPanel,-1,Language$(188))    ; Syntax-Highlighting in CodeView
        x = 17 : y = 20 : w = 500
        Frame3DGadget    (#PrefFrame5             ,x-9  ,y-15,w+23,42,Language$(193))   
        ButtonImageGadget(#PrefEditorBackColor    ,x    ,y  ,20 ,20,ImageID(7))
        TextGadget       (#PrefEditorBackColorText,x+32 ,y+3,130,20,Language$(194))
        ButtonImageGadget(#PrefEditorSearchColor  ,x+165,y  ,20 ,20,ImageID(8))
        TextGadget       (#PrefEditorSearchColorTx,x+197,y+3,150,20,Language$(220)) : y + 48
        
        Frame3DGadget (#PrefFrame6      ,x-9   ,y-15,w+23,218,Language$(190))   
        CheckBoxGadget(#PrefSyntaxH     ,x     ,y,w  ,20,Language$(189)) : y + 25
        x + 25
        ButtonImageGadget(#PrefSyntaxH_StandColor ,x   ,y  ,20 ,20,ImageID(1))
        TextGadget       (#PrefSyntaxH_Standard   ,x+35,y+3,200,20,Language$(199))  : y + 25
        ButtonImageGadget(#PrefSyntaxH_PBKeyColor ,x   ,y  ,20 ,20,ImageID(2))
        TextGadget       (#PrefSyntaxH_PBKeywords ,x+35,y+3,200,20,Language$(149))  : y + 25
        ButtonImageGadget(#PrefSyntaxH_PBComColor ,x   ,y  ,20 ,20,ImageID(3))
        TextGadget       (#PrefSyntaxH_PBCommmands,x+35,y+3,200,20,Language$(150))  : y + 25
        ButtonImageGadget(#PrefSyntaxH_PBAsmColor ,x   ,y  ,20 ,20,ImageID(4))
        TextGadget       (#PrefSyntaxH_ASMCommands,x+35,y+3,200,20,Language$(151))  : y + 25
        ButtonImageGadget(#PrefSyntaxH_PBConColor ,x   ,y  ,20 ,20,ImageID(5))
        TextGadget       (#PrefSyntaxH_Constants  ,x+35,y+3,200,20,Language$(191))  : y + 25
        ButtonImageGadget(#PrefSyntaxH_ComColor   ,x   ,y  ,20 ,20,ImageID(6))
        TextGadget       (#PrefSyntaxH_Comments   ,x+35,y+3,200,20,Language$(195))  : y + 25
        ButtonGadget     (#PrefSyntaxH_SetStandard,x   ,y  ,235,20,Language$(192))


      ;- Prefs-ForumLinks
      AddGadgetItem(#PrefPanel,-1,Language$(228))    ; Forum links 
        x = 26 : y = 25 : w = 500
        Frame3DGadget    (#PrefFrame8      , x-18 , y-20, w+23, 145, Language$(229))   
        TextGadget       (#PrefForumsText1 , x    , y+3, 140  , 20, Language$(230))
        StringGadget     (#PrefForumsInput1, x+150, y,   w-170, 20, prefs$(5))  : y + 30
        TextGadget       (#PrefForumsText2 , x    , y+3, 140,   20, Language$(231))
        StringGadget     (#PrefForumsInput2, x+150, y,   w-170, 20, prefs$(6))  : y + 30
        TextGadget       (#PrefForumsText3 , x    , y+3, 140,   20, Language$(232))
        StringGadget     (#PrefForumsInput3, x+150, y,   w-170, 20, prefs$(7))  : y + 30
        TextGadget       (#PrefForumsText4 , x    , y+3, 140,   20, Language$(233))
        StringGadget     (#PrefForumsInput4, x+150, y,   w-170, 20, prefs$(8))


      ;- Prefs-Windows
     CompilerIf  #os = #windows
      AddGadgetItem(#PrefPanel,-1,Language$(161))    ; Windows special
        x = 17 : y = 22 : w = 500
        Frame3DGadget    (#PrefShortcuts, x-9 , y-17, w+23, 78, Language$(162))   
        ButtonGadget  (#PrefDesktop     , x+35, y   , w-70, 25, Language$(163)) : y + 30
        ButtonGadget  (#PrefStartmenu   , x+35, y   , w-70, 25, Language$(164)) : y + 53
        
        Frame3DGadget (#PrefFrame7      , x-9 , y-15, w+23, 42, Language$(222))   
        CheckBoxGadget(#PrefBubbleHelp  , x   , y   , w   , 20, Language$(221))
     CompilerEndIf
      CloseGadgetList()

      x = 17 : y = 320 : w = 518
      w2 = w/3-10
      ButtonGadget  (#PrefSave        ,x+2      ,y, w2, 25, Language$(69))
      ButtonGadget  (#PrefUse         ,x+w2+13  ,y, w2, 25, Language$(70))
      ButtonGadget  (#PrefCancel      ,x+w2*2+24,y, w2, 25, Language$(71))

    AddKeyboardShortcut(#PrefWin,#PB_Shortcut_Escape,#PrefWinExit)
    AddKeyboardShortcut(#PrefWin,#PB_Shortcut_Return,#PrefReturn)      ; Return-Handler for the Use/Save/Cancel buttons
  EndIf
  
  SetPrefsSettings()
EndProcedure


CompilerIf  #os = #windows
  Procedure.l AddTooltip(Gadget, Tooltext$, maxW) 
    ;--> Remove the #TTS_BALLOON flag in the next line if you want the rectangular Tooltip 
    hToolTip = CreateWindowEx_(0, "ToolTips_Class32", "", #WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON, 0, 0, 0, 0, 0, 0, GetModuleHandle_(0), 0) 
    SendMessage_(hToolTip, #TTM_SETTIPTEXTCOLOR, GetSysColor_(#COLOR_INFOTEXT), 0) 
    SendMessage_(hToolTip, #TTM_SETTIPBKCOLOR, GetSysColor_(#COLOR_INFOBK), 0) 
    ttAdd.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
    ttAdd\uFlags = #TTF_SUBCLASS | #TTF_IDISHWND 
    ;--> Here's where the multiline comes into play by setting the maxWidth 
    SendMessage_(hToolTip, #TTM_SETMAXTIPWIDTH, 0, maxW) 
    ttAdd\hWnd = GadgetID(Gadget)   ;WindowID(#MainWindow)
    ttAdd\uId = GadgetID(Gadget) 
    ttAdd\hinst = 0 
    ttAdd\lpszText = @Tooltext$ 
    SendMessage_(hToolTip, #TTM_ADDTOOL, 0, ttAdd) 
    SendMessage_(hToolTip, #TTM_SETDELAYTIME, #TTDT_AUTOPOP, 6000) 
;    SendMessage_(hToolTip, #TTM_UPDATE , 0, 0) 
    ProcedureReturn hToolTip
  EndProcedure 

; Procedure BalloonTipWindow(windowID, balloonText$, balloonTitle$, balloonIcon) 
;   hBalloonTip = CreateWindowEx_(0, "ToolTips_Class32", "", #WS_POPUP | #TTS_NOPREFIX, 0, 0, 0, 0, 0, 0, GetModuleHandle_(0), 0) 
;   SendMessage_(hBalloonTip, #TTM_SETTIPTEXTCOLOR, RGB(0, 0, 0), 0) 
;   SendMessage_(hBalloonTip, #TTM_SETTIPBKCOLOR, RGB(150, 150, 150), 0) 
;   Balloon\cbSize = SizeOf(TOOLINFO) 
;   Balloon\uFlags = #TTF_IDISHWND | #TTF_SUBCLASS 
;   Balloon\hwnd = WindowID(windowID) 
;   Balloon\uID = WindowID(windowID) 
;   Balloon\lpszText = @balloonText$ 
;   SendMessage_(hBalloonTip, #TTM_ADDTOOL, 0, Balloon) 
;   SendMessage_(hBalloonTip, #TTM_SETDELAYTIME, #TTDT_AUTOPOP, 10000) 
;   If balloonTitle$ > "" 
;     SendMessage_(hBalloonTip, #TTM_SETTITLE, balloonIcon, @balloonTitle$) 
;   EndIf 
; EndProcedure 
;/ 
; Procedure UpdateBalloonTipWindow(windowID, balloonText$) 
;   Balloon\cbSize = SizeOf(TOOLINFO) 
;   Balloon\hwnd = WindowID(windowID) 
;   Balloon\uID = WindowID(windowID) 
;   Balloon\lpszText = @balloonText$ 
;   SendMessage_(hBalloonTip, #TTM_UPDATETIPTEXT, 0, Balloon) 
; EndProcedure 
; 


; Procedure BalloonTip(WindowID, Gadget, Text$ , Title$, Icon) 
;   
;   ToolTip=CreateWindowEx_(0,"ToolTips_Class32","",#WS_POPUP | #TTS_NOPREFIX | #TTS_BALLOON,0,0,0,0,WindowID,0,GetModuleHandle_(0),0) 
;   SendMessage_(ToolTip,#TTM_SETTIPTEXTCOLOR,GetSysColor_(#COLOR_INFOTEXT),0) 
;   SendMessage_(ToolTip,#TTM_SETTIPBKCOLOR,GetSysColor_(#COLOR_INFOBK),0) 
;   SendMessage_(ToolTip,#TTM_SETMAXTIPWIDTH,0,180) 
;   Balloon.TOOLINFO\cbSize=SizeOf(TOOLINFO) 
;   Balloon\uFlags=#TTF_IDISHWND | #TTF_SUBCLASS 
;   Balloon\hWnd=GadgetID(Gadget) 
;   Balloon\uId=GadgetID(Gadget) 
;   Balloon\lpszText=@Text$ 
;   SendMessage_(ToolTip, #TTM_ADDTOOL, 0, Balloon) 
;   If Title$ > "" 
;     SendMessage_(ToolTip, #TTM_SETTITLE, Icon, @Title$) 
;   EndIf 
;   
; EndProcedure 
; 
; Procedure DelBalloonTip(Gadget); Mein Tip (Falko) 
;   Balloon.TOOLINFO\cbSize=SizeOf(TOOLINFO) 
;   Balloon\hWnd=GadgetID(Gadget) 
;   Balloon\uId=GadgetID(Gadget) 
;   SendMessage_(ToolTip, #TTM_DELTOOL, 0, Balloon) 
; EndProcedure 
; 


  Procedure.l RemoveToolTip(hTT.l, Gadget.l) 
    ttRemove.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
    ttRemove\hWnd = GadgetID(Gadget) ;WindowID() 
    ttRemove\uId = GadgetID(Gadget) 
    SendMessage_(hTT, #TTM_DELTOOL, 0, ttRemove) 
  EndProcedure 

  Procedure.l ChangeToolTip(hTT.l, Gadget.l, Tooltext$) 
    ttChange.TOOLINFO\cbSize = SizeOf(TOOLINFO) 
    ttChange\hWnd = GadgetID(Gadget)   ;WindowID() 
    ttChange\uId = GadgetID(Gadget) 
    ttChange\lpszText = @Tooltext$
    SendMessage_(hTT, #TTM_UPDATETIPTEXT, 0, ttChange) 
  EndProcedure 
CompilerEndIf


Procedure SetMainWinToolTips()
  Protected State
  ; SetMainWinToolTips() is used by the OpenMainWindow() and ChangeGUILanguage() procedures
  
  If prefs(15) = 1     ; show tooltips
    If prefs(16) = 1   ; no tooltips for tree/searchresults/codeviewer
      state = 1
    Else
      state = 2        ; show all tooltips
    EndIf
  Else
    state = 0
  EndIf

;Debug "Tooltip-State: "+Str(state)

  ; State = 0    ; display no tooltips
  ; State = 1    ; display tooltips, but not for tree/search-results/code-display
  ; State = 2    ; display all tooltips
  
  
  
  CompilerIf #os = #windows
    If State > 0 And prefs(28) = 1     ; use BubbleHelp instead of normal Tooltips
      If TTHandles(0) = 0    ; do the work only, if tooltips are NOT already existing 
        ; Search buttons and string fields
        TTHandles(0) = AddToolTip(#SearchSourceInput, Language$(126),300)
        TTHandles(1) = AddToolTip(#SearchAuthorInput, Language$(127),300)
        TTHandles(2) = AddToolTip(#SearchAuthorSelect,Language$(128),300)
        TTHandles(3) = AddToolTip(#SearchDateRange,   Language$(218),300)
        TTHandles(4) = AddToolTip(#SearchDateDay,     Language$(129),300)
        TTHandles(5) = AddToolTip(#SearchDateMonth,   Language$(130),300)
        TTHandles(6) = AddToolTip(#SearchDateYear,    Language$(131),300)
        TTHandles(7) = AddToolTip(#SearchFullInput,   Language$(35) ,300)
        TTHandles(8) = AddToolTip(#SearchKeywords,    Language$(36) ,300)
        TTHandles(9) = AddToolTip(#ResetSearch,       Language$(7)  ,300)
        TTHandles(10) = AddToolTip(#StartSearch,       Language$(125),300)
    
        ; Buttons beside the Treeview, ListIcon, EditorGadget
        TTHandles(11) = AddToolTip(#ResultShow,       Language$(135),300)    ; there are 2 tooltipps, because the button name changes to 'Back' when EditorGadget is displayed
        TTHandles(12) = AddToolTip(#ResultForum,      Language$(136),300)
        TTHandles(13) = AddToolTip(#ResultEditor,     Language$(137),300)
        TTHandles(14) = AddToolTip(#ShowFileTree,     Language$(138),300)
        TTHandles(15) = AddToolTip(#CloseFileTree,    Language$(139),300)
        TTHandles(16) = AddToolTip(#PureAreaPic,      Language$(140),300)
      Else        ; Tooltips are already existing, so we need to update them (probably because of a language change)
        ; Search buttons and string fields
        ChangeTooltip(TTHandles(0), #SearchSourceInput, Language$(126))
        ChangeTooltip(TTHandles(1), #SearchAuthorInput, Language$(127))
        ChangeTooltip(TTHandles(2), #SearchAuthorSelect,Language$(128))
        ChangeTooltip(TTHandles(3), #SearchDateRange,   Language$(218))
        ChangeTooltip(TTHandles(4), #SearchDateDay,     Language$(129))
        ChangeTooltip(TTHandles(5), #SearchDateMonth,   Language$(130))
        ChangeTooltip(TTHandles(6), #SearchDateYear,    Language$(131))
        ChangeTooltip(TTHandles(7), #SearchFullInput,   Language$(35))
        ChangeTooltip(TTHandles(8), #SearchKeywords,    Language$(36))
        ChangeTooltip(TTHandles(9), #ResetSearch,       Language$(7))
        ChangeTooltip(TTHandles(10), #StartSearch,       Language$(125))
        ; Buttons beside the Treeview, ListIcon, EditorGadget
        ChangeTooltip(TTHandles(11), #ResultShow,       Language$(135))
        ChangeTooltip(TTHandles(12), #ResultForum,      Language$(136))
        ChangeTooltip(TTHandles(13), #ResultEditor,     Language$(137))
        ChangeTooltip(TTHandles(14), #ShowFileTree,     Language$(138))
        ChangeTooltip(TTHandles(15), #CloseFileTree,    Language$(139))
        ChangeTooltip(TTHandles(16), #PureAreaPic,      Language$(140))
      EndIf
    Else 
      If TTHandles(0) > 0    ; do the work only, if tooltips are already existing 
        ; Search buttons and string fields
        RemoveToolTip(TTHandles(0) ,#SearchSourceInput)     : TTHandles(0) = 0
        RemoveToolTip(TTHandles(1) ,#SearchAuthorInput)     : TTHandles(1) = 0
        RemoveToolTip(TTHandles(2) ,#SearchAuthorSelect)    : TTHandles(2) = 0
        RemoveToolTip(TTHandles(3) ,#SearchDateRange)       : TTHandles(3) = 0
        RemoveToolTip(TTHandles(4) ,#SearchDateDay)         : TTHandles(4) = 0
        RemoveToolTip(TTHandles(5) ,#SearchDateMonth)       : TTHandles(5) = 0
        RemoveToolTip(TTHandles(6) ,#SearchDateYear)        : TTHandles(6) = 0
        RemoveToolTip(TTHandles(7) ,#SearchFullInput)       : TTHandles(7) = 0
        RemoveToolTip(TTHandles(8) ,#SearchKeywords)        : TTHandles(8) = 0
        RemoveToolTip(TTHandles(9) ,#ResetSearch)           : TTHandles(9) = 0
        RemoveToolTip(TTHandles(10) ,#StartSearch)           : TTHandles(10) = 0
        
        ; Buttons beside the Treeview, ListIcon, EditorGadget
        RemoveToolTip(TTHandles(11) ,#ResultShow)           : TTHandles(11) = 0
        RemoveToolTip(TTHandles(12) ,#ResultForum)          : TTHandles(12) = 0
        RemoveToolTip(TTHandles(13) ,#ResultEditor)         : TTHandles(13) = 0
        RemoveToolTip(TTHandles(14) ,#ShowFileTree)         : TTHandles(14) = 0
        RemoveToolTip(TTHandles(15) ,#CloseFileTree)        : TTHandles(15) = 0
        RemoveToolTip(TTHandles(16) ,#PureAreaPic)          : TTHandles(16) = 0
      EndIf
    EndIf
  
    If State > 1 And prefs(28) = 1
      If TTHandles(17) = 0    ; do the work only, if tooltips are NOT already existing 
        ; TreeView / ListIcon / EditorGadget
        TTHandles(17) = AddToolTip(#ResultList,        Language$(132),300)
        TTHandles(18) = AddToolTip(#EditorSource,      Language$(133),300)
        TTHandles(19) = AddToolTip(#FileTree,          Language$(134),300)
      EndIf
    Else
      If TTHandles(17) > 0    ; do the work only, if tooltips are NOT already existing 
        ; TreeView / ListIcon / EditorGadget
        RemoveToolTip(TTHandles(17) ,#ResultList)           : TTHandles(17) = 0
        RemoveToolTip(TTHandles(18) ,#EditorSource)         : TTHandles(18) = 0
        RemoveToolTip(TTHandles(19) ,#FileTree)             : TTHandles(19) = 0
      EndIf
    EndIf

  CompilerElse  
    ; ************* This is the   #os = #linux   compatible section ***********************
    ;If #PB_Compiler_OS = #PB_OS_MacOS Or (State > 0 And prefs(28) = 0)
    If State > 0 And prefs(28) = 0
    
      ; Search buttons and string fields
      GadgetToolTip(#SearchSourceInput, Language$(126))
      GadgetToolTip(#SearchAuthorInput, Language$(127))
      GadgetToolTip(#SearchAuthorSelect,Language$(128))
      GadgetToolTip(#SearchDateRange,   Language$(218))
      GadgetToolTip(#SearchDateDay,     Language$(129))
      GadgetToolTip(#SearchDateMonth,   Language$(130))
      GadgetToolTip(#SearchDateYear,    Language$(131))
      GadgetToolTip(#SearchFullInput,   Language$(35))
      GadgetToolTip(#SearchKeywords,    Language$(36))
      GadgetToolTip(#ResetSearch,       Language$(7))
      GadgetToolTip(#StartSearch,       Language$(125))
  
      ; Buttons beside the Treeview, ListIcon, EditorGadget
      GadgetToolTip(#ResultShow,        Language$(135))    ; there are 2 tooltipps, because the button name changes to 'Back' when EditorGadget is displayed
      GadgetToolTip(#ResultForum,       Language$(136))
      GadgetToolTip(#ResultEditor,      Language$(137))
      GadgetToolTip(#ShowFileTree,      Language$(138))
      GadgetToolTip(#CloseFileTree,     Language$(139))
      GadgetToolTip(#PureAreaPic,       Language$(140))
    Else 
      ; Search buttons and string fields
      GadgetToolTip(#SearchSourceInput, "")
      GadgetToolTip(#SearchAuthorInput, "")
      GadgetToolTip(#SearchAuthorSelect,"")
      GadgetToolTip(#SearchDateRange,   "")
      GadgetToolTip(#SearchDateDay,     "")
      GadgetToolTip(#SearchDateMonth,   "")
      GadgetToolTip(#SearchDateYear,    "")
      GadgetToolTip(#SearchFullInput,   "")
      GadgetToolTip(#SearchKeywords,    "")
      GadgetToolTip(#ResetSearch,       "")
      GadgetToolTip(#StartSearch,       "")
  
      ; Buttons beside the Treeview, ListIcon, EditorGadget
      GadgetToolTip(#ResultShow,        "")
      GadgetToolTip(#ResultForum,       "")
      GadgetToolTip(#ResultEditor,      "")
      GadgetToolTip(#ShowFileTree,      "")
      GadgetToolTip(#CloseFileTree,     "")
      GadgetToolTip(#PureAreaPic,       "")
    EndIf
  
    ;If #PB_Compiler_OS = #PB_OS_MacOS Or (State > 1 And prefs(28) = 0)
    If State > 1 And prefs(28) = 0
      ; TreeView / ListIcon / EditorGadget
      GadgetToolTip(#ResultList,        Language$(132))
      GadgetToolTip(#EditorSource,      Language$(133))
      GadgetToolTip(#FileTree,          Language$(134))
    Else
      ; TreeView / ListIcon / EditorGadget
      GadgetToolTip(#ResultList,        "")
      GadgetToolTip(#EditorSource,      "")
      GadgetToolTip(#FileTree,          "")
    EndIf
  CompilerEndIf
    
EndProcedure 
 

Procedure ChangeGUILanguage()
  Shared files, demofiles
  Protected a, b

  ; *************** MAIN window ******************
  SetGadgetText(#Title,          Language$(0)+" "+#version)
  SetGadgetText(#Codes,          Language$(1)+" "+Str(files)+"  ("+Language$(227)+" "+Str(demofiles)+")")
  SetGadgetText(#SearchFrame,    Language$(2))
  SetGadgetText(#SearchSource,   Language$(3))
  SetGadgetText(#SearchAuthor,   Language$(4))
  SetGadgetText(#SearchDate,     Language$(5))
  SetGadgetText(#SearchDateRange,Language$(218))
  SetGadgetText(#SearchFull,     Language$(6))
  SetGadgetText(#ResetSearch,    Language$(29))
  SetGadgetText(#StartSearch,    Language$(8))
  SetGadgetText(#FrameResults,   Language$(58))    ; Language$(9))   ;  58 = Contents of the CodeArchive, 9 = Search Results


 
  ; ------- Icon's for displaying during performing a search ---------
  SetGadgetText(#SearchProgressText,Language$(85))

  ; ------- Icon's for displaying after performing a search ---------
  ;Column.LV_COLUMN 
  
  ; 1st column "Name"
  SetGadgetItemText(#ResultList, -1, Language$(59), 0)

  ; 2nd column "Dir(s)"
  SetGadgetItemText(#ResultList, -1, Language$(79), 1)
  
  ; 3rd column "OS"
  SetGadgetItemText(#ResultList, -1, Language$(61), 2)

  ; 4th column "Demo"
  SetGadgetItemText(#ResultList, -1, Language$(62), 3)

  ; 5th column "Description"
  SetGadgetItemText(#ResultList, -1, Language$(60), 4)
 ; ------------------------------------------------------------------
      
  SetGadgetText(#ResultShow,     Language$(10))
  SetGadgetText(#ResultForum,    Language$(11))
  SetGadgetText(#ResultEditor,   Language$(12))

  ; ------- Icon's for displaying after performing a search **** Part 2 ***** ---------
  SetGadgetText(#ShowFileTree,   Language$(63))   ; Show FileTree with complete code archive
  ; ------------------------------------------------------------------

  SetGadgetText(#CloseFileTree,  Language$(78))    ; Close FileTree, must be hidden when Search-ListIcon is activated
  SetGadgetText(#PureAreaText,   Language$(89))   ; "Sponsored by"

  ;- Tooltips
  SetMainWinToolTips()
    
  CreateMainMenu()

  ; --------------- Change Combobox items -----------------
 ; Source of code examples
  a = GetGadgetState(#SearchSourceInput)   ; save current status before changing names (which will automatically reset state)
  SetGadgetItemText(#SearchSourceInput,0,Language$(13) ,0)   ; all
  SetGadgetItemText(#SearchSourceInput,1,Language$(14) ,0)   ; english forum
  SetGadgetItemText(#SearchSourceInput,2,Language$(15) ,0)   ; german forum
  SetGadgetItemText(#SearchSourceInput,3,Language$(119),0)   ; french forum
  SetGadgetItemText(#SearchSourceInput,4,Language$(16) ,0)   ; other
  SetGadgetState(#SearchSourceInput,a)     ; restore the saved status

  ; Setting date range
  a = GetGadgetState(#SearchDateRange)   ; save current status before changing names (which will automatically reset state)
  SetGadgetItemText(#SearchDateRange,0,Language$(215),0)   ; all
  For b=0 To 2
    SetGadgetItemText(#SearchDateRange,b,Language$(215+b),0)  
  Next
  SetGadgetState(#SearchDateRange,a)     ; restore the saved status
  
  ; Search for day
  a = GetGadgetState(#SearchDateDay)   ; save current status before changing names (which will automatically reset state)
  SetGadgetItemText(#SearchDateDay,0,Language$(13),0)   ; all
  ; following date items 1 till 31 don't need to be changed, because there are numerical values displayed
  SetGadgetState(#SearchDateDay,a)     ; restore the saved status

  ; Search for month
  a = GetGadgetState(#SearchDateMonth)   ; save current status before changing names (which will automatically reset state)
  SetGadgetItemText(#SearchDateMonth,0,Language$(13),0)   ; all
  For b=1 To 12
    SetGadgetItemText(#SearchDateMonth,b,Language$(16+b),0) 
  Next
  SetGadgetState(#SearchDateMonth,a)     ; restore the saved status

  ; Search for year
  a = GetGadgetState(#SearchDateYear)   ; save current status before changing names (which will automatically reset state)
  SetGadgetItemText(#SearchDateYear,0,Language$(13),0)   ; all
  SetGadgetState(#SearchDateYear,a)     ; restore the saved status

  ; *************** AUTHORs window ******************
  SetGadgetText(#AuthorWinFrame,Language$(43))
  SetGadgetText(#AuthorWinText ,Language$(44))
  SetGadgetText(#AuthorWinQuit ,Language$(34))

  ; *************** KEYWORDs window ******************
  SetGadgetText(#KeyWinFrame, Language$(30))    ; Title: Choose keyword to search:
  SetGadgetText(#KeyWinText1, Language$(31))    ; PB keywords
  SetGadgetText(#KeyWinText2, Language$(32))    ; PB commands
  SetGadgetText(#KeyWinText3, Language$(33))    ; ASM keywords
  SetGadgetText(#KeyWinText4, Language$(120))   ; PB constants
  SetGadgetText(#KeyWinText5, Language$(118))   ; WinAPI functions
  SetGadgetText(#KeyWinQuit,  Language$(34))    ; Cancel  
      
  ; *************** TopAUTHORs window ******************
  ; window title is changed every time, when the window is called, so we don't need to change the title here...
  ;If OpenWindow(#TopAuthorsWin,0,0,320,212,#PB_Window_SystemMenu|#PB_Window_ScreenCentered|#PB_Window_Invisible,Language$(title))

  ; 1st column "Place"
  SetGadgetItemAttribute(#TopAuthorList, -1, #PB_ListIcon_ColumnWidth, 50, 0)
  SetGadgetItemText(#TopAuthorList, -1, Language$(96), 0)  

  ; 2nd column "Author"
  SetGadgetItemAttribute(#TopAuthorList, -1, #PB_ListIcon_ColumnWidth, 170, 1)
  SetGadgetItemText(#TopAuthorList, -1, Language$(97), 1)  

  ; 3rd column "Codes"
  SetGadgetItemAttribute(#TopAuthorList, -1, #PB_ListIcon_ColumnWidth, 60, 2)
  SetGadgetItemText(#TopAuthorList, -1, Language$(98), 2)  

  SetGadgetText(#TopAuthorChoose, Language$(99))     ; Cancel  


  ; *************** PREFs window ******************
  ; Window title + Panel headlines
  SetWindowTitle(#PrefWin,"C.A.V. - "+Language$(64))
  SetGadgetItemText(#PrefPanel,0,Language$(159),0)
  SetGadgetItemText(#PrefPanel,1,Language$(160),0)
  SetGadgetItemText(#PrefPanel,2,Language$(188),0)
  SetGadgetItemText(#PrefPanel,3,Language$(228),0)
  SetGadgetItemText(#PrefPanel,4,Language$(161),0)
  ;- ****
  ; General
  SetGadgetText(#PrefLangText    ,Language$(73))
  SetGadgetText(#PrefSaveWinPos  ,Language$(77))
  SetGadgetText(#PrefAutoSave    ,Language$(80))
  SetGadgetText(#PrefAskSave     ,Language$(157))
  SetGadgetText(#PrefToolTips    ,Language$(165))
  SetGadgetText(#PrefToolTipMain ,Language$(142))
  SetGadgetText(#PrefFrame2      ,Language$(168))
  SetGadgetText(#PrefEditorText  ,Language$(67))
  SetGadgetText(#PrefEditorText2 ,Language$(169))
  ; Functions
  SetGadgetText(#PrefFrame3      ,Language$(81))   ; DirTree
  SetGadgetText(#PrefDirDesc     ,Language$(65))
  SetGadgetText(#PrefFileDesc    ,Language$(66))
  SetGadgetText(#PrefFrame4      ,Language$(82))    ; Search results
  SetGadgetText(#PrefReturnText  ,Language$(158))
  SetGadgetText(#PrefReturnHnd1  ,Language$(122))
  SetGadgetText(#PrefReturnHnd2  ,Language$(123))
  SetGadgetText(#PrefSearchOS    ,Language$(83))
  SetGadgetText(#PrefSearchDemo  ,Language$(84))
  SetGadgetText(#PrefSearchFileName, Language$(224))
  SetGadgetText(#PrefSearchDesc  ,Language$(66))
  ; Code-Viewer
  SetGadgetText(#PrefFrame5             ,Language$(193))   
  SetGadgetText(#PrefEditorBackColorText,Language$(194))
  SetGadgetText(#PrefFrame6             ,Language$(190))   
  SetGadgetText(#PrefSyntaxH            ,Language$(189))
  SetGadgetText(#PrefSyntaxH_Standard   ,Language$(199))
  SetGadgetText(#PrefSyntaxH_PBKeywords ,Language$(149))
  SetGadgetText(#PrefSyntaxH_PBCommmands,Language$(150))
  SetGadgetText(#PrefSyntaxH_ASMCommands,Language$(151))
  SetGadgetText(#PrefSyntaxH_Constants  ,Language$(191))
  SetGadgetText(#PrefSyntaxH_Comments   ,Language$(195))
  SetGadgetText(#PrefSyntaxH_SetStandard,Language$(192))
  ; Forum-Links
  SetGadgetText(#PrefFrame8,      Language$(229))
  SetGadgetText(#PrefForumsText1, Language$(230))
  SetGadgetText(#PrefForumsText2, Language$(231))
  SetGadgetText(#PrefForumsText3, Language$(232))
  SetGadgetText(#PrefForumsText4, Language$(233))
  ; Windows shortcuts
  SetGadgetText(#PrefShortcuts   ,Language$(162))
  SetGadgetText(#PrefDesktop     ,Language$(163))
  SetGadgetText(#PrefStartmenu   ,Language$(164))
  SetGadgetText(#PrefFrame7      ,Language$(222))
  SetGadgetText(#PrefBubbleHelp  ,Language$(221))
  ; Buttons
  SetGadgetText(#PrefSave        ,Language$(69))
  SetGadgetText(#PrefUse         ,Language$(70))
  SetGadgetText(#PrefCancel      ,Language$(71))
  
  
EndProcedure


Procedure ShowPrefs()
  HideWindow(#PrefWin, 0)
  StickyWindow(#PrefWin, 1)
  DisableWindow(#MainWindow, 1)
  SetActiveGadget(#PrefPanel)
  ;SetWindowPos_(WindowID(#PrefWin),#HWND_TOPMOST,0,0,0,0,#SWP_NOMOVE|#SWP_NOSIZE) 
  ;EnableWindow_(WindowID(#MainWindow), #False) 
  ;SetFocus_(GadgetID(#PrefPanel))
EndProcedure


Procedure HidePrefs()
  DisableWindow(#MainWindow, 0)  
  ;EnableWindow_(WindowID(#MainWindow), #True)
  HideWindow(#PrefWin, 1)
EndProcedure


Procedure CancelPrefs()
  HidePrefs()   ; first hide the preferences window
  ; now change back all strings/values in preferences window to its original state

;  RestoreTempPrefs()    
  SetPrefsSettings() 
EndProcedure


Procedure.l GetColor(image)
  Protected a
  ;UseImage(image)
  StartDrawing(ImageOutput(image))
    a = Point(10,10)
  StopDrawing()
  ProcedureReturn a  
EndProcedure


Procedure SetColor(gadget,image,color)
  CreateImage(image,20,20)
  StartDrawing(ImageOutput(image))
    Box(0,0,20,20,color)
  StopDrawing()
  SetGadgetState(gadget,ImageID(image))    ; update the ButtonImageGadget with new color
EndProcedure


Procedure SetStandardColors()
  SetColor(#PrefSyntaxH_StandColor,1,0)         ; Normal text color
  SetColor(#PrefSyntaxH_PBKeyColor,2,6710784)   ; PB Keywords
  SetColor(#PrefSyntaxH_PBComColor,3,6710784)   ; PB Commands/Functions
  SetColor(#PrefSyntaxH_PBAsmColor,4,7490450)   ; ASM commands
  SetColor(#PrefSyntaxH_PBConColor,5,7490450)   ; Constants
  SetColor(#PrefSyntaxH_PBComColor,6,11184640)  ; Comments
EndProcedure


; Following two procedures are by Danilo from codearchiv example ListIconColumn_Delete&Count.pb
; Procedure ListIcon_GetColumnCount(gadget) 
;   col.LV_COLUMN\mask = #LVCF_WIDTH 
;   Repeat 
;     a+1:x=SendMessage_(GadgetID(gadget),#LVM_GETCOLUMN,a,@col) 
;   Until x = 0 
;   ProcedureReturn a 
; EndProcedure 


; THE FOLLOWING 2 PROCEDURES ARE NOT NEEDED ANYMORE WHEN USING REMOVEGADGETCOLUMN() AND
; ANOTHER PREFS() CHECKING ROUTINE  (13th April 2007)
; Procedure ListIcon_DeleteColumn(gadget,item) 
;   ProcedureReturn SendMessage_(GadgetID(gadget),#LVM_DELETECOLUMN,item,0) 
; EndProcedure 
; 
; ; Following structure + procedure is from CodeArchiv example Get&SetListIconColumnText.pb
; Structure LVCOLUMN 
;   mask.l 
;   fmt.l 
;   cx.l 
;   pszText.s 
;   cchTextMax.l 
;   iSubItem.l 
;   iImage.l 
;   iOrder.l 
; EndStructure 
; 
; Procedure.s ListIcon_GetColumnText(Gadget,index) 
;   lvc.LVCOLUMN 
;   lvc\mask = #LVCF_TEXT 
;   lvc\pszText = Space(255) 
;   lvc\cchTextMax = 255 
;   SendMessage_(GadgetID(Gadget),#LVM_GETCOLUMN,index,@lvc) 
;   Result$=PeekS(Val(lvc\pszText))
;   ProcedureReturn Result$
; EndProcedure 


Procedure UsePrefs()
  Protected oldlang$, oldtooltip, olddirtranslation, oldfiletranslation, oldlistOS, oldlistDemo, oldlistDesc
  Protected a, b, updateListIcon, column
  
  oldlang$ = prefs$(0)
  oldtooltip = prefs(15)
  olddirtranslation = prefs(3)
  oldfiletranslation = prefs(4)
  oldlistOS   = prefs(5)
  oldlistDemo = prefs(6)
  oldlistDesc = prefs(7)
  
  prefs$(0) = GetGadgetText(#PrefLangChoose)     ; get and save name + state of the ...
;  prefs(0)  = GetGadgetState(#PrefLangChoose)    ; ... locale language ComboBox      *** not needed anymore ***
  prefs(0)  = GetGadgetState(#PrefSaveWinPos)    ; get status of "Save position of main window"
  prefs(8)  = GetGadgetState(#PrefAutoSave)
  prefs(14) = GetGadgetState(#PrefAskSave)
  prefs(15) = GetGadgetState(#PrefToolTips)
  prefs(16) = GetGadgetState(#PrefToolTipMain)
  prefs$(1) = GetGadgetText(#PrefEditorPath)     ; get path to the PB editor for using with CAV
  prefs$(4) = GetGadgetText(#PrefEditorPath2)    ; get path to the alternate editor for using with CAV
  prefs(3)  = GetGadgetState(#PrefDirDesc)       ; get status of "Show directory translation/description"
  prefs(4)  = GetGadgetState(#PrefFileDesc)      ; get status of "Show file translation/description"
  prefs(5)  = GetGadgetState(#PrefSearchOS)
  prefs(6)  = GetGadgetState(#PrefSearchDemo)
  prefs(35) = GetGadgetState(#PrefSearchFileName)
  prefs(7)  = GetGadgetState(#PrefSearchDesc)
  prefs(28) = GetGadgetState(#PrefBubbleHelp)

  prefs$(5) = GetGadgetText(#PrefForumsInput1)
  prefs$(6) = GetGadgetText(#PrefForumsInput2)
  prefs$(7) = GetGadgetText(#PrefForumsInput3)
  prefs$(8) = GetGadgetText(#PrefForumsInput4)
  
  If GetGadgetState(#PrefEditOriginal)
    prefs(17) = 1     ; use original PB editor
  Else
    prefs(17) = 0     ; use alternate editor
  EndIf
  If GetGadgetState(#PrefReturnHnd1)
    prefs(9) = 0
  Else
    prefs(9) = 1     ; #PrefReturnHnd2 is set  (use Return key only in fulltext-string for starting search
  EndIf
  If GetGadgetState(#PrefSyntaxH)
    prefs(18) = 1     ; activate syntax-highlighting in codeviewer
  Else
    prefs(18) = 0     ; deactivate syntax-highlighting 
  EndIf
  For a = 1 To 8      ; this are the image IDs: 1-6 for syntax highlighting, 7 for editor background, 8 for found search-terms
    prefs(a+18) = GetColor(a)  ; save the current colors from buttonimagegadgets; relating pref IDs are 19-26
  Next    
  CompilerIf #PB_Compiler_OS = #PB_OS_Windows
    SendMessage_(GadgetID(#EditorSource),#EM_SETBKGNDCOLOR,#Null,prefs(25))   ; set background color of the code viewer
  CompilerElse
    Debug "Setting BackgroundColor not supported on this OS!"
  CompilerEndIf
  
  HidePrefs()
  SetActiveWindow(#MainWindow)
  If prefs(0) = 1                                ; 1 = save current position of main window, 0 = not
    prefs(1)  = WindowX(#MainWindow)
    prefs(2)  = WindowY(#MainWindow)
  EndIf

  updateListIcon = #False
  If prefs$(0) <> oldlang$    ; language has changed
    SetLanguage()
    ChangeGUILanguage()
    If ResultMode = 2    ; ListIcon with searchresults is shown...
      updateListIcon = #True
    EndIf
  EndIf
  If (prefs(3) <> olddirtranslation) Or (prefs$(0) <> oldlang$) Or (prefs(4) <> oldfiletranslation)
    ; Update TreeGadget (just fill it again) because of the additional descriptions
    FillTree()
  EndIf
  
  If prefs(5) <> oldlistOS     ; there was something changed in the ListIcon settings for showing/not showing the OS compatibility
    If prefs(5) = 0   ; don't show OS compatibility anymore
      RemoveGadgetColumn(#ResultList, 2)
    Else              ; we must show now the OS column again
      updateListIcon = #True
    EndIf
  EndIf

  If prefs(6) <> oldlistDemo     ; there was something changed in the ListIcon settings for showing/not showing the Demo compatibility
    If prefs(6) = 0   ; don't show Demo compatibility anymore
      If prefs(5) = 1   ; OS is still existing
        RemoveGadgetColumn(#ResultList, 3)
      Else
        RemoveGadgetColumn(#ResultList, 2)
      EndIf
    Else              ; we must show now the Demo column again
      updateListIcon = #True
    EndIf
  EndIf

  If prefs(7) <> oldlistDesc     ; there was something changed in the ListIcon settings for showing/not showing the Demo compatibility
    If prefs(7) = 0   ; don't show description anymore
      If prefs(5) = 1 And prefs(6) = 1  ; OS and Demo are still existing
        RemoveGadgetColumn(#ResultList, 4)
      ElseIf prefs(5) = 1 Or prefs(6) = 1   ; OS or Demo are existing
        RemoveGadgetColumn(#ResultList, 3)
      Else 
        RemoveGadgetColumn(#ResultList, 2)
      EndIf
    Else              ; we must show now the Demo column again
      updateListIcon = #True
    EndIf
  EndIf

  If updateListIcon = #True
    ;Debug "Before deleting...."
    ;For a = 0 To 8
    ;  Debug "Column="+Str(a)
    ;  Debug ListIcon_GetColumnText(#ResultList,a)
    ;Next
    ;b = ListIcon_GetColumnCount(#ResultList)
    ;Debug b
    
;    For a = 2 To b-1
;      ListIcon_DeleteColumn(#ResultList, a)     ; delete all columns for a completely refresh
;    Next
    
    
    FreeGadget(#ResultList)
    UseGadgetList(WindowID(#MainWindow))
    If prefs(7) = 0      ; no description should be displayed, so we have space to expand 'name' and 'dir' width
      a = 170    ; expanded 'name' size  (1st column)
      b = 170    ; expanded 'dir' size  (2nd column)
    Else 
      a = 130    ; normal 'name' size
      b = 110    ; normal 'dir' size
    EndIf
    ListIconGadget(#ResultList, 30, 190, 490, 380, Language$(59), a, #PB_ListIcon_FullRowSelect|#PB_ListIcon_AlwaysShowSelection)  ; ListIcon for displaying the search results
    AddGadgetColumn(#ResultList,1,Language$(79),b)                  ; Dir(s)
    column = 2
    If prefs(5) = 1 
      AddGadgetColumn(#ResultList,column,Language$(61),55)                   ; OS
      column + 1
    EndIf
    If prefs(6) = 1 
      AddGadgetColumn(#ResultList,column,Language$(62),45)                   ; Demo
      column + 1
    EndIf
    If prefs(7) = 1 
      AddGadgetColumn(#ResultList,column,Language$(60),250)                  ; Description
    EndIf

;     Debug "After re-creating...."
;     For a = 0 To 8
;       Debug "Column="+Str(a)
;       Debug ListIcon_GetColumnText(#ResultList,a)
;     Next
    
;    If ListIcon_GetColumnCount(#ResultList) > 5    ; there are too much columns   (a workaround for a bug)
;      Debug "Too much!"
;    EndIf

    ; the search function must be called again here, but we are in a procedure
    ; so we return a special value to indicate, that search function must be called again in the main program
  EndIf
  
  SetMainWinToolTips()
  
  If updateListIcon = #True
    ProcedureReturn 1
  Else
    ProcedureReturn 0
  EndIf
EndProcedure



Procedure SavePrefs()
  SetActiveWindow(#MainWindow)
  If prefs(0) = 1                                ; 1 = save current position of main window, 0 = not
    prefs(1)  = WindowX(#MainWindow)
    prefs(2)  = WindowY(#MainWindow)
  EndIf

  prefs(10) = GetGadgetState(#SearchSourceInput)
  prefs$(2) = GetGadgetText(#SearchAuthorInput)
  prefs(11) = GetGadgetState(#SearchDateDay)
  prefs(12) = GetGadgetState(#SearchDateMonth)
  prefs(13) = GetGadgetState(#SearchDateYear)
  prefs$(3) = GetGadgetText(#SearchFullInput)


  If CreatePreferences(prefspath$+"CAV.prefs")
    PreferenceComment(" CAV Preferences File")
    PreferenceComment("")
    WritePreferenceLong("PreferenceVersion", 1)
    PreferenceComment("")
    PreferenceGroup("General")
      WritePreferenceLong("SaveWindowPos"         , prefs(0))
      WritePreferenceLong("WindowX"               , prefs(1))
      WritePreferenceLong("WindowY"               , prefs(2))
      WritePreferenceLong("AutoSavePrefs"         , prefs(8))
      WritePreferenceLong("AskSavePrefs"          , prefs(14))
      WritePreferenceLong("ShowToolTipps"         , prefs(15))
      WritePreferenceLong("NoMainToolTipps"       , prefs(16))
      WritePreferenceLong("OnlyDemoCompatibleCodes",prefs(36))

    PreferenceComment("")
    PreferenceGroup("Language")
      WritePreferenceString("CurrentLanguage"     , prefs$(0))
;      WritePreferenceLong  ("CurrentLanguageState" , prefs(1))

    PreferenceComment("")
    PreferenceGroup("CodeViewer")
      WritePreferenceLong  ("EditorBackgroundColor"         , prefs(25))
      WritePreferenceLong  ("SearchTermBackgroundColor"     , prefs(26))
      WritePreferenceLong  ("UseSyntaxHighlighting"         , prefs(18))
      WritePreferenceLong  ("SyntaxHighlight_Standard"      , prefs(19))
      WritePreferenceLong  ("SyntaxHighlight_PBKeywords"    , prefs(20))
      WritePreferenceLong  ("SyntaxHighlight_PBFunctions"   , prefs(21))
      WritePreferenceLong  ("SyntaxHighlight_ASMCommands"   , prefs(22))
      WritePreferenceLong  ("SyntaxHighlight_Constants"     , prefs(23))
      WritePreferenceLong  ("SyntaxHighlight_Comments"      , prefs(24))

    PreferenceComment("")
    PreferenceGroup("Windows")
      WritePreferenceLong  ("UseBubbleHelp"       , prefs(28))

    PreferenceComment("")
    PreferenceGroup("External")
      WritePreferenceLong  ("UsePureBasicIDE"     , prefs(17))
      WritePreferenceString("EditorPath"          , prefs$(1))
      WritePreferenceString("EditorPathAlternate" , prefs$(4))

    PreferenceComment("")
    PreferenceGroup("FileTreeSettings")
      WritePreferenceLong  ("ShowDirDescription"  , prefs(3))
      WritePreferenceLong  ("ShowFileDescription" , prefs(4))

    PreferenceComment("")
    PreferenceGroup("SearchInputSettings")
      WritePreferenceLong  ("ReturnHandler"       , prefs(9))
      WritePreferenceLong  ("SearchForum"         , prefs(10))
      WritePreferenceString("SearchAuthor"        , prefs$(2))
      WritePreferenceLong  ("SeachDateRange"      , prefs(34))
      WritePreferenceLong  ("SeachDay"            , prefs(11))
      WritePreferenceLong  ("SeachMonth"          , prefs(12))
      WritePreferenceLong  ("SeachYear"           , prefs(13))
      WritePreferenceString("SearchFullText"      , prefs$(3))

    PreferenceComment("")
    PreferenceGroup("SearchResultSettings")
      WritePreferenceLong  ("SearchOS"            , prefs(5))
      WritePreferenceLong  ("SearchDemo"          , prefs(6))
      WritePreferenceLong  ("SearchFileNames"     , prefs(35))
      WritePreferenceLong  ("ShowDesc"            , prefs(7))

    PreferenceComment("")
    PreferenceGroup("CodeTesterSettings")
      WritePreferenceLong  ("CompileRun"          , prefs(29))
      WritePreferenceLong  ("WaitForEnd"          , prefs(30))
      WritePreferenceLong  ("EnableDebugger"      , prefs(31))
      WritePreferenceLong  ("EnableInlineASM"     , prefs(32))
      WritePreferenceLong  ("StartFromHere"       , prefs(33))

    PreferenceComment("")
    PreferenceGroup("ForumLinks")
      WritePreferenceString("ForumEnglish"        , prefs$(5))
      WritePreferenceString("ForumGerman"         , prefs$(6))
      WritePreferenceString("ForumFrench"         , prefs$(7))
      WritePreferenceString("ForumLounge"         , prefs$(8))

    ClosePreferences()
    prefssaved = #True
  Else
    CompilerIf #PB_Compiler_OS = #PB_OS_Windows
      MessageRequester(Language$(74),Language$(124),#MB_ICONERROR)    ; Saving of prefs file failed!
    CompilerElse
      MessageRequester(Language$(74),Language$(124))    ; Saving of prefs file failed!
    CompilerEndIf
  EndIf

;       WritePreferenceString("SourceDirectory"   , SourceDirectory)
;       WritePreferenceString("CurrentFileName"   , FileList()\FileName$)
;       WritePreferenceLong  ("AutoSave"          , AutoSave)
;       WritePreferenceLong  ("IsWindowMaximized" , IsWindowMaximized)
;       WritePreferenceLong  ("RunOnce"           , Editor_RunOnce)
;       WritePreferenceLong  ("ShowToolbar"       , ShowMainToolbar)
;       WritePreferenceLong  ("TabLength"         , TabLength)
; 
;       
; 
;    PreferenceComment("")
;    PreferenceGroup("OpenedFiles")
;       
;       OpenedFilesCount = 0
;       
;       CurrentIndex = ListIndex(FileList()) ; Save the current index, as it will changed and need to be restored
;       
;       ForEach FileList()
;         If OpenedFilesCount < #OPENEDFILES_Maximum And FileList()\FileName$ ; Test needed because a '< New >' file doesn't have a name and can't be reopened
;           OpenedFilesCount + 1
;           WritePreferenceString("OpenedFile_"+Str(OpenedFilesCount), FileList()\FileName$)
;         EndIf
;       Next
;       
;       SelectElement(FileList(), CurrentIndex) ; Restore the current list element
;       
;       WritePreferenceLong("Count", OpenedFilesCount)
; 
; 

EndProcedure


Procedure CheckBoxGadgetState(gadget,relatedgadget)
  ; currently used for checking the prefs gadgets: AutoSave + ToolTipps display
  Protected a
  If GetGadgetState(gadget) = 0     ; .... disabled
    a = 1    ; then also disable the following question
  Else
    a = 0
  EndIf
  DisableGadget(relatedgadget,a)
EndProcedure


Procedure SetActiveEditor()
  ; editor = 1  then use original editor, else use alternate editor
  Protected a, b
  If GetGadgetState(#PrefEditOriginal) = 1     ; original editor is set
    a = 0     
    b = 1    ; disable alternate editor gadgets
  Else                                         ; alternate editor is set, disable all PB-IDE related gadgets
    a = 1    ; disable PB editor gadgets
    b = 0
  EndIf
  DisableGadget(#PrefEditorText,a)
  DisableGadget(#PrefEditorPath,a)
  DisableGadget(#PrefEditorSelect,a)
  DisableGadget(#PrefEditorText2,b)
  DisableGadget(#PrefEditorPath2,b)
  DisableGadget(#PrefEditorSelect2,b)
EndProcedure


Procedure SetSyntaxHighlightingColors()
  Protected a
  ; prefs(18) = 1  then syntax-highlighting is used, else not (and so deactivate the color gadgets)
  If GetGadgetState(#PrefSyntaxH) = 1     ; syntax-highlighting is on
    a = 0    ; activate coloring gadgets  
  Else 
    a = 1    ; de-activate coloring gadgets
  EndIf
  DisableGadget(#PrefSyntaxH_StandColor ,a)
  DisableGadget(#PrefSyntaxH_Standard   ,a)
  DisableGadget(#PrefSyntaxH_PBKeyColor ,a)
  DisableGadget(#PrefSyntaxH_PBKeywords ,a)
  DisableGadget(#PrefSyntaxH_PBComColor ,a)
  DisableGadget(#PrefSyntaxH_PBCommmands,a)
  DisableGadget(#PrefSyntaxH_PBAsmColor ,a)
  DisableGadget(#PrefSyntaxH_ASMCommands,a)
  DisableGadget(#PrefSyntaxH_PBConColor ,a)
  DisableGadget(#PrefSyntaxH_Constants  ,a)  
  DisableGadget(#PrefSyntaxH_ComColor ,a)
  DisableGadget(#PrefSyntaxH_Comments   ,a)  
  DisableGadget(#PrefSyntaxH_SetStandard,a)
EndProcedure


Procedure GetEditorPath(gadget)
  Protected a$
  a$ = GetGadgetText(gadget)
  a$ = OpenFileRequester(Language$(72),a$,"Exe (*.exe)|*.exe|Alle Dateien (*.*)|*.*",0)
  If a$ 
    SetGadgetText(gadget,a$)
  EndIf
EndProcedure


; Procedure CreateDesktopShortcut(FullPathName$)
; 
; MessageRequester("",FullPathName$)
; 
;   DesktopBuffer.l=0
;   DesktopFolder$=Space(255)
;   SHGetSpecialFolderLocation_(0, 16, @DesktopBuffer)
;   SHGetPathFromIDList_(DesktopBuffer, @DesktopFolder$)
; 
;   RecentBuffer.l=0
;   RecentFolder$=Space(255)
;   SHGetSpecialFolderLocation_(0, 8, @RecentBuffer)
;   SHGetPathFromIDList_(RecentBuffer, @RecentFolder$)
; 
;   Result=SHAddToRecentDocs_(2,FullPathName$)
;   FileName$=GetFilePart(FullPathName$)
;   SourceFile$=RecentFolder$+"\"+FileName$+".lnk"
; 
; MessageRequester("",SourceFile$)  
;   
;   FileNameLenght=Len(FileName$)
;   TargetFile$=DesktopFolder$+"\"+Left(FileName$,FileNameLenght-4)+".lnk"
;   Delay(1000)  ; give Windows time to work, otherwise you can't copy the file... 
;   Result=CopyFile(SourceFile$,TargetFile$)
;   If Result
;     DeleteFile(SourceFile$)
;   Else
;     MessageRequester("Copy File",Str(Result)+" No file copied",0)
;   EndIf
;   ; well if the shortcut don't show up... we force a desktop refresh!
;   PostMessage_(FindWindow_("ProgMan",0),$0100,$74,0)
; EndProcedure
; 


; ********************************************************************************
; Following code snippets are taken from "TS-ShutDown" sourcecode
; ********************************************************************************

#CSIDL_DESKTOP   =  0
#CSIDL_STARTUP   =  7
#CSIDL_APPDATA   = 26

Structure EMID
  cb.b
  abID.b[1]
EndStructure

; Structure ITEMIDLIST
;   mkid.EMID
; EndStructure

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  Procedure.s GetFullPath()
    FullPath.s = Space(#MAX_PATH)
    GetModuleFileName_(GetModuleHandle_(0), @FullPath, #MAX_PATH)
    FullPath = GetPathPart(FullPath)
    If Right(FullPath, 1) <> "\"
      FullPath = FullPath + "\"
    EndIf
    ProcedureReturn FullPath
  EndProcedure
CompilerEndIf

Procedure.l mFileExists(Filename.s)
  Protected Result
  Result = #True
  If FileSize(Filename) = -1
    Result = #False
  EndIf
  ProcedureReturn Result
EndProcedure

; Procedure.s GetUserName()
;   nSize.l = 255
;   lpBuffer.s = Space(255)
;   GetUserName_(@lpBuffer, @nSize)
;   If Trim(lpBuffer) = ""
;     ; lpBuffer = "Benutzer"
;     lpBuffer = Language$(167)     ; use localized version for working on different localized Windows versions
;   EndIf
;   ProcedureReturn Trim(lpBuffer)
; EndProcedure
; 

CompilerIf #PB_Compiler_OS = #PB_OS_Windows
  Procedure.s myGetSpecialeFolder(Folder.l)
    *itemid.ITEMIDLIST = #Null
    If SHGetSpecialFolderLocation_ (0, Folder, @*itemid) = #NOERROR
      location.s = Space (#MAX_PATH)
      If SHGetPathFromIDList_ (*itemid, @location)
        If Right(location, 1) <> "\" : location + "\" : EndIf
        ProcedureReturn location
      EndIf
    EndIf
  EndProcedure
  
  Procedure myCreateShortcut(Path.s, Link.s, WorkingDir.s, Argument.s, IconFile.s, IconIndex.l)
    ShowCommand = #SW_SHOWNORMAL
    Description.s = ""
    HotKey = #Null
    CoInitialize_(0)
    If CoCreateInstance_(?CLSID_ShellLink,0,1,?IID_IShellLink,@psl.IShellLinkA) = 0
      Set_ShellLink_preferences:
      psl\SetPath(@Path)
      psl\SetArguments(@Argument)
      psl\SetWorkingDirectory(@WorkingDir)
      psl\SetDescription(@Description)
      psl\SetShowCmd(ShowCommand)
      psl\SetHotkey(HotKey)
      psl\SetIconLocation(@IconFile, IconIndex)
      ShellLink_SAVE:
      If psl\QueryInterface(?IID_IPersistFile,@ppf.IPersistFile) = 0
        mem.s = Space(1000)
        MultiByteToWideChar_(#CP_ACP, 0, Link, -1, mem, 1000)
        hres = ppf\Save(@mem,#True)
        Result = 1
        ppf\Release()
      EndIf
      psl\Release()
    EndIf
    CoUninitialize_()
    ProcedureReturn Result
    DataSection
    CLSID_ShellLink:
    Data.l $00021401
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    IID_IShellLink:
    Data.l $000214EE
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    IID_IPersistFile:
    Data.l $0000010B
    Data.w $0000,$0000
    Data.b $C0,$00,$00,$00,$00,$00,$00,$46
    EndDataSection
  EndProcedure
  
  ; Example:
  ; myCreateShortcut(GetFullPath() + "TS-Shutdown.exe", myGetSpecialeFolder(#CSIDL_DESKTOP) + "Computer neustarten.lnk", "TS-Shutdown", "/r",GetFullPath() + "TS-Shutdown.exe", 3)
  
  ; ********************************************************************************
CompilerEndIf
; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 746
; FirstLine = 705
; Folding = -----
; EnableXP
; UseMainFile = CodeArchivViewer_Main.pb
; DisableDebugger